unit MasterUnit ;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, CommCtrl, Gauges,
  MMSystem, dsound ;

const
  MaxWave = 10240       ;
  Max     = MaxWave - 1 ;
type
  TMasterForm = class(TForm)
    OpenDialog1    : TOpenDialog ;
    New            : TButton     ;
    MasterMute     : TButton     ;
    PanL           : TLabel      ;
    PanE           : TEdit       ;
    PanF           : TTrackBar   ;
    VolumeL        : TLabel      ;
    VolumeLP       : TPanel      ;
    VolumeP        : TPanel      ;
    VolumeWaveL    : TLabel      ;
    VolumeWaveE    : TEdit       ;
    VolumeWaveF    : TTrackBar   ;
    VolumeSpeakerL : TLabel      ;
    VolumeSpeakerE : TEdit       ;
    VolumeSpeakerF : TTrackBar   ;
    EQL            : TLabel      ;
    EQLP           : TPanel      ;
    EQP            : TPanel      ;
    EQLoL          : TLabel      ;
    EQLoE          : TEdit       ;
    EQLoF          : TTrackBar   ;
    EQHiL          : TLabel      ;
    EQHiE          : TEdit       ;
    EQHiF          : TTrackBar   ;
    MeterL         : TLabel      ;
    MeterLP        : TPanel      ;
    MaterP         : TPanel      ;
    MeterLL        : TLabel      ;
    MeterLE        : TEdit       ;
    MeterLG        : TGauge      ;
    MeterRL        : TLabel      ;
    MeterRE        : TEdit       ;
    MeterRG        : TGauge      ;
    MeterT         : TTimer      ;
    procedure FormCreate(Sender : TObject) ;
    procedure FormClose(Sender : TObject ; var Action : TCloseAction) ;
    procedure NewClick(Sender : TObject) ;
    procedure VolumeSpeakerFChange(Sender : TObject) ;
    procedure VolumeSpeakerEChange(Sender : TObject) ;
    procedure PanFChange(Sender : TObject) ;
    procedure PanEChange(Sender : TObject) ;
    procedure EQLoFChange(Sender : TObject) ;
    procedure EQLoEChange(Sender : TObject) ;
    procedure EQHiFChange(Sender : TObject) ;
    procedure EQHiEChange(Sender : TObject) ;
    procedure VolumeWaveFChange(Sender : TObject) ;
    procedure VolumeWaveEChange(Sender : TObject) ;
    procedure MasterMuteKeyDown(Sender : TObject ; var Key : Word ;
      Shift : TShiftState) ;
    procedure MasterMuteKeyUp(Sender : TObject ; var Key : Word ;
      Shift : TShiftState) ;
    procedure MasterMuteKeyPress(Sender : TObject ; var Key : Char) ;
    procedure MasterMuteMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure MasterMuteMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure MeterTTimer(Sender : TObject) ;
  private
    { Private declarations }
    procedure MixerCallBack
      (var Msg : TMessage) ; Message MM_MIXM_CONTROL_CHANGE ;
    procedure MasterDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
    procedure ApplicationActivate(Sender : TObject) ;
    procedure ApplicationDeactivate(Sender : TObject) ;
  public
    { Public declarations }
  end ;

var
  MasterForm : TMasterForm                          ;
  DS         : IDirectSound                         ;
  DS1stB     : IDirectSoundBuffer                   ;
  DS2ndB     : array[0.. Max] of IDirectSoundBuffer ;
  WF         : TWaveFormatEX                        ;
  ModuleList : TList                                ;
  ModuleID   : Integer                              ;
  FPFN       : String                               ;
  FN         : String                               ;
  WaveSize   : DWORD                                ;
  WaveSizeM  : array [0.. Max] of DWORD             ;
  WaveTime   : DWORD                                ;
  WaveTimeM  : array [0.. Max] of DWORD             ;
  HM         : HMIXER                               ;
  MCP        : TMixerCaps                           ;
  ML_D_S     : TMixerLine                           ;
  ML_C_W     : TMixerLine                           ;
  MLC        : TMixerLineControls                   ;
  MCL        : TMixerControl                        ;
  MCD        : TMixerControlDetails                 ;
  PanLR      : array [0.. 1024] of DWORD            ;
  PanLeft    : DWORD                                ;
  PanRight   : DWORD                                ;
  PanPos     : Integer                              ;
  VolPos     : DWORD                                ;
  PanMax     : DWORD                                ;
  Bass       : DWORD                                ;
  Treble     : DWORD                                ;
  VolumeWave : DWORD                                ;
  Mute       : Boolean                              ;
  MeterLR    : array [0.. 1024] of DWORD            ;
  MeterLeft  : DWORD                                ;
  MeterRight : DWORD                                ;
  MasterActivateFlag : DWORD                        ;

  procedure LoadWave(var FPFN : String ; var ModuleBuf : Integer) ;

implementation

uses
  ModuleUnit ;

{$R *.DFM}

//*********************************************************************
//  [ Initialize ]
//*********************************************************************
procedure TMasterForm.FormCreate(Sender : TObject) ;
var
  TBS  : DWORD        ;
  DSBD : DSBufferDesc ;
  C    : Integer      ;
begin
  //  [ Active ]
  Application.OnActivate := ApplicationActivate ;
  Application.OnDeactivate := ApplicationDeactivate ;
  //  [ DragDrop ]
  Application.OnMessage := MasterDropMsg ;
  DragAcceptFiles(MasterForm.Handle, True) ;
  //  [ TrackBar - TBS_ENABLESELRANGE ]
  TBS := GetWindowLong(VolumeWaveF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeWaveF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(VolumeSpeakerF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeSpeakerF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PanF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PanF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(EQLoF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(EQLoF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(EQHiF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(EQHiF.Handle, GWL_STYLE, TBS) ;
  //  [ Initialize ]
  ModuleID  := 0      ;
  FPFN      := 'None' ;
  FN        := 'None' ;
{
********************************************
  [ DirectSound ]
********************************************
}
  //  [ Constructor ]
  DirectSoundCreate(Nil, DS, Nil) ;
  //  [ CooperativeLevel ]
  DS.SetCooperativeLevel(Handle, DSSCL_EXCLUSIVE) ;
  //  [ DSBUFFERDESC structure ]
  Zeromemory(@DSBD, Sizeof(DSBufferDesc)) ;
  with DSBD do
    begin
      dwSize := Sizeof(DSBufferDesc) ;
      dwFlags :=
          DSBCAPS_PRIMARYBUFFER
        + DSBCAPS_STATIC
        + DSBCAPS_CTRLFREQUENCY
        + DSBCAPS_CTRLPAN
        + DSBCAPS_CTRLVOLUME
        + DSBCAPS_GLOBALFOCUS
        + DSBCAPS_STICKYFOCUS ;
    end ;
  //  [ PrimaryBuffer ]
  DS.CreateSoundBuffer(@DSBD, DS1stB, nil) ;
  //  [ SecondaryBuffer ]
  for C := 0 to Max do begin DS2ndB[C] := nil ; end ;
{
********************************************
  [ AudioMixer ]
********************************************
}
  if mixerGetNumDevs = 0 then Exit ;
  //  ID = 0
  mixerGetDevCaps(0, @MCP, Sizeof(MCP)) ;
  //  ID = 0
  mixerOpen(@HM, 0, Handle, Integer(Self), CALLBACK_WINDOW
                                         + MIXER_OBJECTF_MIXER) ;
{
  [ DestinationLine - Speaker ]
}
  //  ID = 0
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
  [ VolumeControl and PanControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := ML_D_S.cChannels                     ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @PanLR                               ;
  end ;
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
  if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
  if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
  PanLeft  := PanLR[0] ;
  PanRight := PanLR[1] ;
  if PanLeft = PanRight then
    if PanLeft = 0 then
      begin
        VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;
        VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;
      end else
      begin
        PanF.Position := 0 ;
        PanE.Text := IntToStr(0) ;
        VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;
        VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;
      end ;
  if PanLeft > PanRight then
    begin
      if PanRight = 0 then
        begin
          PanF.Position := -65535 ;
          PanE.Text := IntToStr(-65535) ;
          VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;
        end ;
      if PanRight <> 0 then
        begin
          PanF.Position :=
            (65535 - (((655350000 div PanLeft) * PanRight) div 10000))
                                                               * (- 1) ;
          PanE.Text := IntToStr(PanF.Position) ;
          VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;
        end ;
    end ;
  if PanLeft < PanRight then
    begin
      if PanLeft = 0 then
        begin
          PanF.Position := 65535 ;
          PanE.Text := IntToStr(65535) ;
          VolumeSpeakerF.Position := Integer(PanRight) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight))        ;
        end ;
      if PanLeft <> 0 then
        begin
          PanF.Position :=
            (65535 - (((655350000 div PanRight) * PanLeft) div 10000))
                                                               * (+ 1) ;
          PanE.Text := IntToStr(PanF.Position) ;
          VolumeSpeakerF.Position := Integer(PanRight) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight))        ;
        end ;
    end ;
{
  [ BassControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Bass                                ;
  end ;
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  EQLoF.Position := Integer(Bass) * - 1 + 32768 ;
  EQLoE.Text := IntToStr(Integer(Bass) - 32768) ;
{
  [  TrebleControl]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Treble                              ;
  end ;
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  EQHiF.Position := Integer(Treble) * - 1 + 32768 ;
  EQHiE.Text := IntToStr(Integer(Treble) - 32768) ;
{
  [ ConnectionLine - Wave ]
}
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
  [ VolumeControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @VolumeWave                       ;
  end ;
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  VolumeWaveF.Position := Integer(VolumeWave) * -1 + 65535 ;
  VolumeWaveE.Text := IntToStr(Integer(VolumeWave))        ;
end ;

//*********************************************************************
//  [ Close ]
//*********************************************************************
procedure TMasterForm.FormClose(Sender : TObject ; var Action : TCloseAction) ;
var
  C    : Integer      ;
begin
{
********************************************
  [ AudioMixer ]
********************************************
}
  mixerClose(HM) ;
{
********************************************
  [ DirectSound ]
********************************************
}
  //  [ SecondaryBuffer ]
  for C := 0 to Max do
    begin
      if DS2ndB[C] <> nil then
        begin
          DS2ndB[C].Release ;
          DS2ndB[C] := nil ;
        end;
    end;
  //  [ PrimaryBuffer ]
  if DS1stB <> nil then
    begin
      DS1stB.Release ;
      DS1stB := nil ;
    end;
  //  [ DirectSoundObject ]
  if DS <> nil then
    begin
      DS.Release ;
      DS := nil ;
    end ;
end ;

{
*********************************************************************
[ LoadRoutine ]
*********************************************************************
}
procedure LoadWave(var FPFN : String ; var ModuleBuf : Integer) ;
var
  F         : TFileStream          ;
  DSBD      : DSBufferDesc         ;
  FCheck4B  : array[0.. 3] of Char ;
  FCheck3B  : array[0.. 2] of Char ;
  WaveBuf1  : Pointer              ;
  WaveBuf2  : Pointer              ;
  WaveSize1 : DWORD                ;
  WaveSize2 : DWORD                ;
begin
  F := TFileStream.Create(FPFN, fmOpenRead) ;
  //  [ DSBUFFERDESC structure ]
  Zeromemory(@DSBD, Sizeof(DSBufferDesc)) ;
  with DSBD do
    begin
      dwSize := Sizeof(DSBufferDesc) ;
      dwFlags :=
          DSBCAPS_STATIC
        + DSBCAPS_CTRLFREQUENCY
        + DSBCAPS_CTRLPAN
        + DSBCAPS_CTRLVOLUME
        + DSBCAPS_GLOBALFOCUS
        + DSBCAPS_STICKYFOCUS ;
      //  [ RIFF CHUNK ]
      F.Position := 0 ;
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;
      if String(FCheck4B) <> 'RIFF' then     //  RIFF ??
        begin F.Free ; Exit ; end ;
      F.Seek(4, 1) ;
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;
      if String(FCheck4B) <> 'WAVE' then     //  WAVE ??
        begin F.Free ; Exit ; end ;
      F.Read(FCheck3B, Sizeof(FCheck3B)) ;
      if String(FCheck3B) <> 'fmt' then      //  fmt ??
        begin F.Free ; Exit ; end ;
      F.Seek(5, 1) ;
      F.Read(WF, 16) ;
      lpwfxFormat := @WF ;
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;
      if String(FCheck4B) <> 'data' then     //  data ??
        begin F.Free ; Exit ; end ;
      F.Read(dwBufferBytes, Sizeof(DWORD)) ;
      F.Position := 0 ;
      F.Seek(40, 1) ;
      F.Read(WaveSize, Sizeof(DWORD)) ;
    end;
  //  [ SecondaryBufferInitialize ]
  if DS2ndB[ModuleBuf] <> nil then
    begin
      DS2ndB[ModuleBuf].Release ;
      DS2ndB[ModuleBuf] := nil ;
    end;
  //  [ SecondaryBufferCreate ]
  DS.CreateSoundBuffer(@DSBD, DS2ndB[ModuleBuf], nil) ;
  //  [ Lock ]
  DS2ndB[ModuleBuf].Lock
    (0, DSBD.dwBufferBytes, WaveBuf1, @WaveSize1, WaveBuf2, @WaveSize2, 0) ;
  //  [ Read ]
  F.Position := 44 ;
  F.Read(WaveBuf1^, WaveSize1) ;
  if WaveSize2 <> 0 then
    begin
      F.Read(WaveBuf2^, WaveSize2) ;
    end ;
  //  [ Unlock ]
  DS2ndB[ModuleBuf].Unlock
    (WaveBuf1, WaveSize1, WaveBuf2, WaveSize2) ;
  F.Free ;
end ;

//  [ NewModuleCreate ]
procedure TMasterForm.NewClick(Sender : TObject) ;
begin
  if OpenDialog1.Execute then
    begin
      FPFN := OpenDialog1.FileName ;
      FN := ExtractFileName(FPFN) ;
      ModuleList.Add(TModuleForm.Create(Self)) ;
      LoadWave(FPFN, ModuleID) ;
      WaveSizeM[ModuleID] := WaveSize ;
      WaveTimeM[ModuleID] :=
          WaveSizeM[ModuleID] div 1764 * 10 ;
      TModuleForm(ModuleList[ModuleID]).Caption := FN ;
      TModuleForm(ModuleList[ModuleID]).TimeE.Text :=
                        IntToStr(WaveTimeM[ModuleID]) ;
      TModuleForm(ModuleList[ModuleID]).Show ;
      Inc(ModuleID) ;
    end else
      Exit ;
end ;

//  [ DestinationLine - SpeakerVolumeFader ]
procedure TMasterForm.VolumeSpeakerFChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then
    begin
      Exit ;
    end ;
  if MasterActivateFlag = 1 then
    begin
      VolumeSpeakerE.Text :=
        IntToStr(VolumeSpeakerF.Position * -1 + 65535) ;
      VolPos := VolumeSpeakerF.Position * -1 + 65535 ;
      PanPos := PanF.Position ;
      if PanPos = 0 then
        begin
          PanLR[0] := VolPos ;
          PanLR[1] := VolPos ;
        end ;
      if PanPos < 0 then
        begin
          PanLR[0] := VolPos ;
          PanLR[1] := (VolPos div 2) * (65535 - PanPos * (- 1)) div 65535 * 2 ;
        end ;
      if PanPos > 0 then
        begin
          PanLR[0] := (VolPos div 2) * (65535 - PanPos) div 65535 * 2 ;
          PanLR[1] := VolPos ;
        end ;

      with ML_D_S do begin
        cbStruct        := Sizeof(TMixerLine)                   ;
        dwDestination   := 0                                    ;
        dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
      end ;
      mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                  + MIXER_OBJECTF_HMIXER) ;
      with MLC do begin
        cbStruct      := Sizeof(TMixerLineControls)      ;
        dwLineID      := ML_D_S.dwLineID                 ;
        dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
        cControls     := ML_D_S.cControls                ;
        cbmxctrl      := Sizeof(TMixerControl)           ;
        pamxctrl      := @MCL                            ;
      end ;
      with MCL do begin
        cbStruct   := Sizeof(TMixerControl)         ;
        fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
      end ;
      mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                   + MIXER_OBJECTF_HMIXER) ;
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_SETCONTROLDETAILSF_VALUE) ;
      if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
      if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
      if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      PanF.Position := PanPos ;
    end ;
end ;

//  [ DestinationLine - SpeakerVolumeEdit ]
procedure TMasterForm.VolumeSpeakerEChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then
    begin
      Exit ;
    end ;
  if MasterActivateFlag = 1 then
    begin
      try StrToInt(VolumeSpeakerE.Text) ; except Exit ; end ;
      if StrToInt(VolumeSpeakerE.Text) > 65535 then
        VolumeSpeakerE.Text := '65535' ;
      if StrToInt(VolumeSpeakerE.Text) < 0 then
        VolumeSpeakerE.Text := '0' ;
          begin
            VolumeSpeakerF.Position
              := StrToInt(VolumeSpeakerE.Text) * -1 + 65535 ;
            PanPos := PanF.Position ;
            if PanPos = 0 then
              begin
                PanLR[0] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[1] := StrToInt(VolumeSpeakerE.Text) ;
              end ;
            if PanPos < 0 then
              begin
                PanLR[0] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[1] := PanLR[0] * 10000 div 65535
                              * (65535 - PanPos * -1) div 10000 ;
              end ;
            if PanPos > 0 then
              begin
                PanLR[1] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[0] := PanLR[1] * 10000 div 65535
                              * (65535 - PanPos) div 10000 ;
              end ;
            with ML_D_S do begin
              cbStruct        := Sizeof(TMixerLine)                   ;
              dwDestination   := 0                                    ;
              dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
            end ;
            mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                        + MIXER_OBJECTF_HMIXER) ;
            with MLC do begin
              cbStruct      := Sizeof(TMixerLineControls)      ;
              dwLineID      := ML_D_S.dwLineID                 ;
              dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
              cControls     := ML_D_S.cControls                ;
              cbmxctrl      := Sizeof(TMixerControl)           ;
              pamxctrl      := @MCL                            ;
            end ;
            with MCL do begin
              cbStruct   := Sizeof(TMixerControl)         ;
              fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
            end ;
            mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                         + MIXER_OBJECTF_HMIXER) ;
            with MCD do begin
              cbStruct       := Sizeof(TMixerControlDetails)         ;
              dwControlID    := MCL.dwControlID                      ;
              cChannels      := ML_D_S.cChannels                     ;
              cMultipleItems := 0                                    ;
              cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
              paDetails      := @PanLR                               ;
            end ;
            mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                           + MIXER_SETCONTROLDETAILSF_VALUE) ;
            if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
            if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
            if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
            PanLeft  := PanLR[0] ;
            PanRight := PanLR[1] ;
          end ;
    end ;
end ;

//  [ DestinationLine - SpeakerPanFader ]
procedure TMasterForm.PanFChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then
    begin
      Exit ;
    end ;
  if MasterActivateFlag = 1 then
    begin
      PanE.Text := IntToStr(PanF.Position) ;
      if PanF.Position = 0 then
        begin
          if PanLR[0] = PanLR[1] then Exit ;
          if PanLR[0] > PanLR[1] then PanLR[1] := PanLR[0] ;
          if PanLR[0] < PanLR[1] then PanLR[0] := PanLR[1] ;
        end ;
      if PanF.Position < 0 then
        begin
          PanLR[0] := PanMax ;
          PanLR[1] := PanLR[0] * 10000 div 65535
                        * (65535 - PanF.Position * -1) div 10000 ;
        end ;
      if PanF.Position > 0 then
        begin
          PanLR[1] := PanMax ;
          PanLR[0] := PanLR[1] * 10000 div 65535
                        * (65535 - PanF.Position) div 10000 ;
        end ;
      with ML_D_S do begin
        cbStruct        := Sizeof(TMixerLine)                   ;
        dwDestination   := 0                                    ;
        dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
      end ;
      mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                  + MIXER_OBJECTF_HMIXER) ;
      with MLC do begin
        cbStruct      := Sizeof(TMixerLineControls)      ;
        dwLineID      := ML_D_S.dwLineID                 ;
        dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
        cControls     := ML_D_S.cControls                ;
        cbmxctrl      := Sizeof(TMixerControl)           ;
        pamxctrl      := @MCL                            ;
      end ;
      with MCL do begin
        cbStruct   := Sizeof(TMixerControl)         ;
        fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
      end ;
      mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                   + MIXER_OBJECTF_HMIXER) ;
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_SETCONTROLDETAILSF_VALUE) ;
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      PanPos := PanF.Position ;
    end ;
end ;

//  [ DestinationLine - SpeakerPanEdit ]
procedure TMasterForm.PanEChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then
    begin
      Exit ;
    end ;
  if MasterActivateFlag = 1 then
    begin
      try StrToInt(PanE.Text) ; except Exit ; end ;
      if StrToInt(PanE.Text) > 65535 then
        PanE.Text := '65535' ;
      if StrToInt(PanE.Text) < -65535 then
        PanE.Text := '-65535' ;
      PanF.Position := StrToInt(PanE.Text) ;
    end ;
end ;

//  [ DestinationLine - SpeakerBassFader ]
procedure TMasterForm.EQLoFChange(Sender : TObject) ;
begin
  EQLoE.Text := IntToStr(EQLoF.Position * -1) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  Bass := EQLoF.Position * -1 + 32768 ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Bass                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//  [ DestinationLine - SpeakerBassEdit ]
procedure TMasterForm.EQLoEChange(Sender : TObject) ;
begin
  try StrToInt(EQLoE.Text) ; except Exit ; end ;
  if StrToInt(EQLoE.Text) > 32767 then
    EQLoE.Text := '32767' ;
  if StrToInt(EQLoE.Text) < -32768 then
    EQLoE.Text := '-32768' ;
      begin
        EQLoF.Position := StrToInt(EQLoE.Text) * -1 ;   
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)    ;
          dwLineID      := ML_D_S.dwLineID               ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
          cControls     := ML_D_S.cControls              ;
          cbmxctrl      := Sizeof(TMixerControl)         ;
          pamxctrl      := @MCL                          ;
        end ;
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        Bass := StrToInt(EQLoE.Text) + 32768 ;
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @Bass                                ;
        end ;
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//  [ DestinationLine - SpeakerTrebleFader ]
procedure TMasterForm.EQHiFChange(Sender : TObject) ;
begin
  EQHiE.Text := IntToStr(EQHiF.Position * -1) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  Treble := EQHiF.Position * -1 + 32768 ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Treble                              ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//  [ DestinationLine - SpeakerTrebleEdit ]
procedure TMasterForm.EQHiEChange(Sender : TObject) ;
begin
  try StrToInt(EQHiE.Text) ; except Exit ; end ;
  if StrToInt(EQHiE.Text) > 32767 then
    EQHiE.Text := '32767' ;
  if StrToInt(EQHiE.Text) < -32768 then
    EQHiE.Text := '-32768' ;
      begin
        EQHiF.Position := StrToInt(EQHiE.Text) * -1 ;
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)      ;
          dwLineID      := ML_D_S.dwLineID                 ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
          cControls     := ML_D_S.cControls                ;
          cbmxctrl      := Sizeof(TMixerControl)           ;
          pamxctrl      := @MCL                            ;
        end ;
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        Treble := StrToInt(EQHiE.Text) + 32768 ;
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @Treble                              ;
        end ;
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//  [ ConnectionLine - WaveVolumeFader ]
procedure TMasterForm.VolumeWaveFChange(Sender : TObject) ;
begin
  VolumeWaveE.Text := IntToStr(VolumeWaveF.Position * -1 + 65535) ;
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  VolumeWave := VolumeWaveF.Position * -1 + 65535 ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @VolumeWave                       ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//  [ ConnectionLine - WaveVolumeEdit ]
procedure TMasterForm.VolumeWaveEChange(Sender : TObject) ;
begin
  try StrToInt(VolumeWaveE.Text) ; except Exit ; end ;
  if StrToInt(VolumeWaveE.Text) > 65535 then
    VolumeWaveE.Text := '65535' ;
  if StrToInt(VolumeWaveE.Text) < 0 then
    VolumeWaveE.Text := '0' ;
      begin
        VolumeWaveF.Position
          := StrToInt(VolumeWaveE.Text) * -1 + 65535 ;
        with ML_C_W do begin
          cbStruct        := Sizeof(TMixerLine)                   ;
          dwDestination   := 0                                    ;
          dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
        end ;
        mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                                    + MIXER_OBJECTF_HMIXER) ;
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)      ;
          dwLineID      := ML_C_W.dwLineID                 ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
          cControls     := ML_C_W.cControls                ;
          cbmxctrl      := Sizeof(TMixerControl)           ;
          pamxctrl      := @MCL                            ;
        end ;
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        VolumeWave := StrToInt(VolumeWaveE.Text) ;
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @VolumeWave                       ;
        end ;
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//  [ DestinationLine - SpeakerMute - OFF ]
procedure TMasterForm.MasterMuteKeyDown(Sender : TObject ; var Key : Word ;
  Shift : TShiftState) ;
begin
  if key = Word(VK_SPACE) then Mute := False ;
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//  [ DestinationLine - SpeakerMute - ON ]
procedure TMasterForm.MasterMuteKeyUp(Sender : TObject ; var Key : Word ;
  Shift : TShiftState) ;
begin
  if key = Word(VK_SPACE) then Mute := True ;
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//  [ DestinationLine - SpeakerMute - OFF ]
procedure TMasterForm.MasterMuteKeyPress(Sender : TObject ; var Key : Char) ;
begin
  if key <> Char(VK_SPACE) then Mute := False ;
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//  [ DestinationLine - SpeakerMute - OFF ]
procedure TMasterForm.MasterMuteMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  Mute := False ;
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//  [ DestinationLine - SpeakerMute - ON ]
procedure TMasterForm.MasterMuteMouseUp(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  Mute := True ;
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//  [ ConnectionLine - WaveMeterEdit - Timer ]
procedure TMasterForm.MeterTTimer(Sender : TObject) ;
begin
{
  [ ConnectionLine - Wave ]
}
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
  [ MeterControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)         ;
    dwLineID      := ML_C_W.dwLineID                    ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_PEAKMETER ;
    cControls     := ML_C_W.cControls                   ;
    cbmxctrl      := Sizeof(TMixerControl)              ;
    pamxctrl      := @MCL                               ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := ML_C_W.cChannels                     ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @MeterLR                             ;
  end ;
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  MeterLeft  := MeterLR[0] ;
  MeterRight := MeterLR[1] ;
  MeterLeft  := Abs(MeterLeft)  ;
  MeterRight := Abs(MeterRight) ;
  MeterLG.Progress := MeterLeft ;
  MeterRG.Progress := MeterRight ;
  MeterLE.Text := IntToStr(MeterLeft) ;
  MeterRE.Text := IntToStr(MeterRight) ;

end ;

{
*********************************************************************
[ CallBackMessage - Routine ]
*********************************************************************
}
procedure TMasterForm.MixerCallBack(var Msg : TMessage) ;
begin
  if MasterActivateFlag = 1 then
    begin
      Exit ;
    end ;
  if MasterActivateFlag = 0 then
    begin
      case Msg.Msg of
        MM_MIXM_LINE_CHANGE :
          Exit ;
        MM_MIXM_CONTROL_CHANGE :
          begin
//**********************************************************************
{
  [ DestinationLine - Speaker ]
}
  //  ID = 0
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
  [ VolumeControl and PanControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  if Msg.lParam = MCL.dwControlID then
    begin
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      if PanLeft = PanRight then
        begin
          if PanLeft = 0 then
            begin
              VolumeSpeakerF.Position :=
              Integer(PanLeft) * -1 + 65535 ;
              VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ;
            end ;
          if PanLeft <> 0 then
            begin
              VolumeSpeakerF.Position :=
              Integer(PanLeft) * -1 + 65535 ;
              VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ;
              PanF.Position := 0 ;
              PanE.Text := IntToStr(0) ;
            end ;
        end ;
      if PanLeft > PanRight then
        begin
          VolumeSpeakerF.Position :=
          Integer(PanLeft) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ;
          PanF.Position :=
            (65535 - (((655350000 div PanLeft)
                              * PanRight) div 10000)) * (- 1) ;
          PanE.Text := IntToStr(PanF.Position) ;
        end ;
      if PanLeft < PanRight then
        begin
          VolumeSpeakerF.Position :=
          Integer(PanRight) * -1 + 65535 ;
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight)) ;
          PanF.Position :=
            (65535 - (((655350000 div PanRight)
                               * PanLeft) div 10000)) * (+ 1) ;
          PanE.Text := IntToStr(PanF.Position) ;
        end ;
    end ;

{
  [ BassControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  if Msg.lParam = MCL.dwControlID then
    begin
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @Bass                                ;
      end ;
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      EQLoF.Position := Integer(Bass) * - 1 + 32768 ;
      EQLoE.Text := IntToStr(Integer(Bass) - 32768) ;
    end ;

{
  [  TrebleControl]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  if Msg.lParam = MCL.dwControlID then
    begin
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @Treble                              ;
      end ;
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      EQHiF.Position := Integer(Treble) * - 1 + 32768 ;
      EQHiE.Text := IntToStr(Integer(Treble) - 32768) ;
    end ;

{
  [ ConnectionLine - Wave ]
}
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
  [ VolumeControl ]
}
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  if Msg.lParam = MCL.dwControlID then
    begin
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @VolumeWave                       ;
      end ;
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      VolumeWaveF.Position := Integer(VolumeWave) * -1 + 65535 ;
      VolumeWaveE.Text := IntToStr(Integer(VolumeWave))        ;
    end ;
//**********************************************************************
          end ;
      end ;
    end ;
end ;

//  [ DragDrop ]
procedure TMasterForm.MasterDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
const
  DropBuf = 255 ;
var
  DropFN : string ;
  FN     : string ;
begin
  if Msg.Message = WM_DROPFILES then
    begin
      SetLength(DropFN, DropBuf) ;
      DragQueryFile(Msg.wParam, 0, PChar(DropFN), DropBuf) ;
      ModuleList.Add(TModuleForm.Create(Self)) ;
      LoadWave(DropFN, ModuleID) ;
      FN := ExtractFileName(DropFN) ;
      WaveSizeM[ModuleID] := WaveSize ;
      WaveTimeM[ModuleID] :=
          WaveSizeM[ModuleID] div 1764 * 10 ;
      TModuleForm(ModuleList[ModuleID]).Caption := FN ;
      TModuleForm(ModuleList[ModuleID]).TimeE.Text :=
                                        IntToStr(WaveTimeM[ModuleID]) ;
      TModuleForm(ModuleList[ModuleID]).Show ;
      Inc(ModuleID) ;
      DragFinish(Msg.wParam) ;
      Handled := True ;
    end ;
end ;

//  [ Deactivate ]
procedure TMasterForm.ApplicationDeactivate(Sender : TObject) ;
begin
  MasterActivateFlag := 0 ;
end;

//  [ Activate ]
procedure TMasterForm.ApplicationActivate(Sender : TObject) ;
begin
  MasterActivateFlag := 1 ;
end;

initialization
  ModuleList := TList.Create;

finalization
  ModuleList.Free;

end.

