unit ModuleUnit ;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, CommCtrl, Gauges,
  MMSystem, dsound ;

type
  TModuleForm = class(TForm)
    OpenDialog1 : TOpenDialog ;
    Panel1      : TPanel      ;
    Load        : TButton     ;
    Play        : TButton     ;
    Pause       : TButton     ;
    PanLM       : TLabel      ;
    PanF        : TTrackBar   ;
    PanE        : TEdit       ;
    VolumeLM    : TLabel      ;
    VolumeE     : TEdit       ;
    VolumeF     : TTrackBar   ;
    PitchLM     : TLabel      ;
    PitchE      : TEdit       ;
    PitchF      : TTrackBar   ;
    PitchUP     : TButton     ;
    PitchDOWN   : TButton     ;
    PitchRL     : TLabel      ;
    PitchRE     : TEdit       ;
    StepL       : TLabel      ;
    StepE       : TEdit       ;
    TimeL       : TLabel      ;
    TimeE       : TEdit       ;
    BpmL        : TLabel      ;
    BpmE        : TEdit       ;
    procedure FormCreate(Sender : TObject) ;
    procedure FormClose(Sender : TObject ; var Action : TCloseAction) ;
    procedure LoadClick(Sender : TObject) ;
    procedure PlayClick(Sender : TObject) ;
    procedure PauseClick(Sender : TObject) ;
    procedure VolumeFChange(Sender : TObject) ;
    procedure VolumeEChange(Sender : TObject) ;
    procedure PitchFChange(Sender : TObject) ;
    procedure PitchEChange(Sender : TObject) ;
    procedure PanFChange(Sender : TObject) ;
    procedure PanEChange(Sender : TObject) ;
    procedure PitchREChange(Sender : TObject) ;
    procedure PitchUPMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchUPMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchDOWNMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchDOWNMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure StepEChange(Sender : TObject) ;
    procedure BpmEChange(Sender : TObject) ;
  private
    { Private declarations }
//    procedure ModuleDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
  public
    { Public declarations }
    PublicID         : Integer ;
    PublicFPFN       : String  ;
    PublicFN         : String  ;
    PublicFPause     : Byte    ;
  end ;

var
  ModuleForm : TModuleForm ;

implementation

uses
  MasterUnit ;

{$R *.DFM}

//  [ ModuleCreate ]
procedure TModuleForm.FormCreate(Sender : TObject) ;
var
  TBS : DWORD ;
begin
{
  //  [ DragDrop ]
  Application.OnMessage := ModuleDropMsg ;
  DragAcceptFiles(ModuleForm.Handle, True) ;
}
  //  [ TrackBar - TBS_ENABLESELRANGE ]
  TBS := GetWindowLong(VolumeF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PitchF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PitchF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PanF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PanF.Handle, GWL_STYLE, TBS) ;
  //  [ Initialize ]
  PublicID     := ModuleID ;
  PublicFPFN   := FPFN ;
  PublicFN     := FN ;
  PublicFPause := 0 ;
end ;

//  [ ModuleClose ]
procedure TModuleForm.FormClose(Sender : TObject ; var Action : TCloseAction) ;
begin
  //  [ SecondaryBuffer - Free ]
  if DS2ndB[PublicID] <> nil then
    begin
      DS2ndB[PublicID].Release ;
      DS2ndB[PublicID] := nil ;
    end;
  Action := caFree ;
end ;

//  [ Load ]
procedure TModuleForm.LoadClick(Sender : TObject) ;
begin
  PublicFPause := 0 ;
  if OpenDialog1.Execute then
    begin
      FPFN := OpenDialog1.FileName ;
      FN := ExtractFileName(FPFN) ;
      Caption := FN ;
      LoadWave(FPFN, PublicID) ;
      StepE.Text := 'NONE' ;
      BpmE.Text := 'NONE' ;
      PitchF.Position := 44100 ;
      PitchE.Text := IntToStr(PitchF.Position) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ;
      WaveSizeM[PublicID] := WaveSize ;
      WaveTimeM[PublicID] := WaveSizeM[PublicID] div 1764 * 10 ;
      TimeE.Text := IntToStr(WaveTimeM[PublicID]) ;
    end else
      Exit ;
end ;

//  [ Play ]
procedure TModuleForm.PlayClick(Sender : TObject) ;
begin
  if DS2ndB[PublicID] = nil then Exit ;
  PublicFPause := 1 ;
  DS2ndB[PublicID].SetCurrentPosition(0) ;
  DS2ndB[PublicID].Play(0, 0, DSBPLAY_LOOPING) ;
end ;

//  [ Pause ]
procedure TModuleForm.PauseClick(Sender : TObject) ;
begin
  if DS2ndB[PublicID] = nil then Exit ;
  if PublicFPause <> 0 then
    begin
      DS2ndB[PublicID].Stop() ;
      PublicFPause := 0 ;
    end else
    begin
      DS2ndB[PublicID].Play(0, 0, DSBPLAY_LOOPING) ;
      PublicFPause := 1 ;
    end ;
end ;

//  [ VolumeFader ]
procedure TModuleForm.VolumeFChange(Sender : TObject) ;
begin
  if VolumeF.Position <> 3200 then
    begin
      VolumeE.Text := IntToStr(VolumeF.Position * -1 + 3200) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(VolumeF.Position * -1) ;
    end else
    begin
      VolumeE.Text := '0' ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(-10000) ;
    end ;
end ;

//  [ VolumeEdit ]
procedure TModuleForm.VolumeEChange(Sender : TObject) ;
begin
  try StrToInt(VolumeE.Text) ; except Exit ; end ;
  if StrToInt(VolumeE.Text) > 3200 then VolumeE.Text := '3200' ;
  if StrToInt(VolumeE.Text) < 0 then VolumeE.Text := '0' ;
  if StrToInt(VolumeE.Text) <> 0 then
    begin
      VolumeF.Position := StrToInt(VolumeE.Text) * -1 + 3200 ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(StrToInt(VolumeE.Text) - 3200) ;
    end else
    begin
      VolumeF.Position := 3200 ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(-10000) ;
    end ;
end ;

//  [ PitchFader ]
procedure TModuleForm.PitchFChange(Sender : TObject) ;
begin
  PitchE.Text := IntToStr(PitchF.Position) ;
//  if StepE.text <> 'NONE' then
//    BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
//                              div PitchF.Position) div StrToInt(StepE.text))) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(PitchF.Position) ;
end ;

//  [ PitchEdit ]
procedure TModuleForm.PitchEChange(Sender : TObject) ;
begin
  try StrToInt(PitchE.Text) ; except Exit ; end ;
  if StrToInt(PitchE.Text) > 88200 then PitchE.Text := '88200' ;
  if StrToInt(PitchE.Text) < 100 then PitchE.Text := '100' ;
    begin
      PitchF.Position := StrToInt(PitchE.Text) ;
//      if StepE.text <> 'NONE' then
//        BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
//                              div PitchF.Position) div StrToInt(StepE.text))) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ;
    end ;
end ;

//  [ PanFader ]
procedure TModuleForm.PanFChange(Sender : TObject) ;
begin
  PanE.Text := IntToStr(PanF.Position) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetPan(PanF.Position) ;
end ;

//  [ PanEdit ]
procedure TModuleForm.PanEChange(Sender : TObject) ;
begin
  try StrToInt(PanE.Text) ; except Exit ; end ;
  if StrToInt(PanE.Text) > 10000 then PanE.Text := '10000' ;
  if StrToInt(PanE.Text) < -10000 then PanE.Text := '-10000' ;
    begin
      PanF.Position := StrToInt(PanE.Text) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetPan(StrToInt(PanE.Text)) ;
    end ;
end ;

//  [ PitchRange ]
procedure TModuleForm.PitchREChange(Sender : TObject) ;
begin
  try StrToInt(PitchRE.Text) ; except Exit ; end ;
  if StrToInt(PitchRE.Text) > 88200 then PitchRE.Text := '88200' ;
  if StrToInt(PitchRE.Text) < 100 then PitchRE.Text := '100' ;
end ;

//  [ PitchUp - ON ]
procedure TModuleForm.PitchUPMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) + (StrToInt(PitchRE.Text))) ;
  PitchF.Position := StrToInt(PitchE.Text) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ;
end ;

//  [ PitchUp - OFF ]
procedure TModuleForm.PitchUPMouseUp(Sender : TObject ; Button : TMouseButton ;
  Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) - (StrToInt(PitchRE.Text))) ;
  PitchF.Position := StrToInt(PitchE.Text) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ;
end ;

//  [ PitchDown - ON ]
procedure TModuleForm.PitchDOWNMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) - (StrToInt(PitchRE.Text))) ;
  PitchF.Position := StrToInt(PitchE.Text) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ;
end ;

//  [ PitchDown - OFF ]
procedure TModuleForm.PitchDOWNMouseUp(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) + (StrToInt(PitchRE.Text))) ;
  PitchF.Position := StrToInt(PitchE.Text) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ;
end ;

//  [ StepEdit ]
procedure TModuleForm.StepEChange(Sender : TObject) ;
begin
  try StrToInt(StepE.Text) ; except Exit ; end ;
  if StrToInt(StepE.Text) > 99999 then StepE.Text := '99999' ;
  if StrToInt(StepE.Text) < 1 then StepE.Text := '1' ;
//  BpmE.Text :=
//    IntToStr(60000 div (WaveTimeM[PublicID] div StrToInt(StepE.Text))) ;
  BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
                            div PitchF.Position) div StrToInt(StepE.text))) ;
end ;

//  [ BPMEdit ]
procedure TModuleForm.BpmEChange(Sender : TObject) ;
begin
  if StepE.Text = 'NONE' then BpmE.Text := 'NONE' ;
  if BpmE.Text <> 'NONE' then
    begin
      try StrToInt(BpmE.Text) ; except Exit ; end ;
      if StrToInt(BpmE.Text) > 999 then BpmE.Text := '999' ;
      if StrToInt(BpmE.Text) < 1 then BpmE.Text := '1' ;
      TimeE.Text :=
          IntToStr(60000 div StrToInt(BpmE.Text) * StrToInt(StepE.Text)) ;
      PitchF.Position :=
        44100 * WaveTimeM[PublicID]
                              div StrToInt(TimeE.Text) ;
      PitchE.Text := IntToStr(PitchF.Position) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ;
    end ;
end ;

{
//  [ DragDrop ]
procedure TModuleForm.ModuleDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
const
  DropBuf = 255 ;
var
  DropFN : string ;
begin
  if Msg.Message = WM_DROPFILES then
    begin
      SetLength(DropFN, DropBuf) ;
      DragQueryFile(Msg.wParam, 0, PChar(DropFN), DropBuf) ;
      PublicFPause := 0 ;
      LoadWave(DropFN, PublicID) ;
      StepE.Text := 'NONE' ;
      BpmE.Text := 'NONE' ;
      PitchF.Position := 44100 ;
      PitchE.Text := IntToStr(PitchF.Position) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ;
      WaveSizeM[PublicID] := WaveSize ;
      WaveTimeM[PublicID] := WaveSizeM[PublicID] div 1764 * 10 ;
      TimeE.Text := IntToStr(WaveTimeM[PublicID]) ;
      DragFinish(Msg.wParam) ;
      Handled := True ;
    end ;
end ;
}

end.

