unit ModuleUnit ;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, CommCtrl, Gauges,
  MMSystem, dsound ;

type
  TModuleForm = class(TForm)
    OpenDialog1 : TOpenDialog ;
    Panel1      : TPanel      ;
    Load        : TButton     ;
    Play        : TButton     ;
    Pause       : TButton     ;
    //  pRg[
    PanLM       : TLabel      ;
    PanF        : TTrackBar   ;
    PanE        : TEdit       ;
    //  {[Rg[
    VolumeLM    : TLabel      ;
    VolumeE     : TEdit       ;
    VolumeF     : TTrackBar   ;
    //  sb`Rg[
    PitchLM     : TLabel      ;
    PitchE      : TEdit       ;
    PitchF      : TTrackBar   ;
    PitchUP     : TButton     ;
    PitchDOWN   : TButton     ;
    PitchRL     : TLabel      ;
    PitchRE     : TEdit       ;
    //  aolRg[
    StepL       : TLabel      ;
    StepE       : TEdit       ;
    TimeL       : TLabel      ;
    TimeE       : TEdit       ;
    BpmL        : TLabel      ;
    BpmE        : TEdit       ;
    procedure FormCreate(Sender : TObject) ;
    procedure FormClose(Sender : TObject ; var Action : TCloseAction) ;
    procedure LoadClick(Sender : TObject) ;
    procedure PlayClick(Sender : TObject) ;
    procedure PauseClick(Sender : TObject) ;
    procedure VolumeFChange(Sender : TObject) ;
    procedure VolumeEChange(Sender : TObject) ;
    procedure PitchFChange(Sender : TObject) ;
    procedure PitchEChange(Sender : TObject) ;
    procedure PanFChange(Sender : TObject) ;
    procedure PanEChange(Sender : TObject) ;
    procedure PitchREChange(Sender : TObject) ;
    procedure PitchUPMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchUPMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchDOWNMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure PitchDOWNMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure StepEChange(Sender : TObject) ;
    procedure BpmEChange(Sender : TObject) ;
  private
    { Private declarations }
//    procedure ModuleDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
  public
    { Public declarations }
    PublicID         : Integer ; //  W[j[Nio[
    PublicFPFN       : String  ; //  W[t@Cl[itpXj
    PublicFN         : String  ; //  W[t@Cl[
    PublicFPause     : Byte    ; //  W[|[YtO
  end ;

var
  ModuleForm : TModuleForm ;

implementation

uses
  MasterUnit ;

{$R *.DFM}

//y W[NGCg z
procedure TModuleForm.FormCreate(Sender : TObject) ;
var
  TBS : DWORD ; //  gbNo[TBS_ENABLESELRANGEpϐ
begin
{
  //y hOhbvbZ[W z
  Application.OnMessage := ModuleDropMsg ;
  DragAcceptFiles(ModuleForm.Handle, True) ;
}
  //y gbNo[TBS_ENABLESELRANGE z
  TBS := GetWindowLong(VolumeF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PitchF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PitchF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PanF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PanF.Handle, GWL_STYLE, TBS) ;
  //y j[NϐɃZbg z
  PublicID     := ModuleID ;
  PublicFPFN   := FPFN ;
  PublicFN     := FN ;
  PublicFPause := 0 ;
end ;

//y W[N[Y z
procedure TModuleForm.FormClose(Sender : TObject ; var Action : TCloseAction) ;
begin
  //y ZJ_obt@j z
  if DS2ndB[PublicID] <> nil then
    begin
      DS2ndB[PublicID].Release ;
      DS2ndB[PublicID] := nil ;
    end;
  Action := caFree ;
end ;

//y [h z
procedure TModuleForm.LoadClick(Sender : TObject) ;
begin
  PublicFPause := 0 ;                //  |[YtO
  if OpenDialog1.Execute then
    begin
      FPFN := OpenDialog1.FileName ; //  t@Cl[擾itpXj
      FN := ExtractFileName(FPFN) ;  //  t@Cl[擾
      Caption := FN ;                //  LvV\
      LoadWave(FPFN, PublicID) ;     //  WAVEt@C[h
      StepE.Text := 'NONE' ;
      BpmE.Text := 'NONE' ;
      PitchF.Position := 44100 ;                         //  ʒuɔf
      PitchE.Text := IntToStr(PitchF.Position) ;         //  lɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ; //  sb`ɔf
      WaveSizeM[PublicID] := WaveSize ;
      WaveTimeM[PublicID] := WaveSizeM[PublicID] div 1764 * 10 ;
      TimeE.Text := IntToStr(WaveTimeM[PublicID]) ;
    end else
      Exit ;                         //  t@CI[vLZ
end ;

//y vC z
procedure TModuleForm.PlayClick(Sender : TObject) ;
begin
  if DS2ndB[PublicID] = nil then Exit ;          //  ݂ȂȂ牽Ȃ
  PublicFPause := 1 ;                            //  ĐtO
  DS2ndB[PublicID].SetCurrentPosition(0) ;       //  gbvɃZbg
  DS2ndB[PublicID].Play(0, 0, DSBPLAY_LOOPING) ; //  [vĐ
end ;

//y |[Y z
procedure TModuleForm.PauseClick(Sender : TObject) ;
begin
  if DS2ndB[PublicID] = nil then Exit ;          //  ݂ȂȂ牽Ȃ
  if PublicFPause <> 0 then
    begin
      DS2ndB[PublicID].Stop() ;                  //  ĐȂ~
      PublicFPause := 0 ;                        //  tOIt
    end else
    begin
      DS2ndB[PublicID].Play(0, 0, DSBPLAY_LOOPING) ; //  ~ȂĊJ
      PublicFPause := 1 ;                            //  tOI
    end ;
end ;

//y {[tF[_[ z
procedure TModuleForm.VolumeFChange(Sender : TObject) ;
begin
  if VolumeF.Position <> 3200 then                             //  őlH
    begin
      VolumeE.Text := IntToStr(VolumeF.Position * -1 + 3200) ; //  lɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(VolumeF.Position * -1) ;    //  ʂɔf
    end else
    begin
      VolumeE.Text := '0' ;                                    //  lMIN
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(-10000) ;                   //  ʂMIN
    end ;
end ;

//y {[GfBbg z
procedure TModuleForm.VolumeEChange(Sender : TObject) ;
begin
  try StrToInt(VolumeE.Text) ; except Exit ; end ;               //  LH
  if StrToInt(VolumeE.Text) > 3200 then VolumeE.Text := '3200' ; //  ȏ
  if StrToInt(VolumeE.Text) < 0 then VolumeE.Text := '0' ;       //  ȉ
  if StrToInt(VolumeE.Text) <> 0 then                            //  ŏlH
    begin
      VolumeF.Position := StrToInt(VolumeE.Text) * -1 + 3200 ;      //  ʒuɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(StrToInt(VolumeE.Text) - 3200) ; //  ʂɔf
    end else
    begin
      VolumeF.Position := 3200 ;                                    //  ʒuMAX
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetVolume(-10000) ;                        //  ʂMIN
    end ;
end ;

//y sb`tF[_[ z
procedure TModuleForm.PitchFChange(Sender : TObject) ;
begin
  PitchE.Text := IntToStr(PitchF.Position) ;         //  lɔf
//  if StepE.text <> 'NONE' then
//    BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
//                              div PitchF.Position) div StrToInt(StepE.text))) ;
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(PitchF.Position) ; //  sb`ɔf
end ;

//y sb`GfBbg z
procedure TModuleForm.PitchEChange(Sender : TObject) ;
begin
  try StrToInt(PitchE.Text) ; except Exit ; end ;                //  LH
  if StrToInt(PitchE.Text) > 88200 then PitchE.Text := '88200' ; //  ȏ
  if StrToInt(PitchE.Text) < 100 then PitchE.Text := '100' ;     //  ȉ
    begin
      PitchF.Position := StrToInt(PitchE.Text) ;               //  ʒuɔf
//      if StepE.text <> 'NONE' then
//        BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
//                              div PitchF.Position) div StrToInt(StepE.text))) ;
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ; //  sb`ɔf
    end ;
end ;

//y ptF[_[ z
procedure TModuleForm.PanFChange(Sender : TObject) ;
begin
  PanE.Text := IntToStr(PanF.Position) ;     //  lɔf
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetPan(PanF.Position) ; //  pɔf
end ;

//y pGfBbg z
procedure TModuleForm.PanEChange(Sender : TObject) ;
begin
  try StrToInt(PanE.Text) ; except Exit ; end ;                //  LH
  if StrToInt(PanE.Text) > 10000 then PanE.Text := '10000' ;   //  ȏ
  if StrToInt(PanE.Text) < -10000 then PanE.Text := '-10000' ; //  ȉ
    begin
      PanF.Position := StrToInt(PanE.Text) ;           //  ʒuɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetPan(StrToInt(PanE.Text)) ; //  pɔf
    end ;
end ;

//y sb`W z
procedure TModuleForm.PitchREChange(Sender : TObject) ;
begin
  try StrToInt(PitchRE.Text) ; except Exit ; end ;                 //  LH
  if StrToInt(PitchRE.Text) > 88200 then PitchRE.Text := '88200' ; //  ȏ
  if StrToInt(PitchRE.Text) < 100 then PitchRE.Text := '100' ;     //  ȉ
end ;

//y sb`AbvEI z
procedure TModuleForm.PitchUPMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) + (StrToInt(PitchRE.Text))) ; //  lɔf
  PitchF.Position := StrToInt(PitchE.Text) ;               //  ʒuɔf
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ; //  sb`ɔf
end ;

//y sb`AbvEIt z
procedure TModuleForm.PitchUPMouseUp(Sender : TObject ; Button : TMouseButton ;
  Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) - (StrToInt(PitchRE.Text))) ; //  lɔf
  PitchF.Position := StrToInt(PitchE.Text) ;               //  ʒuɔf
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ; //  sb`ɔf
end ;

//y sb`_EEI z
procedure TModuleForm.PitchDOWNMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) - (StrToInt(PitchRE.Text))) ; //  lɔf
  PitchF.Position := StrToInt(PitchE.Text) ;               //  ʒuɔf
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ; //  sb`ɔf
end ;

//y sb`_EEIt z
procedure TModuleForm.PitchDOWNMouseUp(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  PitchE.Text := IntToStr
    ((StrToInt(PitchE.Text)) + (StrToInt(PitchRE.Text))) ; //  lɔf
  PitchF.Position := StrToInt(PitchE.Text) ;               //  ʒuɔf
  if DS2ndB[PublicID] <> nil then
    DS2ndB[PublicID].SetFrequency(StrToInt(PitchE.Text)) ; //  sb`ɔf
end ;

//y XebvGfBbg z
procedure TModuleForm.StepEChange(Sender : TObject) ;
begin
  try StrToInt(StepE.Text) ; except Exit ; end ;               //  LH
  if StrToInt(StepE.Text) > 99999 then StepE.Text := '99999' ; //  ȏ
  if StrToInt(StepE.Text) < 1 then StepE.Text := '1' ;         //  ȉ
//  BpmE.Text :=
//    IntToStr(60000 div (WaveTimeM[PublicID] div StrToInt(StepE.Text))) ;
  BpmE.Text := IntToStr(60000 div (((44100 * WaveTimeM[PublicID])
                            div PitchF.Position) div StrToInt(StepE.text))) ;
end ;

//y aolGfBbg z
procedure TModuleForm.BpmEChange(Sender : TObject) ;
begin
  if StepE.Text = 'NONE' then BpmE.Text := 'NONE' ;
  if BpmE.Text <> 'NONE' then
    begin
      try StrToInt(BpmE.Text) ; except Exit ; end ;          //  LH
      if StrToInt(BpmE.Text) > 999 then BpmE.Text := '999' ; //  ȏ
      if StrToInt(BpmE.Text) < 1 then BpmE.Text := '1' ;     //  ȉ
      TimeE.Text :=
          IntToStr(60000 div StrToInt(BpmE.Text) * StrToInt(StepE.Text)) ;
      PitchF.Position :=
        44100 * WaveTimeM[PublicID]
                              div StrToInt(TimeE.Text) ; //  ʒuɔf
      PitchE.Text := IntToStr(PitchF.Position) ;         //  lɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ; //  sb`ɔf
    end ;
end ;

{
//y hOhbv z
procedure TModuleForm.ModuleDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
const
  DropBuf = 255 ;
var
  DropFN : string ;
begin
  if Msg.Message = WM_DROPFILES then
    begin
      SetLength(DropFN, DropBuf) ;
      DragQueryFile(Msg.wParam, 0, PChar(DropFN), DropBuf) ;
      PublicFPause := 0 ;                //  |[YtO
      LoadWave(DropFN, PublicID) ;              //  WAVEt@C[h
      StepE.Text := 'NONE' ;
      BpmE.Text := 'NONE' ;
      PitchF.Position := 44100 ;                         //  ʒuɔf
      PitchE.Text := IntToStr(PitchF.Position) ;         //  lɔf
      if DS2ndB[PublicID] <> nil then
        DS2ndB[PublicID].SetFrequency(PitchF.Position) ; //  sb`ɔf
      WaveSizeM[PublicID] := WaveSize ;
      WaveTimeM[PublicID] := WaveSizeM[PublicID] div 1764 * 10 ;
      TimeE.Text := IntToStr(WaveTimeM[PublicID]) ;
      DragFinish(Msg.wParam) ;
      Handled := True ;
    end ;
end ;
}

end.

