unit d3dtypes;

{$X+}{$Z4}

interface

uses Windows, ddraw;

const
  DIRECT3D_VERSION	= $0700;

type
  D3DVALUE	= Single;
  LPD3DVALUE	= ^Single;

type
  D3DFIXED	= LongInt;

const
  D3DENUMRET_CANCEL	= DDENUMRET_CANCEL;
  D3DENUMRET_OK	= DDENUMRET_OK;

type
  LPD3DVALIDATECALLBACK =   function (lpUserArg: Pointer; dwOffset: DWORD): HRESULT; stdcall;
  LPD3DENUMTEXTUREFORMATSCALLBACK =   function (lpDdsd: LPDDSURFACEDESC; lpContext: Pointer): HRESULT; stdcall;
  LPD3DENUMPIXELFORMATSCALLBACK =   function (lpDDPixFmt: LPDDPIXELFORMAT; lpContext: Pointer): HRESULT; stdcall;

  D3DCOLOR	= DWORD;
  LPD3DCOLOR	= ^DWORD;

  D3DMATERIALHANDLE	= DWORD;
  LPD3DMATERIALHANDLE	= ^DWORD;
  D3DTEXTUREHANDLE	= DWORD;
  LPD3DTEXTUREHANDLE	= ^DWORD;
  D3DMATRIXHANDLE	= DWORD;
  LPD3DMATRIXHANDLE	= ^DWORD;

  LPD3DCOLORVALUE	= ^D3DCOLORVALUE;
  D3DCOLORVALUE = record
	case Integer of
	0: (
	  r	: D3DVALUE;
	  g	: D3DVALUE;
	  b	: D3DVALUE;
	  a	: D3DVALUE;
	);
	1: (
	  dvR	: D3DVALUE;
	  dvG	: D3DVALUE;
	  dvB	: D3DVALUE;
	  dvA	: D3DVALUE;
	);
  end;

  LPD3DRECT	= ^D3DRECT;
  D3DRECT = record
	case Integer of
	0: (
	  x1	: LongInt;
	  y1	: LongInt;
	  x2	: LongInt;
	  y2	: LongInt;
	);
	1: (
	  lX1	: LongInt;
	  lY1	: LongInt;
	  lX2	: LongInt;
	  lY2	: LongInt;
	);
  end;

  LPD3DVECTOR	= ^D3DVECTOR;
  D3DVECTOR = record
	case Integer of
	0: (
	  x	: D3DVALUE;
	  y	: D3DVALUE;
	  z	: D3DVALUE;
	);
	1: (
	  dvX	: D3DVALUE;
	  dvY	: D3DVALUE;
	  dvZ	: D3DVALUE;
	);
  end;

  LPD3DHVERTEX	= ^D3DHVERTEX;
  D3DHVERTEX = record
	dwFlags	: DWORD;
	case Integer of
	0: (
	  hx	: D3DVALUE;
	  hy	: D3DVALUE;
	  hz	: D3DVALUE;
	);
	1: (
	  dvHX	: D3DVALUE;
	  dvHY	: D3DVALUE;
	  dvHZ	: D3DVALUE;
	);
  end;

  LPD3DTLVERTEX	= ^D3DTLVERTEX;
  D3DTLVERTEX = record
	case Integer of
	0: (
	  sx	: D3DVALUE;
	  sy	: D3DVALUE;
	  sz	: D3DVALUE;
	  rhw	: D3DVALUE;
	  color	: D3DCOLOR;
	  specular	: D3DCOLOR;
	  tu	: D3DVALUE;
	  tv	: D3DVALUE;
	);
	1: (
	  dvSX	: D3DVALUE;
	  dvSY	: D3DVALUE;
	  dvSZ	: D3DVALUE;
	  dvRHW	: D3DVALUE;
	  dcColor	: D3DCOLOR;
	  dcSpecular	: D3DCOLOR;
	  dvTU	: D3DVALUE;
	  dvTV	: D3DVALUE;
	);
  end;

  LPD3DLVERTEX	= ^D3DLVERTEX;
  D3DLVERTEX = record
	case Integer of
	0: (
	  x	: D3DVALUE;
	  y	: D3DVALUE;
	  z	: D3DVALUE;
	  dwReserved	: DWORD;
	  color	: D3DCOLOR;
	  specular	: D3DCOLOR;
	  tu	: D3DVALUE;
	  tv	: D3DVALUE;
	);
	1: (
	  dvX	: D3DVALUE;
	  dvY	: D3DVALUE;
	  dvZ	: D3DVALUE;
	  Unknown1_4:  DWORD;
	  dcColor	: D3DCOLOR;
	  dcSpecular	: D3DCOLOR;
	  dvTU	: D3DVALUE;
	  dvTV	: D3DVALUE;
	);
  end;

  LPD3DVERTEX	= ^D3DVERTEX;
  D3DVERTEX = record
	case Integer of
	0: (
	  x	: D3DVALUE;
	  y	: D3DVALUE;
	  z	: D3DVALUE;
	  nx	: D3DVALUE;
	  ny	: D3DVALUE;
	  nz	: D3DVALUE;
	  tu	: D3DVALUE;
	  tv	: D3DVALUE;
	);
	1: (
	  dvX	: D3DVALUE;
	  dvY	: D3DVALUE;
	  dvZ	: D3DVALUE;
	  dvNX	: D3DVALUE;
	  dvNY	: D3DVALUE;
	  dvNZ	: D3DVALUE;
	  dvTU	: D3DVALUE;
	  dvTV	: D3DVALUE;
	);
  end;

  LPD3DMATRIX	= ^D3DMATRIX;

  D3DMATRIX = record
	  case Integer of
      1: (_11,_12,_13,_14, _21,_22,_23,_24, _31,_32,_33,_34, _41,_42,_43,_44: D3DVALUE);
      2: (_m00,_m01,_m02,_m03, _m10,_m11,_m12,_m13, _m20,_m21,_m22,_m23, _m30,_m31,_m32,_m33: D3DVALUE);
  end;

  LPD3DVIEWPORT	= ^D3DVIEWPORT;
  D3DVIEWPORT = record
	dwSize	: DWORD;
	dwX	: DWORD;
	dwY	: DWORD;
	dwWidth	: DWORD;
	dwHeight	: DWORD;
	dvScaleX	: D3DVALUE;
	dvScaleY	: D3DVALUE;
	dvMaxX	: D3DVALUE;
	dvMaxY	: D3DVALUE;
	dvMinZ	: D3DVALUE;
	dvMaxZ	: D3DVALUE;
  end;

  LPD3DVIEWPORT2	= ^D3DVIEWPORT2;
  D3DVIEWPORT2 = record
	dwSize	: DWORD;
	dwX	: DWORD;
	dwY	: DWORD;
	dwWidth	: DWORD;
	dwHeight	: DWORD;
	dvClipX	: D3DVALUE;
	dvClipY	: D3DVALUE;
	dvClipWidth	: D3DVALUE;
	dvClipHeight	: D3DVALUE;
	dvMinZ	: D3DVALUE;
	dvMaxZ	: D3DVALUE;
  end;
  LPD3DVIEWPORT7	= ^D3DVIEWPORT7;
  D3DVIEWPORT7 = record
	dwX	: DWORD;
	dwY	: DWORD;
	dwWidth	: DWORD;
	dwHeight	: DWORD;
	dvMinZ	: D3DVALUE;
	dvMaxZ	: D3DVALUE;
  end;

const
  D3DMAXUSERCLIPPLANES	= 32;
  D3DCLIPPLANE0	= $00000001;
  D3DCLIPPLANE1	= $00000002;
  D3DCLIPPLANE2	= $00000004;
  D3DCLIPPLANE3	= $00000008;
  D3DCLIPPLANE4	= $00000010;
  D3DCLIPPLANE5	= $00000020;
  D3DCLIP_LEFT	= $00000001;
  D3DCLIP_RIGHT	= $00000002;
  D3DCLIP_TOP	= $00000004;
  D3DCLIP_BOTTOM	= $00000008;
  D3DCLIP_FRONT	= $00000010;
  D3DCLIP_BACK	= $00000020;
  D3DCLIP_GEN0	= $00000040;
  D3DCLIP_GEN1	= $00000080;
  D3DCLIP_GEN2	= $00000100;
  D3DCLIP_GEN3	= $00000200;
  D3DCLIP_GEN4	= $00000400;
  D3DCLIP_GEN5	= $00000800;
  D3DSTATUS_CLIPUNIONLEFT	= D3DCLIP_LEFT;
  D3DSTATUS_CLIPUNIONRIGHT	= D3DCLIP_RIGHT;
  D3DSTATUS_CLIPUNIONTOP	= D3DCLIP_TOP;
  D3DSTATUS_CLIPUNIONBOTTOM	= D3DCLIP_BOTTOM;
  D3DSTATUS_CLIPUNIONFRONT	= D3DCLIP_FRONT;
  D3DSTATUS_CLIPUNIONBACK	= D3DCLIP_BACK;
  D3DSTATUS_CLIPUNIONGEN0	= D3DCLIP_GEN0;
  D3DSTATUS_CLIPUNIONGEN1	= D3DCLIP_GEN1;
  D3DSTATUS_CLIPUNIONGEN2	= D3DCLIP_GEN2;
  D3DSTATUS_CLIPUNIONGEN3	= D3DCLIP_GEN3;
  D3DSTATUS_CLIPUNIONGEN4	= D3DCLIP_GEN4;
  D3DSTATUS_CLIPUNIONGEN5	= D3DCLIP_GEN5;
  D3DSTATUS_CLIPINTERSECTIONLEFT	= $00001000;
  D3DSTATUS_CLIPINTERSECTIONRIGHT	= $00002000;
  D3DSTATUS_CLIPINTERSECTIONTOP	= $00004000;
  D3DSTATUS_CLIPINTERSECTIONBOTTOM	= $00008000;
  D3DSTATUS_CLIPINTERSECTIONFRONT	= $00010000;
  D3DSTATUS_CLIPINTERSECTIONBACK	= $00020000;
  D3DSTATUS_CLIPINTERSECTIONGEN0	= $00040000;
  D3DSTATUS_CLIPINTERSECTIONGEN1	= $00080000;
  D3DSTATUS_CLIPINTERSECTIONGEN2	= $00100000;
  D3DSTATUS_CLIPINTERSECTIONGEN3	= $00200000;
  D3DSTATUS_CLIPINTERSECTIONGEN4	= $00400000;
  D3DSTATUS_CLIPINTERSECTIONGEN5	= $00800000;
  D3DSTATUS_ZNOTVISIBLE	= $01000000;

  D3DSTATUS_CLIPUNIONALL	= ( D3DSTATUS_CLIPUNIONLEFT or D3DSTATUS_CLIPUNIONRIGHT or
         D3DSTATUS_CLIPUNIONTOP or D3DSTATUS_CLIPUNIONBOTTOM or D3DSTATUS_CLIPUNIONFRONT or
         D3DSTATUS_CLIPUNIONBACK or D3DSTATUS_CLIPUNIONGEN0 or D3DSTATUS_CLIPUNIONGEN1 or
         D3DSTATUS_CLIPUNIONGEN2 or D3DSTATUS_CLIPUNIONGEN3 or D3DSTATUS_CLIPUNIONGEN4 or
         D3DSTATUS_CLIPUNIONGEN5 );

  D3DSTATUS_CLIPINTERSECTIONALL	= ( D3DSTATUS_CLIPINTERSECTIONLEFT or D3DSTATUS_CLIPINTERSECTIONRIGHT or
         D3DSTATUS_CLIPINTERSECTIONTOP or D3DSTATUS_CLIPINTERSECTIONBOTTOM or D3DSTATUS_CLIPINTERSECTIONFRONT or
         D3DSTATUS_CLIPINTERSECTIONBACK or D3DSTATUS_CLIPINTERSECTIONGEN0 or D3DSTATUS_CLIPINTERSECTIONGEN1 or
         D3DSTATUS_CLIPINTERSECTIONGEN2 or D3DSTATUS_CLIPINTERSECTIONGEN3 or D3DSTATUS_CLIPINTERSECTIONGEN4 or
         D3DSTATUS_CLIPINTERSECTIONGEN5 );

  D3DSTATUS_DEFAULT	= ( D3DSTATUS_CLIPINTERSECTIONALL or D3DSTATUS_ZNOTVISIBLE );

  D3DTRANSFORM_CLIPPED	= $00000001;
  D3DTRANSFORM_UNCLIPPED	= $00000002;

type
  LPD3DTRANSFORMDATA	= ^D3DTRANSFORMDATA;
  D3DTRANSFORMDATA = record
	dwSize	: DWORD;
	lpIn	: Pointer;
	dwInSize	: DWORD;
	lpOut	: Pointer;
	dwOutSize	: DWORD;
	lpHOut	: LPD3DHVERTEX;
	dwClip	: DWORD;
	dwClipIntersection	: DWORD;
	dwClipUnion	: DWORD;
	drExtent	: D3DRECT;
  end;

  LPD3DLIGHTINGELEMENT	= ^D3DLIGHTINGELEMENT;
  D3DLIGHTINGELEMENT = record
	dvPosition	: D3DVECTOR;
	dvNormal	: D3DVECTOR;
  end;

  LPD3DMATERIAL	= ^D3DMATERIAL;
  D3DMATERIAL = record
	dwSize	: DWORD;
	case Integer of
	0: (
	  diffuse	: D3DCOLORVALUE;
	  ambient	: D3DCOLORVALUE;
	  specular	: D3DCOLORVALUE;
	  emissive	: D3DCOLORVALUE;
	  power	: D3DVALUE;
	  hTexture	: D3DTEXTUREHANDLE;
	  dwRampSize	: DWORD;
	);
	1: (
	  dcvDiffuse	: D3DCOLORVALUE;
	  dcvAmbient	: D3DCOLORVALUE;
	  dcvSpecular	: D3DCOLORVALUE;
	  dcvEmissive	: D3DCOLORVALUE;
	  dvPower	: D3DVALUE;
	);
  end;

  LPD3DMATERIAL7	= ^D3DMATERIAL7;
  D3DMATERIAL7 = record
	case Integer of
	0: (
	  diffuse	: D3DCOLORVALUE;
	  ambient	: D3DCOLORVALUE;
	  specular	: D3DCOLORVALUE;
	  emissive	: D3DCOLORVALUE;
	  power	: D3DVALUE;
	);
	1: (
	  dcvDiffuse	: D3DCOLORVALUE;
	  dcvAmbient	: D3DCOLORVALUE;
	  dcvSpecular	: D3DCOLORVALUE;
	  dcvEmissive	: D3DCOLORVALUE;
	  dvPower	: D3DVALUE;
	);
  end;

  D3DLIGHTTYPE = (
	D3DLIGHTTYPE_Unknown0,
	D3DLIGHT_POINT,
	D3DLIGHT_SPOT,
	D3DLIGHT_DIRECTIONAL,
	D3DLIGHT_PARALLELPOINT,
	D3DLIGHT_GLSPOT
  );

  LPD3DLIGHT	= ^D3DLIGHT;
  D3DLIGHT = record
	dwSize	: DWORD;
	dltType	: D3DLIGHTTYPE;
	dcvColor	: D3DCOLORVALUE;
	dvPosition	: D3DVECTOR;
	dvDirection	: D3DVECTOR;
	dvRange	: D3DVALUE;
	dvFalloff	: D3DVALUE;
	dvAttenuation0	: D3DVALUE;
	dvAttenuation1	: D3DVALUE;
	dvAttenuation2	: D3DVALUE;
	dvTheta	: D3DVALUE;
	dvPhi	: D3DVALUE;
  end;

  LPD3DLIGHT7	= ^D3DLIGHT7;
  D3DLIGHT7 = record
	dltType	: D3DLIGHTTYPE;
	dcvDiffuse	: D3DCOLORVALUE;
	dcvSpecular	: D3DCOLORVALUE;
	dcvAmbient	: D3DCOLORVALUE;
	dvPosition	: D3DVECTOR;
	dvDirection	: D3DVECTOR;
	dvRange	: D3DVALUE;
	dvFalloff	: D3DVALUE;
	dvAttenuation0	: D3DVALUE;
	dvAttenuation1	: D3DVALUE;
	dvAttenuation2	: D3DVALUE;
	dvTheta	: D3DVALUE;
	dvPhi	: D3DVALUE;
  end;

const
  D3DLIGHT_ACTIVE	= $00000001;
  D3DLIGHT_NO_SPECULAR	= $00000002;
  D3DLIGHT_ALL	= ( D3DLIGHT_ACTIVE or D3DLIGHT_NO_SPECULAR );

type
  LPD3DLIGHT2	= ^D3DLIGHT2;
  D3DLIGHT2 = record
	dwSize	: DWORD;
	dltType	: D3DLIGHTTYPE;
	dcvColor	: D3DCOLORVALUE;
	dvPosition	: D3DVECTOR;
	dvDirection	: D3DVECTOR;
	dvRange	: D3DVALUE;
	dvFalloff	: D3DVALUE;
	dvAttenuation0	: D3DVALUE;
	dvAttenuation1	: D3DVALUE;
	dvAttenuation2	: D3DVALUE;
	dvTheta	: D3DVALUE;
	dvPhi	: D3DVALUE;
	dwFlags	: DWORD;
  end;

  LPD3DLIGHTDATA	= ^D3DLIGHTDATA;
  D3DLIGHTDATA = record
	dwSize	: DWORD;
	lpIn	: LPD3DLIGHTINGELEMENT;
	dwInSize	: DWORD;
	lpOut	: LPD3DTLVERTEX;
	dwOutSize	: DWORD;
  end;

const
  D3DCOLOR_MONO	= 1;
  D3DCOLOR_RGB	= 2;

type
  D3DCOLORMODEL	= DWORD;

const
  D3DCLEAR_TARGET	= $00000001;
  D3DCLEAR_ZBUFFER	= $00000002;
  D3DCLEAR_STENCIL	= $00000004;

type
  D3DOPCODE = (
	D3DOPCODE_Unknown0,
	D3DOP_POINT,
	D3DOP_LINE,
	D3DOP_TRIANGLE,
	D3DOP_MATRIXLOAD,
	D3DOP_MATRIXMULTIPLY,
	D3DOP_STATETRANSFORM,
	D3DOP_STATELIGHT,
	D3DOP_STATERENDER,
	D3DOP_PROCESSVERTICES,
	D3DOP_TEXTURELOAD,
	D3DOP_EXIT,
	D3DOP_BRANCHFORWARD,
	D3DOP_SPAN,
	D3DOP_SETSTATUS
  );

  LPD3DINSTRUCTION	= ^D3DINSTRUCTION;
  D3DINSTRUCTION = record
	bOpcode	: BYTE;
	bSize	: BYTE;
	wCount	: WORD;
  end;

  LPD3DTEXTURELOAD	= ^D3DTEXTURELOAD;
  D3DTEXTURELOAD = record
	hDestTexture	: D3DTEXTUREHANDLE;
	hSrcTexture	: D3DTEXTUREHANDLE;
  end;

  LPD3DPICKRECORD	= ^D3DPICKRECORD;
  D3DPICKRECORD = record
	bOpcode	: BYTE;
	bPad	: BYTE;
	dwOffset	: DWORD;
	dvZ	: D3DVALUE;
  end;

  D3DSHADEMODE = (
	D3DSHADEMODE_Unknown0,
	D3DSHADE_FLAT,
	D3DSHADE_GOURAUD,
	D3DSHADE_PHONG
  );

  D3DFILLMODE = (
	D3DFILLMODE_Unknown0,
	D3DFILL_POINT,
	D3DFILL_WIREFRAME,
	D3DFILL_SOLID
  );

  D3DLINEPATTERN = record
	wRepeatFactor	: WORD;
	wLinePattern	: WORD;
  end;

  D3DTEXTUREFILTER = (
	D3DTEXTUREFILTER_Unknown0,
	D3DFILTER_NEAREST,
	D3DFILTER_LINEAR,
	D3DFILTER_MIPNEAREST,
	D3DFILTER_MIPLINEAR,
	D3DFILTER_LINEARMIPNEAREST,
	D3DFILTER_LINEARMIPLINEAR
  );

  D3DBLEND = (
	D3DBLEND_Unknown0,
	D3DBLEND_ZERO,
	D3DBLEND_ONE,
	D3DBLEND_SRCCOLOR,
	D3DBLEND_INVSRCCOLOR,
	D3DBLEND_SRCALPHA,
	D3DBLEND_INVSRCALPHA,
	D3DBLEND_DESTALPHA,
	D3DBLEND_INVDESTALPHA,
	D3DBLEND_DESTCOLOR,
	D3DBLEND_INVDESTCOLOR,
	D3DBLEND_SRCALPHASAT,
	D3DBLEND_BOTHSRCALPHA,
	D3DBLEND_BOTHINVSRCALPHA
  );

  D3DTEXTUREBLEND = (
	D3DTEXTUREBLEND_Unknown0,
	D3DTBLEND_DECAL,
	D3DTBLEND_MODULATE,
	D3DTBLEND_DECALALPHA,
	D3DTBLEND_MODULATEALPHA,
	D3DTBLEND_DECALMASK,
	D3DTBLEND_MODULATEMASK,
	D3DTBLEND_COPY,
	D3DTBLEND_ADD
  );

  D3DTEXTUREADDRESS = (
	D3DTEXTUREADDRESS_Unknown0,
	D3DTADDRESS_WRAP,
	D3DTADDRESS_MIRROR,
	D3DTADDRESS_CLAMP,
	D3DTADDRESS_BORDER
  );

  D3DCULL = (
	D3DCULL_Unknown0,
	D3DCULL_NONE,
	D3DCULL_CW,
	D3DCULL_CCW
  );

  D3DCMPFUNC = (
	D3DCMPFUNC_Unknown0,
	D3DCMP_NEVER,
	D3DCMP_LESS,
	D3DCMP_EQUAL,
	D3DCMP_LESSEQUAL,
	D3DCMP_GREATER,
	D3DCMP_NOTEQUAL,
	D3DCMP_GREATEREQUAL,
	D3DCMP_ALWAYS
  );

  D3DSTENCILOP = (
	D3DSTENCILOP_Unknown0,
	D3DSTENCILOP_KEEP,
	D3DSTENCILOP_ZERO,
	D3DSTENCILOP_REPLACE,
	D3DSTENCILOP_INCRSAT,
	D3DSTENCILOP_DECRSAT,
	D3DSTENCILOP_INVERT,
	D3DSTENCILOP_INCR,
	D3DSTENCILOP_DECR
  );

  D3DFOGMODE = (
	D3DFOG_NONE,
	D3DFOG_EXP,
	D3DFOG_EXP2,
	D3DFOG_LINEAR
  );

  D3DZBUFFERTYPE = (
	D3DZB_FALSE,
	D3DZB_TRUE,
	D3DZB_USEW
  );

  D3DANTIALIASMODE = (
	D3DANTIALIAS_NONE,
	D3DANTIALIAS_SORTDEPENDENT,
	D3DANTIALIAS_SORTINDEPENDENT
  );

  D3DVERTEXTYPE = (
	D3DVERTEXTYPE_Unknown0,
	D3DVT_VERTEX,
	D3DVT_LVERTEX,
	D3DVT_TLVERTEX
  );

  D3DPRIMITIVETYPE = (
	D3DPRIMITIVETYPE_Unknown0,
	D3DPT_POINTLIST,
	D3DPT_LINELIST,
	D3DPT_LINESTRIP,
	D3DPT_TRIANGLELIST,
	D3DPT_TRIANGLESTRIP,
	D3DPT_TRIANGLEFAN
  );

const
  D3DSTATE_OVERRIDE_BIAS	= 256;

type
  D3DTRANSFORMSTATETYPE = (
	D3DTRANSFORMSTATETYPE_Unknown0,
	D3DTRANSFORMSTATE_WORLD,
	D3DTRANSFORMSTATE_VIEW,
	D3DTRANSFORMSTATE_PROJECTION,
	D3DTRANSFORMSTATE_WORLD1,
	D3DTRANSFORMSTATE_WORLD2,
	D3DTRANSFORMSTATE_WORLD3,
	D3DTRANSFORMSTATETYPE_Unknown7,
	D3DTRANSFORMSTATETYPE_Unknown8,
	D3DTRANSFORMSTATETYPE_Unknown9,
	D3DTRANSFORMSTATETYPE_Unknown10,
	D3DTRANSFORMSTATETYPE_Unknown11,
	D3DTRANSFORMSTATETYPE_Unknown12,
	D3DTRANSFORMSTATETYPE_Unknown13,
	D3DTRANSFORMSTATETYPE_Unknown14,
	D3DTRANSFORMSTATETYPE_Unknown15,
	D3DTRANSFORMSTATE_TEXTURE0,
	D3DTRANSFORMSTATE_TEXTURE1,
	D3DTRANSFORMSTATE_TEXTURE2,
	D3DTRANSFORMSTATE_TEXTURE3,
	D3DTRANSFORMSTATE_TEXTURE4,
	D3DTRANSFORMSTATE_TEXTURE5,
	D3DTRANSFORMSTATE_TEXTURE6,
	D3DTRANSFORMSTATE_TEXTURE7
  );

  D3DLIGHTSTATETYPE = (
	D3DLIGHTSTATETYPE_Unknown0,
	D3DLIGHTSTATE_MATERIAL,
	D3DLIGHTSTATE_AMBIENT,
	D3DLIGHTSTATE_COLORMODEL,
	D3DLIGHTSTATE_FOGMODE,
	D3DLIGHTSTATE_FOGSTART,
	D3DLIGHTSTATE_FOGEND,
	D3DLIGHTSTATE_FOGDENSITY,
	D3DLIGHTSTATE_COLORVERTEX
  );

const
    D3DRENDERSTATE_TEXTUREHANDLE      = 1;
    D3DRENDERSTATE_ANTIALIAS          = 2;
    D3DRENDERSTATE_TEXTUREADDRESS     = 3;
    D3DRENDERSTATE_TEXTUREPERSPECTIVE = 4;
    D3DRENDERSTATE_WRAPU          = 5;
    D3DRENDERSTATE_WRAPV          = 6;
    D3DRENDERSTATE_ZENABLE            = 7;
    D3DRENDERSTATE_FILLMODE           = 8;
    D3DRENDERSTATE_SHADEMODE          = 9;
    D3DRENDERSTATE_LINEPATTERN        = 10;
    D3DRENDERSTATE_MONOENABLE         = 11;
    D3DRENDERSTATE_ROP2               = 12;
    D3DRENDERSTATE_PLANEMASK          = 13;
    D3DRENDERSTATE_ZWRITEENABLE       = 14;
    D3DRENDERSTATE_ALPHATESTENABLE    = 15;
    D3DRENDERSTATE_LASTPIXEL          = 16;
    D3DRENDERSTATE_TEXTUREMAG         = 17;
    D3DRENDERSTATE_TEXTUREMIN         = 18;
    D3DRENDERSTATE_SRCBLEND           = 19;
    D3DRENDERSTATE_DESTBLEND          = 20;
    D3DRENDERSTATE_TEXTUREMAPBLEND    = 21;
    D3DRENDERSTATE_CULLMODE           = 22;
    D3DRENDERSTATE_ZFUNC              = 23;
    D3DRENDERSTATE_ALPHAREF           = 24;
    D3DRENDERSTATE_ALPHAFUNC          = 25;
    D3DRENDERSTATE_DITHERENABLE       = 26;
    D3DRENDERSTATE_ALPHABLENDENABLE   = 27;
    D3DRENDERSTATE_FOGENABLE          = 28;
    D3DRENDERSTATE_SPECULARENABLE     = 29;
    D3DRENDERSTATE_ZVISIBLE           = 30;
    D3DRENDERSTATE_SUBPIXEL           = 31;
    D3DRENDERSTATE_SUBPIXELX          = 32;
    D3DRENDERSTATE_STIPPLEDALPHA      = 33;
    D3DRENDERSTATE_FOGCOLOR           = 34;
    D3DRENDERSTATE_FOGTABLEMODE       = 35;
    D3DRENDERSTATE_FOGTABLESTART      = 36;
    D3DRENDERSTATE_FOGTABLEEND        = 37;
    D3DRENDERSTATE_FOGTABLEDENSITY    = 38;
    D3DRENDERSTATE_FOGSTART           = 36;
    D3DRENDERSTATE_FOGEND             = 37;
    D3DRENDERSTATE_FOGDENSITY         = 38;
    D3DRENDERSTATE_STIPPLEENABLE      = 39;
  D3DRENDERSTATE_EDGEANTIALIAS = 40 ;
  D3DRENDERSTATE_COLORKEYENABLE = 41 ;
  D3DRENDERSTATE_BORDERCOLOR = 43 ;
  D3DRENDERSTATE_TEXTUREADDRESSU = 44 ;
  D3DRENDERSTATE_TEXTUREADDRESSV = 45 ;
  D3DRENDERSTATE_MIPMAPLODBIAS = 46 ;
  D3DRENDERSTATE_ZBIAS = 47 ;
  D3DRENDERSTATE_RANGEFOGENABLE = 48 ;
  D3DRENDERSTATE_ANISOTROPY = 49 ;
  D3DRENDERSTATE_FLUSHBATCH = 50 ;
  D3DRENDERSTATE_TRANSLUCENTSORTINDEPENDENT = 51 ;
  D3DRENDERSTATE_STENCILENABLE = 52 ;
  D3DRENDERSTATE_STENCILFAIL = 53 ;
  D3DRENDERSTATE_STENCILZFAIL = 54 ;
  D3DRENDERSTATE_STENCILPASS = 55 ;
  D3DRENDERSTATE_STENCILFUNC = 56 ;
  D3DRENDERSTATE_STENCILREF = 57 ;
  D3DRENDERSTATE_STENCILMASK = 58 ;
  D3DRENDERSTATE_STENCILWRITEMASK = 59 ;
  D3DRENDERSTATE_TEXTUREFACTOR = 60 ;
  D3DRENDERSTATE_STIPPLEPATTERN00 = 64 ;
  D3DRENDERSTATE_STIPPLEPATTERN01 = 65 ;
  D3DRENDERSTATE_STIPPLEPATTERN02 = 66 ;
  D3DRENDERSTATE_STIPPLEPATTERN03 = 67 ;
  D3DRENDERSTATE_STIPPLEPATTERN04 = 68 ;
  D3DRENDERSTATE_STIPPLEPATTERN05 = 69 ;
  D3DRENDERSTATE_STIPPLEPATTERN06 = 70 ;
  D3DRENDERSTATE_STIPPLEPATTERN07 = 71 ;
  D3DRENDERSTATE_STIPPLEPATTERN08 = 72 ;
  D3DRENDERSTATE_STIPPLEPATTERN09 = 73 ;
  D3DRENDERSTATE_STIPPLEPATTERN10 = 74 ;
  D3DRENDERSTATE_STIPPLEPATTERN11 = 75 ;
  D3DRENDERSTATE_STIPPLEPATTERN12 = 76 ;
  D3DRENDERSTATE_STIPPLEPATTERN13 = 77 ;
  D3DRENDERSTATE_STIPPLEPATTERN14 = 78 ;
  D3DRENDERSTATE_STIPPLEPATTERN15 = 79 ;
  D3DRENDERSTATE_STIPPLEPATTERN16 = 80 ;
  D3DRENDERSTATE_STIPPLEPATTERN17 = 81 ;
  D3DRENDERSTATE_STIPPLEPATTERN18 = 82 ;
  D3DRENDERSTATE_STIPPLEPATTERN19 = 83 ;
  D3DRENDERSTATE_STIPPLEPATTERN20 = 84 ;
  D3DRENDERSTATE_STIPPLEPATTERN21 = 85 ;
  D3DRENDERSTATE_STIPPLEPATTERN22 = 86 ;
  D3DRENDERSTATE_STIPPLEPATTERN23 = 87 ;
  D3DRENDERSTATE_STIPPLEPATTERN24 = 88 ;
  D3DRENDERSTATE_STIPPLEPATTERN25 = 89 ;
  D3DRENDERSTATE_STIPPLEPATTERN26 = 90 ;
  D3DRENDERSTATE_STIPPLEPATTERN27 = 91 ;
  D3DRENDERSTATE_STIPPLEPATTERN28 = 92 ;
  D3DRENDERSTATE_STIPPLEPATTERN29 = 93 ;
  D3DRENDERSTATE_STIPPLEPATTERN30 = 94 ;
  D3DRENDERSTATE_STIPPLEPATTERN31 = 95 ;
  D3DRENDERSTATE_WRAP0 = 128 ;
  D3DRENDERSTATE_WRAP1 = 129 ;
  D3DRENDERSTATE_WRAP2 = 130 ;
  D3DRENDERSTATE_WRAP3 = 131 ;
  D3DRENDERSTATE_WRAP4 = 132 ;
  D3DRENDERSTATE_WRAP5 = 133 ;
  D3DRENDERSTATE_WRAP6 = 134 ;
  D3DRENDERSTATE_WRAP7 = 135 ;
  D3DRENDERSTATE_CLIPPING = 136 ;
  D3DRENDERSTATE_LIGHTING = 137 ;
  D3DRENDERSTATE_EXTENTS = 138 ;
  D3DRENDERSTATE_AMBIENT = 139 ;
  D3DRENDERSTATE_FOGVERTEXMODE = 140 ;
  D3DRENDERSTATE_COLORVERTEX = 141 ;
  D3DRENDERSTATE_LOCALVIEWER = 142 ;
  D3DRENDERSTATE_NORMALIZENORMALS = 143 ;
  D3DRENDERSTATE_COLORKEYBLENDENABLE = 144 ;
  D3DRENDERSTATE_DIFFUSEMATERIALSOURCE = 145 ;
  D3DRENDERSTATE_SPECULARMATERIALSOURCE = 146 ;
  D3DRENDERSTATE_AMBIENTMATERIALSOURCE = 147 ;
  D3DRENDERSTATE_EMISSIVEMATERIALSOURCE = 148 ;
  D3DRENDERSTATE_VERTEXBLEND = 151 ;
  D3DRENDERSTATE_CLIPPLANEENABLE = 152 ;
  D3DRENDERSTATE_FORCE_DWORD = $7fffffff ;

type

  D3DRENDERSTATETYPE = Integer;

type
  D3DMATERIALCOLORSOURCE = (
	D3DMCS_MATERIAL,
	D3DMCS_COLOR1,
	D3DMCS_COLOR2
  );

const
  D3DRENDERSTATE_BLENDENABLE	= D3DRENDERSTATE_ALPHABLENDENABLE;
  D3DRENDERSTATE_WRAPBIAS	= 128;
  D3DWRAP_U	= $00000001;
  D3DWRAP_V	= $00000002;
  D3DWRAPCOORD_0	= $00000001;
  D3DWRAPCOORD_1	= $00000002;
  D3DWRAPCOORD_2	= $00000004;
  D3DWRAPCOORD_3	= $00000008;

type
  LPD3DSTATE	= ^D3DSTATE;
  D3DSTATE = record
	case Integer of
	0: (
	  dtstTransformStateType	: D3DTRANSFORMSTATETYPE;
	  dwArg	: array[0..0] of DWORD;
	);
	1: (
	  dlstLightStateType	: D3DLIGHTSTATETYPE;
	  dvArg	: array[0..0] of D3DVALUE;
	);
	2: (
	  drstRenderStateType	: D3DRENDERSTATETYPE;
	);
  end;

  LPD3DMATRIXLOAD	= ^D3DMATRIXLOAD;
  D3DMATRIXLOAD = record
	hDestMatrix	: D3DMATRIXHANDLE;
	hSrcMatrix	: D3DMATRIXHANDLE;
  end;

  LPD3DMATRIXMULTIPLY	= ^D3DMATRIXMULTIPLY;
  D3DMATRIXMULTIPLY = record
	hDestMatrix	: D3DMATRIXHANDLE;
	hSrcMatrix1	: D3DMATRIXHANDLE;
	hSrcMatrix2	: D3DMATRIXHANDLE;
  end;

  LPD3DPROCESSVERTICES	= ^D3DPROCESSVERTICES;
  D3DPROCESSVERTICES = record
	dwFlags	: DWORD;
	wStart	: WORD;
	wDest	: WORD;
	dwCount	: DWORD;
	dwReserved	: DWORD;
  end;

const
  D3DPROCESSVERTICES_TRANSFORMLIGHT	= $00000000;
  D3DPROCESSVERTICES_TRANSFORM	= $00000001;
  D3DPROCESSVERTICES_COPY	= $00000002;
  D3DPROCESSVERTICES_OPMASK	= $00000007;

  D3DPROCESSVERTICES_UPDATEEXTENTS	= $00000008;
  D3DPROCESSVERTICES_NOCOLOR	= $00000010;

type
  D3DTEXTURESTAGESTATETYPE = (
	D3DTEXTURESTAGESTATETYPE_Unknown0,
	D3DTSS_COLOROP,
	D3DTSS_COLORARG1,
	D3DTSS_COLORARG2,
	D3DTSS_ALPHAOP,
	D3DTSS_ALPHAARG1,
	D3DTSS_ALPHAARG2,
	D3DTSS_BUMPENVMAT00,
	D3DTSS_BUMPENVMAT01,
	D3DTSS_BUMPENVMAT10,
	D3DTSS_BUMPENVMAT11,
	D3DTSS_TEXCOORDINDEX,
	D3DTSS_ADDRESS,
	D3DTSS_ADDRESSU,
	D3DTSS_ADDRESSV,
	D3DTSS_BORDERCOLOR,
	D3DTSS_MAGFILTER,
	D3DTSS_MINFILTER,
	D3DTSS_MIPFILTER,
	D3DTSS_MIPMAPLODBIAS,
	D3DTSS_MAXMIPLEVEL,
	D3DTSS_MAXANISOTROPY,
	D3DTSS_BUMPENVLSCALE,
	D3DTSS_BUMPENVLOFFSET,
	D3DTSS_TEXTURETRANSFORMFLAGS
  );

  D3DTEXTUREOP = (
	D3DTEXTUREOP_Unknown0,
	D3DTOP_DISABLE,
	D3DTOP_SELECTARG1,
	D3DTOP_SELECTARG2,
	D3DTOP_MODULATE,
	D3DTOP_MODULATE2X,
	D3DTOP_MODULATE4X,
	D3DTOP_ADD,
	D3DTOP_ADDSIGNED,
	D3DTOP_ADDSIGNED2X,
	D3DTOP_SUBTRACT,
	D3DTOP_ADDSMOOTH,
	D3DTOP_BLENDDIFFUSEALPHA,
	D3DTOP_BLENDTEXTUREALPHA,
	D3DTOP_BLENDFACTORALPHA,
	D3DTOP_BLENDTEXTUREALPHAPM,
	D3DTOP_BLENDCURRENTALPHA,
	D3DTOP_PREMODULATE,
	D3DTOP_MODULATEALPHA_ADDCOLOR,
	D3DTOP_MODULATECOLOR_ADDALPHA,
	D3DTOP_MODULATEINVALPHA_ADDCOLOR,
	D3DTOP_MODULATEINVCOLOR_ADDALPHA,
	D3DTOP_BUMPENVMAP,
	D3DTOP_BUMPENVMAPLUMINANCE,
	D3DTOP_DOTPRODUCT3
  );

const
  D3DTA_SELECTMASK	= $0000000f;
  D3DTA_DIFFUSE	= $00000000;
  D3DTA_CURRENT	= $00000001;
  D3DTA_TEXTURE	= $00000002;
  D3DTA_TFACTOR	= $00000003;
  D3DTA_SPECULAR	= $00000004;
  D3DTA_COMPLEMENT	= $00000010;
  D3DTA_ALPHAREPLICATE	= $00000020;

type
  D3DTEXTUREMAGFILTER = (
	D3DTEXTUREMAGFILTER_Unknown0,
	D3DTFG_POINT,
	D3DTFG_LINEAR,
	D3DTFG_FLATCUBIC,
	D3DTFG_GAUSSIANCUBIC,
	D3DTFG_ANISOTROPIC
  );

  D3DTEXTUREMINFILTER = (
	D3DTEXTUREMINFILTER_Unknown0,
	D3DTFN_POINT,
	D3DTFN_LINEAR,
	D3DTFN_ANISOTROPIC
  );

  D3DTEXTUREMIPFILTER = (
	D3DTEXTUREMIPFILTER_Unknown0,
	D3DTFP_NONE,
	D3DTFP_POINT,
	D3DTFP_LINEAR
  );

const
  D3DTRIFLAG_START	= $00000000;
  D3DTRIFLAG_ODD	= $0000001e;
  D3DTRIFLAG_EVEN	= $0000001f;
  D3DTRIFLAG_EDGEENABLE1	= $00000100;
  D3DTRIFLAG_EDGEENABLE2	= $00000200;
  D3DTRIFLAG_EDGEENABLE3	= $00000400;
  D3DTRIFLAG_EDGEENABLETRIANGLE	= ( D3DTRIFLAG_EDGEENABLE1 or D3DTRIFLAG_EDGEENABLE2 or
         D3DTRIFLAG_EDGEENABLE3 );

type
  LPD3DTRIANGLE	= ^D3DTRIANGLE;
  D3DTRIANGLE = record
	case Integer of
	0: (
	  v1	: WORD;
	  v2	: WORD;
	  v3	: WORD;
	  wFlags	: WORD;
	);
	1: (
	  wV1	: WORD;
	  wV2	: WORD;
	  wV3	: WORD;
	);
  end;

  LPD3DLINE	= ^D3DLINE;
  D3DLINE = record
	case Integer of
	0: (
	  v1	: WORD;
	  v2	: WORD;
	);
	1: (
	  wV1	: WORD;
	  wV2	: WORD;
	);
  end;

  LPD3DSPAN	= ^D3DSPAN;
  D3DSPAN = record
	wCount	: WORD;
	wFirst	: WORD;
  end;

  LPD3DPOINT	= ^D3DPOINT;
  D3DPOINT = record
	wCount	: WORD;
	wFirst	: WORD;
  end;

  LPD3DBRANCH	= ^D3DBRANCH;
  D3DBRANCH = record
	dwMask	: DWORD;
	dwValue	: DWORD;
	bNegate	: BOOL;
	dwOffset	: DWORD;
  end;

  LPD3DSTATUS	= ^D3DSTATUS;
  D3DSTATUS = record
	dwFlags	: DWORD;
	dwStatus	: DWORD;
	drExtent	: D3DRECT;
  end;

const
  D3DSETSTATUS_STATUS	= $00000001;
  D3DSETSTATUS_EXTENTS	= $00000002;
  D3DSETSTATUS_ALL	= ( D3DSETSTATUS_STATUS or D3DSETSTATUS_EXTENTS );

type
  LPD3DCLIPSTATUS	= ^D3DCLIPSTATUS;
  D3DCLIPSTATUS = record
	dwFlags	: DWORD;
	dwStatus	: DWORD;
	minx, maxx	: Single;
	miny, maxy	: Single;
	minz, maxz	: Single;
  end;

const
  D3DCLIPSTATUS_STATUS	= $00000001;
  D3DCLIPSTATUS_EXTENTS2	= $00000002;
  D3DCLIPSTATUS_EXTENTS3	= $00000004;

type
  LPD3DSTATS	= ^D3DSTATS;
  D3DSTATS = record
	dwSize	: DWORD;
	dwTrianglesDrawn	: DWORD;
	dwLinesDrawn	: DWORD;
	dwPointsDrawn	: DWORD;
	dwSpansDrawn	: DWORD;
	dwVerticesProcessed	: DWORD;
  end;

const
  D3DEXECUTE_CLIPPED	= $00000001;
  D3DEXECUTE_UNCLIPPED	= $00000002;

type
  LPD3DEXECUTEDATA	= ^D3DEXECUTEDATA;
  D3DEXECUTEDATA = record
	dwSize	: DWORD;
	dwVertexOffset	: DWORD;
	dwVertexCount	: DWORD;
	dwInstructionOffset	: DWORD;
	dwInstructionLength	: DWORD;
	dwHVertexOffset	: DWORD;
	dsStatus	: D3DSTATUS;
  end;

const
  D3DPAL_FREE	= $00;
  D3DPAL_READONLY	= $40;
  D3DPAL_RESERVED	= $80;

type
  LPD3DVERTEXBUFFERDESC	= ^D3DVERTEXBUFFERDESC;
  D3DVERTEXBUFFERDESC = record
	dwSize	: DWORD;
	dwCaps	: DWORD;
	dwFVF	: DWORD;
	dwNumVertices	: DWORD;
  end;

const
  D3DVBCAPS_SYSTEMMEMORY	= $00000800;
  D3DVBCAPS_WRITEONLY	= $00010000;
  D3DVBCAPS_OPTIMIZED	= $80000000;
  D3DVBCAPS_DONOTCLIP	= $00000001;

  D3DVOP_LIGHT	= $00000400;
  D3DVOP_TRANSFORM	= $00000001;
  D3DVOP_CLIP	= $00000004;
  D3DVOP_EXTENTS	= $00000008;
  D3DMAXNUMVERTICES	= (( 1 shl 16 ) - 1 );
  D3DMAXNUMPRIMITIVES	= (( 1 shl 16 ) - 1 );
  D3DPV_DONOTCOPYDATA	= $00000001;
  D3DFVF_RESERVED0	= $001;
  D3DFVF_POSITION_MASK	= $00E;
  D3DFVF_XYZ	= $002;
  D3DFVF_XYZRHW	= $004;
  D3DFVF_XYZB1	= $006;
  D3DFVF_XYZB2	= $008;
  D3DFVF_XYZB3	= $00a;
  D3DFVF_XYZB4	= $00c;
  D3DFVF_XYZB5	= $00e;
  D3DFVF_NORMAL	= $010;
  D3DFVF_RESERVED1	= $020;
  D3DFVF_DIFFUSE	= $040;
  D3DFVF_SPECULAR	= $080;
  D3DFVF_TEXCOUNT_MASK	= $f00;
  D3DFVF_TEXCOUNT_SHIFT	= 8;
  D3DFVF_TEX0	= $000;
  D3DFVF_TEX1	= $100;
  D3DFVF_TEX2	= $200;
  D3DFVF_TEX3	= $300;
  D3DFVF_TEX4	= $400;
  D3DFVF_TEX5	= $500;
  D3DFVF_TEX6	= $600;
  D3DFVF_TEX7	= $700;
  D3DFVF_TEX8	= $800;
  D3DFVF_RESERVED2	= $f000;
  D3DFVF_VERTEX	= ( D3DFVF_XYZ or D3DFVF_NORMAL or D3DFVF_TEX1 );
  D3DFVF_LVERTEX	= ( D3DFVF_XYZ or D3DFVF_RESERVED1 or D3DFVF_DIFFUSE or D3DFVF_SPECULAR or
         D3DFVF_TEX1 );
  D3DFVF_TLVERTEX	= ( D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_SPECULAR or D3DFVF_TEX1
         );

type
  D3DDP_PTRSTRIDE = record
	lpvData	: Pointer;
	dwStride	: DWORD;
  end;

const
  D3DDP_MAXTEXCOORD	= 8;

type
  LPD3DDRAWPRIMITIVESTRIDEDDATA	= ^D3DDRAWPRIMITIVESTRIDEDDATA;
  D3DDRAWPRIMITIVESTRIDEDDATA = record
	position	: D3DDP_PTRSTRIDE;
	normal	: D3DDP_PTRSTRIDE;
	diffuse	: D3DDP_PTRSTRIDE;
	specular	: D3DDP_PTRSTRIDE;
	textureCoords	: array[0..D3DDP_MAXTEXCOORD-1] of D3DDP_PTRSTRIDE;
  end;

const
  D3DVIS_INSIDE_FRUSTUM	= 0;
  D3DVIS_INTERSECT_FRUSTUM	= 1;
  D3DVIS_OUTSIDE_FRUSTUM	= 2;
  D3DVIS_INSIDE_LEFT	= 0;
  D3DVIS_INTERSECT_LEFT	= $00000004;
  D3DVIS_OUTSIDE_LEFT	= $00000008;
  D3DVIS_INSIDE_RIGHT	= 0;
  D3DVIS_INTERSECT_RIGHT	= $00000010;
  D3DVIS_OUTSIDE_RIGHT	= $00000020;
  D3DVIS_INSIDE_TOP	= 0;
  D3DVIS_INTERSECT_TOP	= $00000040;
  D3DVIS_OUTSIDE_TOP	= $00000080;
  D3DVIS_INSIDE_BOTTOM	= 0;
  D3DVIS_INTERSECT_BOTTOM	= $00000100;
  D3DVIS_OUTSIDE_BOTTOM	= $00000200;
  D3DVIS_INSIDE_NEAR	= 0;
  D3DVIS_INTERSECT_NEAR	= $00000400;
  D3DVIS_OUTSIDE_NEAR	= $00000800;
  D3DVIS_INSIDE_FAR	= 0;
  D3DVIS_INTERSECT_FAR	= $00001000;
  D3DVIS_OUTSIDE_FAR	= $00002000;
  D3DVIS_MASK_FRUSTUM	= $00000003;
  D3DVIS_MASK_LEFT	= $0000000C;
  D3DVIS_MASK_RIGHT	= $00000030;
  D3DVIS_MASK_TOP	= $000000C0;
  D3DVIS_MASK_BOTTOM	= $00000300;
  D3DVIS_MASK_NEAR	= $00000C00;
  D3DVIS_MASK_FAR	= $00003000;
  D3DDEVINFOID_TEXTUREMANAGER	= 1;
  D3DDEVINFOID_D3DTEXTUREMANAGER	= 2;

type
  D3DVERTEXBLENDFLAGS = (
	D3DVBLEND_DISABLE,
	D3DVBLEND_1WEIGHT,
	D3DVBLEND_2WEIGHTS,
	D3DVBLEND_3WEIGHTS
  );

  D3DTEXTURETRANSFORMFLAGS = (
	D3DTTFF_DISABLE,
	D3DTTFF_COUNT1,
	D3DTTFF_COUNT2,
	D3DTTFF_COUNT3,
	D3DTTFF_COUNT4,
	D3DTEXTURETRANSFORMFLAGS_Unknown5,
	D3DTEXTURETRANSFORMFLAGS_Unknown6,
	D3DTEXTURETRANSFORMFLAGS_Unknown7,
	D3DTEXTURETRANSFORMFLAGS_Unknown8,
	D3DTEXTURETRANSFORMFLAGS_Unknown9,
	D3DTEXTURETRANSFORMFLAGS_Unknown10,
	D3DTEXTURETRANSFORMFLAGS_Unknown11,
	D3DTEXTURETRANSFORMFLAGS_Unknown12,
	D3DTEXTURETRANSFORMFLAGS_Unknown13,
	D3DTEXTURETRANSFORMFLAGS_Unknown14,
	D3DTEXTURETRANSFORMFLAGS_Unknown15,
	D3DTEXTURETRANSFORMFLAGS_Unknown16,
	D3DTEXTURETRANSFORMFLAGS_Unknown17,
	D3DTEXTURETRANSFORMFLAGS_Unknown18,
	D3DTEXTURETRANSFORMFLAGS_Unknown19,
	D3DTEXTURETRANSFORMFLAGS_Unknown20,
	D3DTEXTURETRANSFORMFLAGS_Unknown21,
	D3DTEXTURETRANSFORMFLAGS_Unknown22,
	D3DTEXTURETRANSFORMFLAGS_Unknown23,
	D3DTEXTURETRANSFORMFLAGS_Unknown24,
	D3DTEXTURETRANSFORMFLAGS_Unknown25,
	D3DTEXTURETRANSFORMFLAGS_Unknown26,
	D3DTEXTURETRANSFORMFLAGS_Unknown27,
	D3DTEXTURETRANSFORMFLAGS_Unknown28,
	D3DTEXTURETRANSFORMFLAGS_Unknown29,
	D3DTEXTURETRANSFORMFLAGS_Unknown30,
	D3DTEXTURETRANSFORMFLAGS_Unknown31,
	D3DTEXTURETRANSFORMFLAGS_Unknown32,
	D3DTEXTURETRANSFORMFLAGS_Unknown33,
	D3DTEXTURETRANSFORMFLAGS_Unknown34,
	D3DTEXTURETRANSFORMFLAGS_Unknown35,
	D3DTEXTURETRANSFORMFLAGS_Unknown36,
	D3DTEXTURETRANSFORMFLAGS_Unknown37,
	D3DTEXTURETRANSFORMFLAGS_Unknown38,
	D3DTEXTURETRANSFORMFLAGS_Unknown39,
	D3DTEXTURETRANSFORMFLAGS_Unknown40,
	D3DTEXTURETRANSFORMFLAGS_Unknown41,
	D3DTEXTURETRANSFORMFLAGS_Unknown42,
	D3DTEXTURETRANSFORMFLAGS_Unknown43,
	D3DTEXTURETRANSFORMFLAGS_Unknown44,
	D3DTEXTURETRANSFORMFLAGS_Unknown45,
	D3DTEXTURETRANSFORMFLAGS_Unknown46,
	D3DTEXTURETRANSFORMFLAGS_Unknown47,
	D3DTEXTURETRANSFORMFLAGS_Unknown48,
	D3DTEXTURETRANSFORMFLAGS_Unknown49,
	D3DTEXTURETRANSFORMFLAGS_Unknown50,
	D3DTEXTURETRANSFORMFLAGS_Unknown51,
	D3DTEXTURETRANSFORMFLAGS_Unknown52,
	D3DTEXTURETRANSFORMFLAGS_Unknown53,
	D3DTEXTURETRANSFORMFLAGS_Unknown54,
	D3DTEXTURETRANSFORMFLAGS_Unknown55,
	D3DTEXTURETRANSFORMFLAGS_Unknown56,
	D3DTEXTURETRANSFORMFLAGS_Unknown57,
	D3DTEXTURETRANSFORMFLAGS_Unknown58,
	D3DTEXTURETRANSFORMFLAGS_Unknown59,
	D3DTEXTURETRANSFORMFLAGS_Unknown60,
	D3DTEXTURETRANSFORMFLAGS_Unknown61,
	D3DTEXTURETRANSFORMFLAGS_Unknown62,
	D3DTEXTURETRANSFORMFLAGS_Unknown63,
	D3DTEXTURETRANSFORMFLAGS_Unknown64,
	D3DTEXTURETRANSFORMFLAGS_Unknown65,
	D3DTEXTURETRANSFORMFLAGS_Unknown66,
	D3DTEXTURETRANSFORMFLAGS_Unknown67,
	D3DTEXTURETRANSFORMFLAGS_Unknown68,
	D3DTEXTURETRANSFORMFLAGS_Unknown69,
	D3DTEXTURETRANSFORMFLAGS_Unknown70,
	D3DTEXTURETRANSFORMFLAGS_Unknown71,
	D3DTEXTURETRANSFORMFLAGS_Unknown72,
	D3DTEXTURETRANSFORMFLAGS_Unknown73,
	D3DTEXTURETRANSFORMFLAGS_Unknown74,
	D3DTEXTURETRANSFORMFLAGS_Unknown75,
	D3DTEXTURETRANSFORMFLAGS_Unknown76,
	D3DTEXTURETRANSFORMFLAGS_Unknown77,
	D3DTEXTURETRANSFORMFLAGS_Unknown78,
	D3DTEXTURETRANSFORMFLAGS_Unknown79,
	D3DTEXTURETRANSFORMFLAGS_Unknown80,
	D3DTEXTURETRANSFORMFLAGS_Unknown81,
	D3DTEXTURETRANSFORMFLAGS_Unknown82,
	D3DTEXTURETRANSFORMFLAGS_Unknown83,
	D3DTEXTURETRANSFORMFLAGS_Unknown84,
	D3DTEXTURETRANSFORMFLAGS_Unknown85,
	D3DTEXTURETRANSFORMFLAGS_Unknown86,
	D3DTEXTURETRANSFORMFLAGS_Unknown87,
	D3DTEXTURETRANSFORMFLAGS_Unknown88,
	D3DTEXTURETRANSFORMFLAGS_Unknown89,
	D3DTEXTURETRANSFORMFLAGS_Unknown90,
	D3DTEXTURETRANSFORMFLAGS_Unknown91,
	D3DTEXTURETRANSFORMFLAGS_Unknown92,
	D3DTEXTURETRANSFORMFLAGS_Unknown93,
	D3DTEXTURETRANSFORMFLAGS_Unknown94,
	D3DTEXTURETRANSFORMFLAGS_Unknown95,
	D3DTEXTURETRANSFORMFLAGS_Unknown96,
	D3DTEXTURETRANSFORMFLAGS_Unknown97,
	D3DTEXTURETRANSFORMFLAGS_Unknown98,
	D3DTEXTURETRANSFORMFLAGS_Unknown99,
	D3DTEXTURETRANSFORMFLAGS_Unknown100,
	D3DTEXTURETRANSFORMFLAGS_Unknown101,
	D3DTEXTURETRANSFORMFLAGS_Unknown102,
	D3DTEXTURETRANSFORMFLAGS_Unknown103,
	D3DTEXTURETRANSFORMFLAGS_Unknown104,
	D3DTEXTURETRANSFORMFLAGS_Unknown105,
	D3DTEXTURETRANSFORMFLAGS_Unknown106,
	D3DTEXTURETRANSFORMFLAGS_Unknown107,
	D3DTEXTURETRANSFORMFLAGS_Unknown108,
	D3DTEXTURETRANSFORMFLAGS_Unknown109,
	D3DTEXTURETRANSFORMFLAGS_Unknown110,
	D3DTEXTURETRANSFORMFLAGS_Unknown111,
	D3DTEXTURETRANSFORMFLAGS_Unknown112,
	D3DTEXTURETRANSFORMFLAGS_Unknown113,
	D3DTEXTURETRANSFORMFLAGS_Unknown114,
	D3DTEXTURETRANSFORMFLAGS_Unknown115,
	D3DTEXTURETRANSFORMFLAGS_Unknown116,
	D3DTEXTURETRANSFORMFLAGS_Unknown117,
	D3DTEXTURETRANSFORMFLAGS_Unknown118,
	D3DTEXTURETRANSFORMFLAGS_Unknown119,
	D3DTEXTURETRANSFORMFLAGS_Unknown120,
	D3DTEXTURETRANSFORMFLAGS_Unknown121,
	D3DTEXTURETRANSFORMFLAGS_Unknown122,
	D3DTEXTURETRANSFORMFLAGS_Unknown123,
	D3DTEXTURETRANSFORMFLAGS_Unknown124,
	D3DTEXTURETRANSFORMFLAGS_Unknown125,
	D3DTEXTURETRANSFORMFLAGS_Unknown126,
	D3DTEXTURETRANSFORMFLAGS_Unknown127,
	D3DTEXTURETRANSFORMFLAGS_Unknown128,
	D3DTEXTURETRANSFORMFLAGS_Unknown129,
	D3DTEXTURETRANSFORMFLAGS_Unknown130,
	D3DTEXTURETRANSFORMFLAGS_Unknown131,
	D3DTEXTURETRANSFORMFLAGS_Unknown132,
	D3DTEXTURETRANSFORMFLAGS_Unknown133,
	D3DTEXTURETRANSFORMFLAGS_Unknown134,
	D3DTEXTURETRANSFORMFLAGS_Unknown135,
	D3DTEXTURETRANSFORMFLAGS_Unknown136,
	D3DTEXTURETRANSFORMFLAGS_Unknown137,
	D3DTEXTURETRANSFORMFLAGS_Unknown138,
	D3DTEXTURETRANSFORMFLAGS_Unknown139,
	D3DTEXTURETRANSFORMFLAGS_Unknown140,
	D3DTEXTURETRANSFORMFLAGS_Unknown141,
	D3DTEXTURETRANSFORMFLAGS_Unknown142,
	D3DTEXTURETRANSFORMFLAGS_Unknown143,
	D3DTEXTURETRANSFORMFLAGS_Unknown144,
	D3DTEXTURETRANSFORMFLAGS_Unknown145,
	D3DTEXTURETRANSFORMFLAGS_Unknown146,
	D3DTEXTURETRANSFORMFLAGS_Unknown147,
	D3DTEXTURETRANSFORMFLAGS_Unknown148,
	D3DTEXTURETRANSFORMFLAGS_Unknown149,
	D3DTEXTURETRANSFORMFLAGS_Unknown150,
	D3DTEXTURETRANSFORMFLAGS_Unknown151,
	D3DTEXTURETRANSFORMFLAGS_Unknown152,
	D3DTEXTURETRANSFORMFLAGS_Unknown153,
	D3DTEXTURETRANSFORMFLAGS_Unknown154,
	D3DTEXTURETRANSFORMFLAGS_Unknown155,
	D3DTEXTURETRANSFORMFLAGS_Unknown156,
	D3DTEXTURETRANSFORMFLAGS_Unknown157,
	D3DTEXTURETRANSFORMFLAGS_Unknown158,
	D3DTEXTURETRANSFORMFLAGS_Unknown159,
	D3DTEXTURETRANSFORMFLAGS_Unknown160,
	D3DTEXTURETRANSFORMFLAGS_Unknown161,
	D3DTEXTURETRANSFORMFLAGS_Unknown162,
	D3DTEXTURETRANSFORMFLAGS_Unknown163,
	D3DTEXTURETRANSFORMFLAGS_Unknown164,
	D3DTEXTURETRANSFORMFLAGS_Unknown165,
	D3DTEXTURETRANSFORMFLAGS_Unknown166,
	D3DTEXTURETRANSFORMFLAGS_Unknown167,
	D3DTEXTURETRANSFORMFLAGS_Unknown168,
	D3DTEXTURETRANSFORMFLAGS_Unknown169,
	D3DTEXTURETRANSFORMFLAGS_Unknown170,
	D3DTEXTURETRANSFORMFLAGS_Unknown171,
	D3DTEXTURETRANSFORMFLAGS_Unknown172,
	D3DTEXTURETRANSFORMFLAGS_Unknown173,
	D3DTEXTURETRANSFORMFLAGS_Unknown174,
	D3DTEXTURETRANSFORMFLAGS_Unknown175,
	D3DTEXTURETRANSFORMFLAGS_Unknown176,
	D3DTEXTURETRANSFORMFLAGS_Unknown177,
	D3DTEXTURETRANSFORMFLAGS_Unknown178,
	D3DTEXTURETRANSFORMFLAGS_Unknown179,
	D3DTEXTURETRANSFORMFLAGS_Unknown180,
	D3DTEXTURETRANSFORMFLAGS_Unknown181,
	D3DTEXTURETRANSFORMFLAGS_Unknown182,
	D3DTEXTURETRANSFORMFLAGS_Unknown183,
	D3DTEXTURETRANSFORMFLAGS_Unknown184,
	D3DTEXTURETRANSFORMFLAGS_Unknown185,
	D3DTEXTURETRANSFORMFLAGS_Unknown186,
	D3DTEXTURETRANSFORMFLAGS_Unknown187,
	D3DTEXTURETRANSFORMFLAGS_Unknown188,
	D3DTEXTURETRANSFORMFLAGS_Unknown189,
	D3DTEXTURETRANSFORMFLAGS_Unknown190,
	D3DTEXTURETRANSFORMFLAGS_Unknown191,
	D3DTEXTURETRANSFORMFLAGS_Unknown192,
	D3DTEXTURETRANSFORMFLAGS_Unknown193,
	D3DTEXTURETRANSFORMFLAGS_Unknown194,
	D3DTEXTURETRANSFORMFLAGS_Unknown195,
	D3DTEXTURETRANSFORMFLAGS_Unknown196,
	D3DTEXTURETRANSFORMFLAGS_Unknown197,
	D3DTEXTURETRANSFORMFLAGS_Unknown198,
	D3DTEXTURETRANSFORMFLAGS_Unknown199,
	D3DTEXTURETRANSFORMFLAGS_Unknown200,
	D3DTEXTURETRANSFORMFLAGS_Unknown201,
	D3DTEXTURETRANSFORMFLAGS_Unknown202,
	D3DTEXTURETRANSFORMFLAGS_Unknown203,
	D3DTEXTURETRANSFORMFLAGS_Unknown204,
	D3DTEXTURETRANSFORMFLAGS_Unknown205,
	D3DTEXTURETRANSFORMFLAGS_Unknown206,
	D3DTEXTURETRANSFORMFLAGS_Unknown207,
	D3DTEXTURETRANSFORMFLAGS_Unknown208,
	D3DTEXTURETRANSFORMFLAGS_Unknown209,
	D3DTEXTURETRANSFORMFLAGS_Unknown210,
	D3DTEXTURETRANSFORMFLAGS_Unknown211,
	D3DTEXTURETRANSFORMFLAGS_Unknown212,
	D3DTEXTURETRANSFORMFLAGS_Unknown213,
	D3DTEXTURETRANSFORMFLAGS_Unknown214,
	D3DTEXTURETRANSFORMFLAGS_Unknown215,
	D3DTEXTURETRANSFORMFLAGS_Unknown216,
	D3DTEXTURETRANSFORMFLAGS_Unknown217,
	D3DTEXTURETRANSFORMFLAGS_Unknown218,
	D3DTEXTURETRANSFORMFLAGS_Unknown219,
	D3DTEXTURETRANSFORMFLAGS_Unknown220,
	D3DTEXTURETRANSFORMFLAGS_Unknown221,
	D3DTEXTURETRANSFORMFLAGS_Unknown222,
	D3DTEXTURETRANSFORMFLAGS_Unknown223,
	D3DTEXTURETRANSFORMFLAGS_Unknown224,
	D3DTEXTURETRANSFORMFLAGS_Unknown225,
	D3DTEXTURETRANSFORMFLAGS_Unknown226,
	D3DTEXTURETRANSFORMFLAGS_Unknown227,
	D3DTEXTURETRANSFORMFLAGS_Unknown228,
	D3DTEXTURETRANSFORMFLAGS_Unknown229,
	D3DTEXTURETRANSFORMFLAGS_Unknown230,
	D3DTEXTURETRANSFORMFLAGS_Unknown231,
	D3DTEXTURETRANSFORMFLAGS_Unknown232,
	D3DTEXTURETRANSFORMFLAGS_Unknown233,
	D3DTEXTURETRANSFORMFLAGS_Unknown234,
	D3DTEXTURETRANSFORMFLAGS_Unknown235,
	D3DTEXTURETRANSFORMFLAGS_Unknown236,
	D3DTEXTURETRANSFORMFLAGS_Unknown237,
	D3DTEXTURETRANSFORMFLAGS_Unknown238,
	D3DTEXTURETRANSFORMFLAGS_Unknown239,
	D3DTEXTURETRANSFORMFLAGS_Unknown240,
	D3DTEXTURETRANSFORMFLAGS_Unknown241,
	D3DTEXTURETRANSFORMFLAGS_Unknown242,
	D3DTEXTURETRANSFORMFLAGS_Unknown243,
	D3DTEXTURETRANSFORMFLAGS_Unknown244,
	D3DTEXTURETRANSFORMFLAGS_Unknown245,
	D3DTEXTURETRANSFORMFLAGS_Unknown246,
	D3DTEXTURETRANSFORMFLAGS_Unknown247,
	D3DTEXTURETRANSFORMFLAGS_Unknown248,
	D3DTEXTURETRANSFORMFLAGS_Unknown249,
	D3DTEXTURETRANSFORMFLAGS_Unknown250,
	D3DTEXTURETRANSFORMFLAGS_Unknown251,
	D3DTEXTURETRANSFORMFLAGS_Unknown252,
	D3DTEXTURETRANSFORMFLAGS_Unknown253,
	D3DTEXTURETRANSFORMFLAGS_Unknown254,
	D3DTEXTURETRANSFORMFLAGS_Unknown255,
	D3DTTFF_PROJECTED
  );

const
  D3DFVF_TEXTUREFORMAT1	= 3;
  D3DFVF_TEXTUREFORMAT2	= 0;
  D3DFVF_TEXTUREFORMAT3	= 1;
  D3DFVF_TEXTUREFORMAT4	= 2;

implementation

end.
