unit ddraw;

{$X+}{$Z2}

interface

uses Windows, Ole2;

const
  DIRECTDRAW_VERSION	= $0700;
  _FACDD	= $876;

{$IFNDEF MAKEFOURCC}
{$ENDIF}

  FOURCC_DXT1 = $31545844;
  FOURCC_DXT2 = $32545844;
  FOURCC_DXT3 = $33545844;
  FOURCC_DXT4 = $34545844;
  FOURCC_DXT5 = $35545844;

  CLSID_DirectDraw: TGUID = (
    D1:$D7B70EE0;D2:$4340;D3:$11CF;D4:($B0,$63,$00,$20,$AF,$C2,$CD,$35));
  CLSID_DirectDraw7:TGUID = (
	D1:$3c305196;D2:$50db;D3:$11d3;D4:($9c,$fe,$00,$c0,$4f,$d9,$30,$c5));
  CLSID_DirectDrawClipper: TGUID = (
    D1:$593817A0;D2:$7DB3;D3:$11CF;D4:($A2,$DE,$00,$AA,$00,$b9,$33,$56));
  IID_IDirectDraw: TGUID = (
    D1:$6C14DB80;D2:$A733;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectDraw2: TGUID = (
    D1:$B3A6F3E0;D2:$2B43;D3:$11CF;D4:($A2,$DE,$00,$AA,$00,$B9,$33,$56));
  IID_IDirectDraw4: TGUID = (
    D1:$9c59509a;D2:$39bd;D3:$11d1;D4:($8c,$4a,$00,$c0,$4f,$d9,$30,$c5));
  IID_IDirectDraw7: TGUID = (
    D1:$15e65ec0;D2:$3b9c;D3:$11d2;D4:($b9,$2f,$00,$60,$97,$97,$ea,$5b));
  IID_IDirectDrawSurface: TGUID = (
    D1:$6C14DB81;D2:$A733;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectDrawSurface2: TGUID = (
    D1:$57805885;D2:$6eec;D3:$11cf;D4:($94,$41,$a8,$23,$03,$c1,$0e,$27));
  IID_IDirectDrawSurface3: TGUID = (
    D1:$DA044E00;D2:$69B2;D3:$11D0;D4:($A1,$D5,$00,$AA,$00,$B8,$DF,$BB));
  IID_IDirectDrawSurface4: TGUID = (
    D1:$0B2B8630;D2:$AD35;D3:$11D0;D4:($8E,$A6,$00,$60,$97,$97,$EA,$5B));
  IID_IDirectDrawSurface7: TGUID = (
    D1:$06675a80;D2:$3b9b;D3:$11d2;D4:($b9,$2f,$00,$60,$97,$97,$ea,$5b));

  IID_IDirectDrawPalette: TGUID = (
    D1:$6C14DB84;D2:$A733;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectDrawClipper: TGUID = (
    D1:$6C14DB85;D2:$A733;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectDrawColorControl: TGUID = (
    D1:$4B9F0EE0;D2:$0D7E;D3:$11D0;D4:($9B,$06,$00,$A0,$C9,$03,$A3,$B8));
  IID_IDirectDrawGammaControl: TGUID = (
    D1:$69C11C3E;D2:$B46B;D3:$11D1;D4:($AD,$7A,$00,$C0,$4F,$C2,$9B,$4E));

type

  HMONITOR = Thandle;
  LPDDENUMCALLBACK =   function (Para0: PGUID; Para1: LPSTR; Para2: LPSTR;
	 Para3: Pointer): BOOL; stdcall;
  function DirectDrawEnumerate(lpCallback: LPDDENUMCALLBACK; lpContext: Pointer): HRESULT; stdcall;

type
  LPDDENUMCALLBACKEX =   function (Para0: PGUID; Para1: LPSTR; Para2: LPSTR;
	 Para3: Pointer; Para4: HMONITOR): BOOL; stdcall;

  function DirectDrawEnumerateEx(lpCallback: LPDDENUMCALLBACKEX; lpContext: Pointer;
	 dwFlags: DWORD): HRESULT; stdcall;

type
  LPDIRECTDRAWENUMERATEEX =   function (lpCallback: LPDDENUMCALLBACKEX; lpContext: Pointer;
	 dwFlags: DWORD): HRESULT; stdcall;

  function DirectDrawCreate(lpGUID: PGUID; var lplpDD: Pointer{IDirectDraw}; pUnkOuter: IUnknown): HRESULT; stdcall;
  function DirectDrawCreateEx(lpGuid: PGUID; var lplpDD: Pointer{IDirectDraw7}; const TIID: TIID;
	 pUnkOuter: IUnknown): HRESULT; stdcall;
  function DirectDrawCreateClipper(dwFlags: DWORD; var lplpDDClipper: Pointer{IDirectDrawClipper};
	 pUnkOuter: IUnknown): HRESULT; stdcall;

type
  IDirectDraw = class;
  IDirectDrawSurface = class;
  IDirectDrawSurface2 = class;
  IDirectDrawSurface4 = class;
  IDirectDrawSurface7 = class;
  IDirectDrawPalette = class;
  IDirectDrawClipper = class;
  LPDIRECTDRAW	= ^IDirectDraw;
  LPDIRECTDRAW2	= ^IDirectDraw2;
  LPDIRECTDRAW4	= ^IDirectDraw4;
  LPDIRECTDRAW7	= ^IDirectDraw7;
  LPDIRECTDRAWSURFACE	= ^IDirectDrawSurface;
  LPDIRECTDRAWSURFACE2	= ^IDirectDrawSurface2;
  LPDIRECTDRAWSURFACE3	= ^IDirectDrawSurface3;
  LPDIRECTDRAWSURFACE4	= ^IDirectDrawSurface4;
  LPDIRECTDRAWSURFACE7	= ^IDirectDrawSurface7;
  LPDIRECTDRAWPALETTE	= ^IDirectDrawPalette;
  LPDIRECTDRAWCLIPPER	= ^IDirectDrawClipper;
  LPDIRECTDRAWCOLORCONTROL	= ^IDirectDrawColorControl;
  LPDIRECTDRAWGAMMACONTROL	= ^IDirectDrawGammaControl;

  DDARGB = record
	blue	: BYTE;
	green	: BYTE;
	red	: BYTE;
	alpha	: BYTE;
  end;

  LPDDARGB	= ^DDARGB;

  DDRGBA = record
	red	: BYTE;
	green	: BYTE;
	blue	: BYTE;
	alpha	: BYTE;
  end;

  LPDDRGBA	= ^DDRGBA;

  DDCOLORKEY = record
	dwColorSpaceLowValue	: DWORD;
	dwColorSpaceHighValue	: DWORD;
  end;

  LPDDCOLORKEY	= ^DDCOLORKEY;

  DDBLTFX = record
	dwSize	: DWORD;
	dwDDFX	: DWORD;
	dwROP	: DWORD;
	dwDDROP	: DWORD;
	dwRotationAngle	: DWORD;
	dwZBufferOpCode	: DWORD;
	dwZBufferLow	: DWORD;
	dwZBufferHigh	: DWORD;
	dwZBufferBaseDest	: DWORD;
	dwZDestConstBitDepth	: DWORD;
	case Integer of
	0: (
	  dwZDestConst	: DWORD;
	  dwZSrcConstBitDepth	: DWORD;
	  dwZSrcConst	: DWORD;
	  dwAlphaEdgeBlendBitDepth	: DWORD;
	  dwAlphaEdgeBlend	: DWORD;
	  dwReserved	: DWORD;
	  dwAlphaDestConstBitDepth	: DWORD;
	  dwAlphaDestConst	: DWORD;
	  dwAlphaSrcConstBitDepth	: DWORD;
	  dwAlphaSrcConst	: DWORD;
	  dwFillColor	: DWORD;
	  ddckDestColorkey	: DDCOLORKEY;
	  ddckSrcColorkey	: DDCOLORKEY;
	);
	1: (
	  lpDDSZBufferDest	: LPDIRECTDRAWSURFACE;
	  Unknown1_2:  DWORD;
	  lpDDSZBufferSrc	: LPDIRECTDRAWSURFACE;
	  Unknown1_4:  DWORD;
	  Unknown1_5:  DWORD;
	  Unknown1_6:  DWORD;
	  Unknown1_7:  DWORD;
	  lpDDSAlphaDest	: LPDIRECTDRAWSURFACE;
	  Unknown1_9:  DWORD;
	  lpDDSAlphaSrc	: LPDIRECTDRAWSURFACE;
	  dwFillDepth	: DWORD;
	);
	2: (
	  Unknown2_1:  DWORD;
	  Unknown2_2:  DWORD;
	  Unknown2_3:  DWORD;
	  Unknown2_4:  DWORD;
	  Unknown2_5:  DWORD;
	  Unknown2_6:  DWORD;
	  Unknown2_7:  DWORD;
	  Unknown2_8:  DWORD;
	  Unknown2_9:  DWORD;
	  Unknown2_10:  DWORD;
	  dwFillPixel	: DWORD;
	);
	3: (
	  Unknown3_1:  DWORD;
	  Unknown3_2:  DWORD;
	  Unknown3_3:  DWORD;
	  Unknown3_4:  DWORD;
	  Unknown3_5:  DWORD;
	  Unknown3_6:  DWORD;
	  Unknown3_7:  DWORD;
	  Unknown3_8:  DWORD;
	  Unknown3_9:  DWORD;
	  Unknown3_10:  DWORD;
	  lpDDSPattern	: LPDIRECTDRAWSURFACE;
	);
  end;

  LPDDBLTFX	= ^DDBLTFX;

  DDSCAPS = record
	dwCaps	: DWORD;
  end;

  LPDDSCAPS	= ^DDSCAPS;

  DDOSCAPS = record
	dwCaps	: DWORD;
  end;

  LPDDOSCAPS	= ^DDOSCAPS;
  LPDDSCAPSEX	= ^DDSCAPSEX;
  DDSCAPSEX = record
	dwCaps2	: DWORD;
	dwCaps3	: DWORD;
	dwCaps4	: DWORD;
  end;

  DDSCAPS2 = record
	dwCaps	: DWORD;
	dwCaps2	: DWORD;
	dwCaps3	: DWORD;
	dwCaps4	: DWORD;
  end;

  LPDDSCAPS2	= ^DDSCAPS2;

  DDCAPS_DX3 = record
	dwSize	: DWORD;
	dwCaps	: DWORD;
	dwCaps2	: DWORD;
	dwCKeyCaps	: DWORD;
	dwFXCaps	: DWORD;
	dwFXAlphaCaps	: DWORD;
	dwPalCaps	: DWORD;
	dwSVCaps	: DWORD;
	dwAlphaBltConstBitDepths	: DWORD;
	dwAlphaBltPixelBitDepths	: DWORD;
	dwAlphaBltSurfaceBitDepths	: DWORD;
	dwAlphaOverlayConstBitDepths	: DWORD;
	dwAlphaOverlayPixelBitDepths	: DWORD;
	dwAlphaOverlaySurfaceBitDepths	: DWORD;
	dwZBufferBitDepths	: DWORD;
	dwVidMemTotal	: DWORD;
	dwVidMemFree	: DWORD;
	dwMaxVisibleOverlays	: DWORD;
	dwCurrVisibleOverlays	: DWORD;
	dwNumFourCCCodes	: DWORD;
	dwAlignBoundarySrc	: DWORD;
	dwAlignSizeSrc	: DWORD;
	dwAlignBoundaryDest	: DWORD;
	dwAlignSizeDest	: DWORD;
	dwAlignStrideAlign	: DWORD;
	dwRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsCaps	: DDSCAPS;
	dwMinOverlayStretch	: DWORD;
	dwMaxOverlayStretch	: DWORD;
	dwMinLiveVideoStretch	: DWORD;
	dwMaxLiveVideoStretch	: DWORD;
	dwMinHwCodecStretch	: DWORD;
	dwMaxHwCodecStretch	: DWORD;
	dwReserved1	: DWORD;
	dwReserved2	: DWORD;
	dwReserved3	: DWORD;
	dwSVBCaps	: DWORD;
	dwSVBCKeyCaps	: DWORD;
	dwSVBFXCaps	: DWORD;
	dwSVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwVSBCaps	: DWORD;
	dwVSBCKeyCaps	: DWORD;
	dwVSBFXCaps	: DWORD;
	dwVSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwSSBCaps	: DWORD;
	dwSSBCKeyCaps	: DWORD;
	dwSSBFXCaps	: DWORD;
	dwSSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwReserved4	: DWORD;
	dwReserved5	: DWORD;
	dwReserved6	: DWORD;
  end;
  LPDDCAPS_DX3	= ^DDCAPS_DX3;

  DDCAPS_DX5 = record
	dwSize	: DWORD;
	dwCaps	: DWORD;
	dwCaps2	: DWORD;
	dwCKeyCaps	: DWORD;
	dwFXCaps	: DWORD;
	dwFXAlphaCaps	: DWORD;
	dwPalCaps	: DWORD;
	dwSVCaps	: DWORD;
	dwAlphaBltConstBitDepths	: DWORD;
	dwAlphaBltPixelBitDepths	: DWORD;
	dwAlphaBltSurfaceBitDepths	: DWORD;
	dwAlphaOverlayConstBitDepths	: DWORD;
	dwAlphaOverlayPixelBitDepths	: DWORD;
	dwAlphaOverlaySurfaceBitDepths	: DWORD;
	dwZBufferBitDepths	: DWORD;
	dwVidMemTotal	: DWORD;
	dwVidMemFree	: DWORD;
	dwMaxVisibleOverlays	: DWORD;
	dwCurrVisibleOverlays	: DWORD;
	dwNumFourCCCodes	: DWORD;
	dwAlignBoundarySrc	: DWORD;
	dwAlignSizeSrc	: DWORD;
	dwAlignBoundaryDest	: DWORD;
	dwAlignSizeDest	: DWORD;
	dwAlignStrideAlign	: DWORD;
	dwRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsCaps	: DDSCAPS;
	dwMinOverlayStretch	: DWORD;
	dwMaxOverlayStretch	: DWORD;
	dwMinLiveVideoStretch	: DWORD;
	dwMaxLiveVideoStretch	: DWORD;
	dwMinHwCodecStretch	: DWORD;
	dwMaxHwCodecStretch	: DWORD;
	dwReserved1	: DWORD;
	dwReserved2	: DWORD;
	dwReserved3	: DWORD;
	dwSVBCaps	: DWORD;
	dwSVBCKeyCaps	: DWORD;
	dwSVBFXCaps	: DWORD;
	dwSVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwVSBCaps	: DWORD;
	dwVSBCKeyCaps	: DWORD;
	dwVSBFXCaps	: DWORD;
	dwVSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwSSBCaps	: DWORD;
	dwSSBCKeyCaps	: DWORD;
	dwSSBFXCaps	: DWORD;
	dwSSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwMaxVideoPorts	: DWORD;
	dwCurrVideoPorts	: DWORD;
	dwSVBCaps2	: DWORD;
	dwNLVBCaps	: DWORD;
	dwNLVBCaps2	: DWORD;
	dwNLVBCKeyCaps	: DWORD;
	dwNLVBFXCaps	: DWORD;
	dwNLVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
  end;
  LPDDCAPS_DX5	= ^DDCAPS_DX5;

  DDCAPS_DX6 = record
	dwSize	: DWORD;
	dwCaps	: DWORD;
	dwCaps2	: DWORD;
	dwCKeyCaps	: DWORD;
	dwFXCaps	: DWORD;
	dwFXAlphaCaps	: DWORD;
	dwPalCaps	: DWORD;
	dwSVCaps	: DWORD;
	dwAlphaBltConstBitDepths	: DWORD;
	dwAlphaBltPixelBitDepths	: DWORD;
	dwAlphaBltSurfaceBitDepths	: DWORD;
	dwAlphaOverlayConstBitDepths	: DWORD;
	dwAlphaOverlayPixelBitDepths	: DWORD;
	dwAlphaOverlaySurfaceBitDepths	: DWORD;
	dwZBufferBitDepths	: DWORD;
	dwVidMemTotal	: DWORD;
	dwVidMemFree	: DWORD;
	dwMaxVisibleOverlays	: DWORD;
	dwCurrVisibleOverlays	: DWORD;
	dwNumFourCCCodes	: DWORD;
	dwAlignBoundarySrc	: DWORD;
	dwAlignSizeSrc	: DWORD;
	dwAlignBoundaryDest	: DWORD;
	dwAlignSizeDest	: DWORD;
	dwAlignStrideAlign	: DWORD;
	dwRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsOldCaps	: DDSCAPS;
	dwMinOverlayStretch	: DWORD;
	dwMaxOverlayStretch	: DWORD;
	dwMinLiveVideoStretch	: DWORD;
	dwMaxLiveVideoStretch	: DWORD;
	dwMinHwCodecStretch	: DWORD;
	dwMaxHwCodecStretch	: DWORD;
	dwReserved1	: DWORD;
	dwReserved2	: DWORD;
	dwReserved3	: DWORD;
	dwSVBCaps	: DWORD;
	dwSVBCKeyCaps	: DWORD;
	dwSVBFXCaps	: DWORD;
	dwSVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwVSBCaps	: DWORD;
	dwVSBCKeyCaps	: DWORD;
	dwVSBFXCaps	: DWORD;
	dwVSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwSSBCaps	: DWORD;
	dwSSBCKeyCaps	: DWORD;
	dwSSBFXCaps	: DWORD;
	dwSSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwMaxVideoPorts	: DWORD;
	dwCurrVideoPorts	: DWORD;
	dwSVBCaps2	: DWORD;
	dwNLVBCaps	: DWORD;
	dwNLVBCaps2	: DWORD;
	dwNLVBCKeyCaps	: DWORD;
	dwNLVBFXCaps	: DWORD;
	dwNLVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsCaps	: DDSCAPS2;
  end;
  LPDDCAPS_DX6	= ^DDCAPS_DX6;

  DDCAPS_DX7 = record
	dwSize	: DWORD;
	dwCaps	: DWORD;
	dwCaps2	: DWORD;
	dwCKeyCaps	: DWORD;
	dwFXCaps	: DWORD;
	dwFXAlphaCaps	: DWORD;
	dwPalCaps	: DWORD;
	dwSVCaps	: DWORD;
	dwAlphaBltConstBitDepths	: DWORD;
	dwAlphaBltPixelBitDepths	: DWORD;
	dwAlphaBltSurfaceBitDepths	: DWORD;
	dwAlphaOverlayConstBitDepths	: DWORD;
	dwAlphaOverlayPixelBitDepths	: DWORD;
	dwAlphaOverlaySurfaceBitDepths	: DWORD;
	dwZBufferBitDepths	: DWORD;
	dwVidMemTotal	: DWORD;
	dwVidMemFree	: DWORD;
	dwMaxVisibleOverlays	: DWORD;
	dwCurrVisibleOverlays	: DWORD;
	dwNumFourCCCodes	: DWORD;
	dwAlignBoundarySrc	: DWORD;
	dwAlignSizeSrc	: DWORD;
	dwAlignBoundaryDest	: DWORD;
	dwAlignSizeDest	: DWORD;
	dwAlignStrideAlign	: DWORD;
	dwRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsOldCaps	: DDSCAPS;
	dwMinOverlayStretch	: DWORD;
	dwMaxOverlayStretch	: DWORD;
	dwMinLiveVideoStretch	: DWORD;
	dwMaxLiveVideoStretch	: DWORD;
	dwMinHwCodecStretch	: DWORD;
	dwMaxHwCodecStretch	: DWORD;
	dwReserved1	: DWORD;
	dwReserved2	: DWORD;
	dwReserved3	: DWORD;
	dwSVBCaps	: DWORD;
	dwSVBCKeyCaps	: DWORD;
	dwSVBFXCaps	: DWORD;
	dwSVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwVSBCaps	: DWORD;
	dwVSBCKeyCaps	: DWORD;
	dwVSBFXCaps	: DWORD;
	dwVSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwSSBCaps	: DWORD;
	dwSSBCKeyCaps	: DWORD;
	dwSSBFXCaps	: DWORD;
	dwSSBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	dwMaxVideoPorts	: DWORD;
	dwCurrVideoPorts	: DWORD;
	dwSVBCaps2	: DWORD;
	dwNLVBCaps	: DWORD;
	dwNLVBCaps2	: DWORD;
	dwNLVBCKeyCaps	: DWORD;
	dwNLVBFXCaps	: DWORD;
	dwNLVBRops	: array[0..{DD_ROP_SPACE}8-1] of DWORD;
	ddsCaps	: DDSCAPS2;
  end;
  LPDDCAPS_DX7	= ^DDCAPS_DX7;

  DDCAPS	= DDCAPS_DX7;

  LPDDCAPS	= ^DDCAPS;

  DDPIXELFORMAT = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwFourCC	: DWORD;
	case Integer of
	0: (
	  dwRGBBitCount	: DWORD;
	  dwRBitMask	: DWORD;
	  dwGBitMask	: DWORD;
	  dwBBitMask	: DWORD;
	  dwRGBAlphaBitMask	: DWORD;
	);
	1: (
	  dwYUVBitCount	: DWORD;
	  dwYBitMask	: DWORD;
	  dwUBitMask	: DWORD;
	  dwVBitMask	: DWORD;
	  dwYUVAlphaBitMask	: DWORD;
	);
	2: (
	  dwZBufferBitDepth	: DWORD;
	  dwStencilBitDepth	: DWORD;
	  dwZBitMask	: DWORD;
	  dwStencilBitMask	: DWORD;
	  dwLuminanceAlphaBitMask	: DWORD;
	);
	3: (
	  dwAlphaBitDepth	: DWORD;
	  dwLuminanceBitMask	: DWORD;
	  dwBumpDvBitMask	: DWORD;
	  dwBumpLuminanceBitMask	: DWORD;
	  dwRGBZBitMask	: DWORD;
	);
	4: (
	  dwLuminanceBitCount	: DWORD;
	  dwBumpDuBitMask	: DWORD;
	  Unknown4_3:  DWORD;
	  Unknown4_4:  DWORD;
	  dwYUVZBitMask	: DWORD;
	);
	5: (
	  dwBumpBitCount	: DWORD;
	);
  end;

  LPDDPIXELFORMAT	= ^DDPIXELFORMAT;

  DDOVERLAYFX = record
	dwSize	: DWORD;
	dwAlphaEdgeBlendBitDepth	: DWORD;
	dwAlphaEdgeBlend	: DWORD;
	dwReserved	: DWORD;
	dwAlphaDestConstBitDepth	: DWORD;
	case Integer of
	0: (
	  dwAlphaDestConst	: DWORD;
	  dwAlphaSrcConstBitDepth	: DWORD;
	  dwAlphaSrcConst	: DWORD;
	  dckDestColorkey	: DDCOLORKEY;
	  dckSrcColorkey	: DDCOLORKEY;
	  dwDDFX	: DWORD;
	  dwFlags	: DWORD;
	);
	1: (
	  lpDDSAlphaDest	: LPDIRECTDRAWSURFACE;
	  Unknown1_2:  DWORD;
	  lpDDSAlphaSrc	: LPDIRECTDRAWSURFACE;
	);
  end;

  LPDDOVERLAYFX	= ^DDOVERLAYFX;

  DDBLTBATCH = record
	lprDest	: PRect;
	lpDDSSrc	: LPDIRECTDRAWSURFACE;
	lprSrc	: PRect;
	dwFlags	: DWORD;
	lpDDBltFx	: LPDDBLTFX;
  end;

  LPDDBLTBATCH	= ^DDBLTBATCH;

  DDGAMMARAMP = record
	red	: array[0..255] of WORD;
	green	: array[0..255] of WORD;
	blue	: array[0..255] of WORD;
  end;

  LPDDGAMMARAMP	= ^DDGAMMARAMP;
  LPDDDEVICEIDENTIFIER	= ^DDDEVICEIDENTIFIER;

  DDDEVICEIDENTIFIER = record
	szDriver	: array[0..{MAX_DDDEVICEID_STRING}512-1] of char;
	szDescription	: array[0..{MAX_DDDEVICEID_STRING}512-1] of char;
{$IFDEF _WIN32}
	liDriverVersion	: TLargeInteger;
{$ELSE}
	dwDriverVersionLowPart	: DWORD;
	dwDriverVersionHighPart	: DWORD;
{$ENDIF}

	dwVendorId	: DWORD;
	dwDeviceId	: DWORD;
	dwSubSysId	: DWORD;
	dwRevision	: DWORD;

	guidDeviceIdentifier	: TGUID;
  end;

  LPDDDEVICEIDENTIFIER2	= ^DDDEVICEIDENTIFIER2;
  DDDEVICEIDENTIFIER2 = record
	szDriver	: array[0..{MAX_DDDEVICEID_STRING}512-1] of char;
	szDescription	: array[0..{MAX_DDDEVICEID_STRING}512-1] of char;

{$IFDEF _WIN32}
	liDriverVersion	: TLargeInteger;
{$ELSE}
	dwDriverVersionLowPart	: DWORD;
	dwDriverVersionHighPart	: DWORD;
{$ENDIF}
	dwVendorId	: DWORD;
	dwDeviceId	: DWORD;
	dwSubSysId	: DWORD;
	dwRevision	: DWORD;

	guidDeviceIdentifier	: TGUID;

	dwWHQLLevel	: DWORD;
  end;

  LPCLIPPERCALLBACK =   function (lpDDClipper: IDirectDrawClipper; hWnd: HWND;
	 code: DWORD; lpContext: Pointer): DWORD; stdcall;
{$IFDEF STREAMING}
  LPSURFACESTREAMINGCALLBACK =   function (Para0: DWORD): DWORD; stdcall;
{$ENDIF}

  DDSURFACEDESC = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwHeight	: DWORD;
	dwWidth	: DWORD;
	case Integer of
	0: (
	  lPitch	: LongInt;
	  dwBackBufferCount	: DWORD;
	  dwMipMapCount	: DWORD;
	  dwAlphaBitDepth	: DWORD;
	  dwReserved	: DWORD;
	  lpSurface	: Pointer;
	  ddckCKDestOverlay	: DDCOLORKEY;
	  ddckCKDestBlt	: DDCOLORKEY;
	  ddckCKSrcOverlay	: DDCOLORKEY;
	  ddckCKSrcBlt	: DDCOLORKEY;
	  ddpfPixelFormat	: DDPIXELFORMAT;
	  ddsCaps	: DDSCAPS;
	);
	1: (
	  dwLinearSize	: DWORD;
	  Unknown1_2:  DWORD;
	  dwZBufferBitDepth	: DWORD;
	);
	2: (
	  Unknown2_1:  LongInt;
	  Unknown2_2:  DWORD;
	  dwRefreshRate	: DWORD;
	);
  end;

  LPDDSURFACEDESC = ^DDSURFACEDESC;

  DDSURFACEDESC2 = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwHeight	: DWORD;
	dwWidth	: DWORD;
	case Integer of
	0: (
	  lPitch	: LongInt;
	  dwBackBufferCount	: DWORD;
	  dwMipMapCount	: DWORD;
	  dwAlphaBitDepth	: DWORD;
	  dwReserved	: DWORD;
	  lpSurface	: Pointer;
	  ddckCKDestOverlay	: DDCOLORKEY;
	  ddckCKDestBlt	: DDCOLORKEY;
	  ddckCKSrcOverlay	: DDCOLORKEY;
	  ddckCKSrcBlt	: DDCOLORKEY;
	  ddpfPixelFormat	: DDPIXELFORMAT;
	  ddsCaps	: DDSCAPS2;
	  dwTextureStage	: DWORD;
	);
	1: (
	  dwLinearSize	: DWORD;
	  Unknown1_2:  DWORD;
	  dwRefreshRate	: DWORD;
	  Unknown1_4:  DWORD;
	  Unknown1_5:  DWORD;
	  Unknown1_6:  Pointer;
	  dwEmptyFaceColor	: DWORD;
	);
  end;

  LPDDSURFACEDESC2 = ^DDSURFACEDESC2;

  DDOPTSURFACEDESC = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	ddSCaps	: DDSCAPS2;
	ddOSCaps	: DDOSCAPS;
	TGUID	: TGUID;
	dwCompressionRatio	: DWORD;
  end;

  DDCOLORCONTROL = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	lBrightness	: LongInt;
	lContrast	: LongInt;
	lHue	: LongInt;
	lSaturation	: LongInt;
	lSharpness	: LongInt;
	lGamma	: LongInt;
	lColorEnable	: LongInt;
	dwReserved1	: DWORD;
  end;

  LPDDCOLORCONTROL = ^DDCOLORCONTROL;
  LPDDENUMMODESCALLBACK =   function (Para0: LPDDSURFACEDESC; Para1: Pointer): HRESULT; stdcall;
  LPDDENUMMODESCALLBACK2 =   function (Para0: LPDDSURFACEDESC2; Para1: Pointer): HRESULT; stdcall;
  LPDDENUMSURFACESCALLBACK =   function (Para0: IDirectDrawSurface; Para1: LPDDSURFACEDESC;
	 Para2: Pointer): HRESULT; stdcall;
  LPDDENUMSURFACESCALLBACK2 =   function (Para0: IDirectDrawSurface4; Para1: LPDDSURFACEDESC2;
	 Para2: Pointer): HRESULT; stdcall;
  LPDDENUMSURFACESCALLBACK7 =   function (Para0: IDirectDrawSurface7; Para1: LPDDSURFACEDESC2;
	 Para2: Pointer): HRESULT; stdcall;

  IDirectDraw = class ( IUnknown )
    function Compact: HRESULT; virtual; stdcall; abstract;
    function CreateClipper(Para0: DWORD; var Para1: IDirectDrawClipper; Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreatePalette(Para0: DWORD; Para1: PPALETTEENTRY; var Para2: IDirectDrawPalette;
	 Para3: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreateSurface(Para0: LPDDSURFACEDESC; var Para1: IDirectDrawSurface;
	 Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function DuplicateSurface(Para0: IDirectDrawSurface; var Para1: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function EnumDisplayModes(Para0: DWORD; Para1: LPDDSURFACEDESC; Para2: Pointer;
	 Para3: LPDDENUMMODESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function EnumSurfaces(Para0: DWORD; Para1: LPDDSURFACEDESC; Para2: Pointer;
	 Para3: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function FlipToGDISurface: HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDCAPS; Para1: LPDDCAPS): HRESULT; virtual; stdcall; abstract;
    function GetDisplayMode(Para0: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function GetFourCCCodes(Para0: PWORD; Para1: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetGDISurface(var Para0: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function GetMonitorFrequency(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetScanLine(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetVerticalBlankStatus(Para0: PBOOL): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function RestoreDisplayMode: HRESULT; virtual; stdcall; abstract;
    function SetCooperativeLevel(Para0: HWND; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDisplayMode(Para0: DWORD; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function WaitForVerticalBlank(Para0: DWORD; Para1: THandle): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDraw2 = class ( IUnknown )
    function Compact: HRESULT; virtual; stdcall; abstract;
    function CreateClipper(Para0: DWORD; var Para1: IDirectDrawClipper; Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreatePalette(Para0: DWORD; Para1: PPALETTEENTRY; var Para2: IDirectDrawPalette;
	 Para3: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreateSurface(Para0: LPDDSURFACEDESC; var Para1: IDirectDrawSurface;
	 Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function DuplicateSurface(Para0: IDirectDrawSurface; var Para1: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function EnumDisplayModes(Para0: DWORD; Para1: LPDDSURFACEDESC; Para2: Pointer;
	 Para3: LPDDENUMMODESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function EnumSurfaces(Para0: DWORD; Para1: LPDDSURFACEDESC; Para2: Pointer;
	 Para3: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function FlipToGDISurface: HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDCAPS; Para1: LPDDCAPS): HRESULT; virtual; stdcall; abstract;
    function GetDisplayMode(Para0: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function GetFourCCCodes(Para0: PWORD; Para1: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetGDISurface(var Para0: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function GetMonitorFrequency(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetScanLine(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetVerticalBlankStatus(Para0: PBOOL): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function RestoreDisplayMode: HRESULT; virtual; stdcall; abstract;
    function SetCooperativeLevel(Para0: HWND; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDisplayMode(Para0: DWORD; Para1: DWORD; Para2: DWORD; Para3: DWORD;
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function WaitForVerticalBlank(Para0: DWORD; Para1: THandle): HRESULT; virtual; stdcall; abstract;
    function GetAvailableVidMem(Para0: LPDDSCAPS; Para1: PWORD; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDraw4 = class ( IUnknown )
    function Compact: HRESULT; virtual; stdcall; abstract;
    function CreateClipper(Para0: DWORD; var Para1: IDirectDrawClipper; Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreatePalette(Para0: DWORD; Para1: PPALETTEENTRY; var Para2: IDirectDrawPalette;
	 Para3: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreateSurface(Para0: LPDDSURFACEDESC2; var Para1: IDirectDrawSurface4;
	 Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function DuplicateSurface(Para0: IDirectDrawSurface4; var Para1: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function EnumDisplayModes(Para0: DWORD; Para1: LPDDSURFACEDESC2; Para2: Pointer;
	 Para3: LPDDENUMMODESCALLBACK2): HRESULT; virtual; stdcall; abstract;
    function EnumSurfaces(Para0: DWORD; Para1: LPDDSURFACEDESC2; Para2: Pointer;
	 Para3: LPDDENUMSURFACESCALLBACK2): HRESULT; virtual; stdcall; abstract;
    function FlipToGDISurface: HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDCAPS; Para1: LPDDCAPS): HRESULT; virtual; stdcall; abstract;
    function GetDisplayMode(Para0: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function GetFourCCCodes(Para0: PWORD; Para1: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetGDISurface(var Para0: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function GetMonitorFrequency(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetScanLine(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetVerticalBlankStatus(Para0: PBOOL): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function RestoreDisplayMode: HRESULT; virtual; stdcall; abstract;
    function SetCooperativeLevel(Para0: HWND; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDisplayMode(Para0: DWORD; Para1: DWORD; Para2: DWORD; Para3: DWORD;
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function WaitForVerticalBlank(Para0: DWORD; Para1: THandle): HRESULT; virtual; stdcall; abstract;
    function GetAvailableVidMem(Para0: LPDDSCAPS2; Para1: PWORD; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceFromDC(Para0: HDC; var Para1: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function RestoreAllSurfaces: HRESULT; virtual; stdcall; abstract;
    function TestCooperativeLevel: HRESULT; virtual; stdcall; abstract;
    function GetDeviceIdentifier(Para0: LPDDDEVICEIDENTIFIER; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDraw7 = class ( IUnknown )
    function Compact: HRESULT; virtual; stdcall; abstract;
    function CreateClipper(Para0: DWORD; var Para1: IDirectDrawClipper; Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreatePalette(Para0: DWORD; Para1: PPALETTEENTRY; var Para2: IDirectDrawPalette;
	 Para3: IUnknown): HRESULT; virtual; stdcall; abstract;
    function CreateSurface(Para0: LPDDSURFACEDESC2; var Para1: IDirectDrawSurface7;
	 Para2: IUnknown): HRESULT; virtual; stdcall; abstract;
    function DuplicateSurface(Para0: IDirectDrawSurface7; var Para1: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function EnumDisplayModes(Para0: DWORD; Para1: LPDDSURFACEDESC2; Para2: Pointer;
	 Para3: LPDDENUMMODESCALLBACK2): HRESULT; virtual; stdcall; abstract;
    function EnumSurfaces(Para0: DWORD; Para1: LPDDSURFACEDESC2; Para2: Pointer;
	 Para3: LPDDENUMSURFACESCALLBACK7): HRESULT; virtual; stdcall; abstract;
    function FlipToGDISurface: HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDCAPS; Para1: LPDDCAPS): HRESULT; virtual; stdcall; abstract;
    function GetDisplayMode(Para0: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function GetFourCCCodes(Para0: PWORD; Para1: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetGDISurface(var Para0: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function GetMonitorFrequency(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetScanLine(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetVerticalBlankStatus(Para0: PBOOL): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function RestoreDisplayMode: HRESULT; virtual; stdcall; abstract;
    function SetCooperativeLevel(Para0: HWND; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDisplayMode(Para0: DWORD; Para1: DWORD; Para2: DWORD; Para3: DWORD;
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function WaitForVerticalBlank(Para0: DWORD; Para1: THandle): HRESULT; virtual; stdcall; abstract;
    function GetAvailableVidMem(Para0: LPDDSCAPS2; Para1: PWORD; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceFromDC(Para0: HDC; var Para1: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function RestoreAllSurfaces: HRESULT; virtual; stdcall; abstract;
    function TestCooperativeLevel: HRESULT; virtual; stdcall; abstract;
    function GetDeviceIdentifier(Para0: LPDDDEVICEIDENTIFIER2; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function StartModeTest(Para0: PSize; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function EvaluateMode(Para0: DWORD; var Para1: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawPalette = class ( IUnknown )
    function GetCaps(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetEntries(Para0: DWORD; Para1: DWORD; Para2: DWORD; Para3: PPALETTEENTRY): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: DWORD; Para2: PPALETTEENTRY): HRESULT; virtual; stdcall; abstract;
    function SetEntries(Para0: DWORD; Para1: DWORD; Para2: DWORD; Para3: PPALETTEENTRY): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawClipper = class ( IUnknown )
    function GetClipList(Para0: PRect; Para1: PRGNDATA; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
    function GetHWnd(var Para0: HWND): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function IsClipListChanged(var Para0: BOOL): HRESULT; virtual; stdcall; abstract;
    function SetClipList(Para0: PRGNDATA; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetHWnd(Para0: DWORD; Para1: HWND): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawSurface = class ( IUnknown )
    function AddAttachedSurface(Para0: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function AddOverlayDirtyRect(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function Blt(Para0: PRect; Para1: IDirectDrawSurface; Para2: PRect; Para3: DWORD; 
	 Para4: LPDDBLTFX): HRESULT; virtual; stdcall; abstract;
    function BltBatch(Para0: LPDDBLTBATCH; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function BltFast(Para0: DWORD; Para1: DWORD; Para2: IDirectDrawSurface; Para3: PRect; 
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function DeleteAttachedSurface(Para0: DWORD; Para1: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function EnumAttachedSurfaces(Para0: Pointer; Para1: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function EnumOverlayZOrders(Para0: DWORD; Para1: Pointer; Para2: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function Flip(Para0: IDirectDrawSurface; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetAttachedSurface(Para0: LPDDSCAPS; var Para1: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
    function GetBltStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDSCAPS): HRESULT; virtual; stdcall; abstract;
    function GetClipper(var Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function GetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function GetDC(var Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function GetFlipStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetOverlayPosition(Para0: PLongint; Para1: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPalette(var Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function GetPixelFormat(Para0: LPDDPIXELFORMAT): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceDesc(Para0: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function IsLost: HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: PRect; Para1: LPDDSURFACEDESC; Para2: DWORD; Para3: THandle): HRESULT; virtual; stdcall; abstract;
    function ReleaseDC(Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
    function SetClipper(Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function SetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function SetOverlayPosition(Para0: LongInt; Para1: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPalette(Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlay(Para0: PRect; Para1: IDirectDrawSurface; Para2: PRect; 
	 Para3: DWORD; Para4: LPDDOVERLAYFX): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayDisplay(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayZOrder(Para0: DWORD; Para1: IDirectDrawSurface): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawSurface2 = class ( IUnknown )
    function AddAttachedSurface(Para0: IDirectDrawSurface2): HRESULT; virtual; stdcall; abstract;
    function AddOverlayDirtyRect(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function Blt(Para0: PRect; Para1: IDirectDrawSurface2; Para2: PRect; Para3: DWORD;
	 Para4: LPDDBLTFX): HRESULT; virtual; stdcall; abstract;
    function BltBatch(Para0: LPDDBLTBATCH; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function BltFast(Para0: DWORD; Para1: DWORD; Para2: IDirectDrawSurface2; Para3: PRect; 
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function DeleteAttachedSurface(Para0: DWORD; Para1: IDirectDrawSurface2): HRESULT; virtual; stdcall; abstract;
    function EnumAttachedSurfaces(Para0: Pointer; Para1: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function EnumOverlayZOrders(Para0: DWORD; Para1: Pointer; Para2: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function Flip(Para0: IDirectDrawSurface2; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetAttachedSurface(Para0: LPDDSCAPS; var Para1: IDirectDrawSurface2): HRESULT; virtual; stdcall; abstract;
    function GetBltStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDSCAPS): HRESULT; virtual; stdcall; abstract;
    function GetClipper(var Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function GetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function GetDC(var Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function GetFlipStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetOverlayPosition(Para0: PLongint; Para1: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPalette(var Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function GetPixelFormat(Para0: LPDDPIXELFORMAT): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceDesc(Para0: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function IsLost: HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: PRect; Para1: LPDDSURFACEDESC; Para2: DWORD; Para3: THandle): HRESULT; virtual; stdcall; abstract;
    function ReleaseDC(Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
    function SetClipper(Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function SetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function SetOverlayPosition(Para0: LongInt; Para1: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPalette(Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlay(Para0: PRect; Para1: IDirectDrawSurface2; Para2: PRect; 
	 Para3: DWORD; Para4: LPDDOVERLAYFX): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayDisplay(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayZOrder(Para0: DWORD; Para1: IDirectDrawSurface2): HRESULT; virtual; stdcall; abstract;
    function GetDDInterface(var Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function PageLock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function PageUnlock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawSurface3 = class ( IUnknown )
    function AddAttachedSurface(Para0: IDirectDrawSurface3): HRESULT; virtual; stdcall; abstract;
    function AddOverlayDirtyRect(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function Blt(Para0: PRect; Para1: IDirectDrawSurface3; Para2: PRect; Para3: DWORD; 
	 Para4: LPDDBLTFX): HRESULT; virtual; stdcall; abstract;
    function BltBatch(Para0: LPDDBLTBATCH; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function BltFast(Para0: DWORD; Para1: DWORD; Para2: IDirectDrawSurface3; Para3: PRect;
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function DeleteAttachedSurface(Para0: DWORD; Para1: IDirectDrawSurface3): HRESULT; virtual; stdcall; abstract;
    function EnumAttachedSurfaces(Para0: Pointer; Para1: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function EnumOverlayZOrders(Para0: DWORD; Para1: Pointer; Para2: LPDDENUMSURFACESCALLBACK): HRESULT; virtual; stdcall; abstract;
    function Flip(Para0: IDirectDrawSurface3; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetAttachedSurface(Para0: LPDDSCAPS; var Para1: IDirectDrawSurface3): HRESULT; virtual; stdcall; abstract;
    function GetBltStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDSCAPS): HRESULT; virtual; stdcall; abstract;
    function GetClipper(var Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function GetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function GetDC(var Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function GetFlipStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetOverlayPosition(Para0: PLongint; Para1: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPalette(var Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function GetPixelFormat(Para0: LPDDPIXELFORMAT): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceDesc(Para0: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: LPDDSURFACEDESC): HRESULT; virtual; stdcall; abstract;
    function IsLost: HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: PRect; Para1: LPDDSURFACEDESC; Para2: DWORD; Para3: THandle): HRESULT; virtual; stdcall; abstract;
    function ReleaseDC(Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
    function SetClipper(Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function SetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function SetOverlayPosition(Para0: LongInt; Para1: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPalette(Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlay(Para0: PRect; Para1: IDirectDrawSurface3; Para2: PRect; 
	 Para3: DWORD; Para4: LPDDOVERLAYFX): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayDisplay(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayZOrder(Para0: DWORD; Para1: IDirectDrawSurface3): HRESULT; virtual; stdcall; abstract;
    function GetDDInterface(var Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function PageLock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function PageUnlock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetSurfaceDesc(Para0: LPDDSURFACEDESC; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawSurface4 = class ( IUnknown )
    function AddAttachedSurface(Para0: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function AddOverlayDirtyRect(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function Blt(Para0: PRect; Para1: IDirectDrawSurface4; Para2: PRect; Para3: DWORD; 
	 Para4: LPDDBLTFX): HRESULT; virtual; stdcall; abstract;
    function BltBatch(Para0: LPDDBLTBATCH; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function BltFast(Para0: DWORD; Para1: DWORD; Para2: IDirectDrawSurface4; Para3: PRect; 
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function DeleteAttachedSurface(Para0: DWORD; Para1: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function EnumAttachedSurfaces(Para0: Pointer; Para1: LPDDENUMSURFACESCALLBACK2): HRESULT; virtual; stdcall; abstract;
    function EnumOverlayZOrders(Para0: DWORD; Para1: Pointer; Para2: LPDDENUMSURFACESCALLBACK2): HRESULT; virtual; stdcall; abstract;
    function Flip(Para0: IDirectDrawSurface4; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetAttachedSurface(Para0: LPDDSCAPS2; var Para1: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function GetBltStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDSCAPS2): HRESULT; virtual; stdcall; abstract;
    function GetClipper(var Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function GetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function GetDC(var Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function GetFlipStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetOverlayPosition(Para0: PLongint; Para1: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPalette(var Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function GetPixelFormat(Para0: LPDDPIXELFORMAT): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceDesc(Para0: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function IsLost: HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: PRect; Para1: LPDDSURFACEDESC2; Para2: DWORD; Para3: THandle): HRESULT; virtual; stdcall; abstract;
    function ReleaseDC(Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
    function SetClipper(Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function SetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function SetOverlayPosition(Para0: LongInt; Para1: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPalette(Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlay(Para0: PRect; Para1: IDirectDrawSurface4; Para2: PRect; 
	 Para3: DWORD; Para4: LPDDOVERLAYFX): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayDisplay(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayZOrder(Para0: DWORD; Para1: IDirectDrawSurface4): HRESULT; virtual; stdcall; abstract;
    function GetDDInterface(var Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function PageLock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function PageUnlock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetSurfaceDesc(Para0: LPDDSURFACEDESC2; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetPrivateData(Para0: PGUID; Para1: Pointer; Para2: DWORD; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetPrivateData(Para0: PGUID; Para1: Pointer; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
    function FreePrivateData(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function GetUniquenessValue(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function ChangeUniquenessValue: HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawSurface7 = class ( IUnknown )
    function AddAttachedSurface(Para0: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function AddOverlayDirtyRect(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function Blt(Para0: PRect; Para1: IDirectDrawSurface7; Para2: PRect; Para3: DWORD; 
	 Para4: LPDDBLTFX): HRESULT; virtual; stdcall; abstract;
    function BltBatch(Para0: LPDDBLTBATCH; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function BltFast(Para0: DWORD; Para1: DWORD; Para2: IDirectDrawSurface7; Para3: PRect; 
	 Para4: DWORD): HRESULT; virtual; stdcall; abstract;
    function DeleteAttachedSurface(Para0: DWORD; Para1: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function EnumAttachedSurfaces(Para0: Pointer; Para1: LPDDENUMSURFACESCALLBACK7): HRESULT; virtual; stdcall; abstract;
    function EnumOverlayZOrders(Para0: DWORD; Para1: Pointer; Para2: LPDDENUMSURFACESCALLBACK7): HRESULT; virtual; stdcall; abstract;
    function Flip(Para0: IDirectDrawSurface7; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetAttachedSurface(Para0: LPDDSCAPS2; var Para1: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function GetBltStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDDSCAPS2): HRESULT; virtual; stdcall; abstract;
    function GetClipper(var Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function GetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function GetDC(var Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function GetFlipStatus(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetOverlayPosition(Para0: PLongint; Para1: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPalette(var Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function GetPixelFormat(Para0: LPDDPIXELFORMAT): HRESULT; virtual; stdcall; abstract;
    function GetSurfaceDesc(Para0: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: IDirectDraw; Para1: LPDDSURFACEDESC2): HRESULT; virtual; stdcall; abstract;
    function IsLost: HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: PRect; Para1: LPDDSURFACEDESC2; Para2: DWORD; Para3: THandle): HRESULT; virtual; stdcall; abstract;
    function ReleaseDC(Para0: HDC): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
    function SetClipper(Para0: IDirectDrawClipper): HRESULT; virtual; stdcall; abstract;
    function SetColorKey(Para0: DWORD; Para1: LPDDCOLORKEY): HRESULT; virtual; stdcall; abstract;
    function SetOverlayPosition(Para0: LongInt; Para1: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPalette(Para0: IDirectDrawPalette): HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: PRect): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlay(Para0: PRect; Para1: IDirectDrawSurface7; Para2: PRect; 
	 Para3: DWORD; Para4: LPDDOVERLAYFX): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayDisplay(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function UpdateOverlayZOrder(Para0: DWORD; Para1: IDirectDrawSurface7): HRESULT; virtual; stdcall; abstract;
    function GetDDInterface(var Para0: Pointer): HRESULT; virtual; stdcall; abstract;
    function PageLock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function PageUnlock(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetSurfaceDesc(Para0: LPDDSURFACEDESC2; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetPrivateData(Para0: PGUID; Para1: Pointer; Para2: DWORD; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetPrivateData(Para0: PGUID; Para1: Pointer; Para2: PWORD): HRESULT; virtual; stdcall; abstract;
    function FreePrivateData(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
    function GetUniquenessValue(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function ChangeUniquenessValue: HRESULT; virtual; stdcall; abstract;
    function SetPriority(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetPriority(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
    function SetLOD(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function GetLOD(Para0: PWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawColorControl = class ( IUnknown )
    function GetColorControls(Para0: LPDDCOLORCONTROL): HRESULT; virtual; stdcall; abstract;
    function SetColorControls(Para0: LPDDCOLORCONTROL): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectDrawGammaControl = class ( IUnknown )
    function GetGammaRamp(Para0: DWORD; Para1: LPDDGAMMARAMP): HRESULT; virtual; stdcall; abstract;
    function SetGammaRamp(Para0: DWORD; Para1: LPDDGAMMARAMP): HRESULT; virtual; stdcall; abstract;
  end;

const
  DDCOLOR_BRIGHTNESS	= $00000001;
  DDCOLOR_CONTRAST	= $00000002;
  DDCOLOR_HUE	= $00000004;
  DDCOLOR_SATURATION	= $00000008;
  DDCOLOR_SHARPNESS	= $00000010;
  DDCOLOR_GAMMA	= $00000020;
  DDCOLOR_COLORENABLE	= $00000040;
  DDSCAPS_RESERVED1	= $00000001;
  DDSCAPS_ALPHA	= $00000002;
  DDSCAPS_BACKBUFFER	= $00000004;
  DDSCAPS_COMPLEX	= $00000008;
  DDSCAPS_FLIP	= $00000010;
  DDSCAPS_FRONTBUFFER	= $00000020;
  DDSCAPS_OFFSCREENPLAIN	= $00000040;
  DDSCAPS_OVERLAY	= $00000080;
  DDSCAPS_PALETTE	= $00000100;
  DDSCAPS_PRIMARYSURFACE	= $00000200;
  DDSCAPS_PRIMARYSURFACELEFT	= $00000400;
  DDSCAPS_SYSTEMMEMORY	= $00000800;
  DDSCAPS_TEXTURE	= $00001000;
  DDSCAPS_3DDEVICE	= $00002000;
  DDSCAPS_VIDEOMEMORY	= $00004000;
  DDSCAPS_VISIBLE	= $00008000;
  DDSCAPS_WRITEONLY	= $00010000;
  DDSCAPS_ZBUFFER	= $00020000;
  DDSCAPS_OWNDC	= $00040000;
  DDSCAPS_LIVEVIDEO	= $00080000;
  DDSCAPS_HWCODEC	= $00100000;
  DDSCAPS_MODEX	= $00200000;
  DDSCAPS_MIPMAP	= $00400000;
  DDSCAPS_RESERVED2	= $00800000;
  DDSCAPS_ALLOCONLOAD	= $04000000;
  DDSCAPS_VIDEOPORT	= $08000000;
  DDSCAPS_LOCALVIDMEM	= $10000000;
  DDSCAPS_NONLOCALVIDMEM	= $20000000;
  DDSCAPS_STANDARDVGAMODE	= $40000000;
  DDSCAPS_OPTIMIZED	= $80000000;
  DDSCAPS2_HARDWAREDEINTERLACE	= $00000002;
  DDSCAPS2_HINTDYNAMIC	= $00000004;
  DDSCAPS2_HINTSTATIC	= $00000008;
  DDSCAPS2_TEXTUREMANAGE	= $00000010;
  DDSCAPS2_RESERVED1	= $00000020;
  DDSCAPS2_RESERVED2	= $00000040;
  DDSCAPS2_OPAQUE	= $00000080;
  DDSCAPS2_HINTANTIALIASING	= $00000100;
  DDSCAPS2_CUBEMAP	= $00000200;
  DDSCAPS2_CUBEMAP_POSITIVEX	= $00000400;
  DDSCAPS2_CUBEMAP_NEGATIVEX	= $00000800;
  DDSCAPS2_CUBEMAP_POSITIVEY	= $00001000;
  DDSCAPS2_CUBEMAP_NEGATIVEY	= $00002000;
  DDSCAPS2_CUBEMAP_POSITIVEZ	= $00004000;
  DDSCAPS2_CUBEMAP_NEGATIVEZ	= $00008000;
  DDSCAPS2_CUBEMAP_ALLFACES	= ( DDSCAPS2_CUBEMAP_POSITIVEX or DDSCAPS2_CUBEMAP_NEGATIVEX or
         DDSCAPS2_CUBEMAP_POSITIVEY or DDSCAPS2_CUBEMAP_NEGATIVEY or DDSCAPS2_CUBEMAP_POSITIVEZ or
         DDSCAPS2_CUBEMAP_NEGATIVEZ );
  DDSCAPS2_MIPMAPSUBLEVEL	= $00010000;
  DDSCAPS2_D3DTEXTUREMANAGE	= $00020000;
  DDSCAPS2_DONOTPERSIST	= $00040000;
  DDSCAPS2_STEREOSURFACELEFT	= $00080000;
  DDCAPS_3D	= $00000001;
  DDCAPS_ALIGNBOUNDARYDEST	= $00000002;
  DDCAPS_ALIGNSIZEDEST	= $00000004;
  DDCAPS_ALIGNBOUNDARYSRC	= $00000008;
  DDCAPS_ALIGNSIZESRC	= $00000010;
  DDCAPS_ALIGNSTRIDE	= $00000020;
  DDCAPS_BLT	= $00000040;
  DDCAPS_BLTQUEUE	= $00000080;
  DDCAPS_BLTFOURCC	= $00000100;
  DDCAPS_BLTSTRETCH	= $00000200;
  DDCAPS_GDI	= $00000400;
  DDCAPS_OVERLAY	= $00000800;
  DDCAPS_OVERLAYCANTCLIP	= $00001000;
  DDCAPS_OVERLAYFOURCC	= $00002000;
  DDCAPS_OVERLAYSTRETCH	= $00004000;
  DDCAPS_PALETTE	= $00008000;
  DDCAPS_PALETTEVSYNC	= $00010000;
  DDCAPS_READSCANLINE	= $00020000;
  DDCAPS_STEREOVIEW	= $00040000;
  DDCAPS_VBI	= $00080000;
  DDCAPS_ZBLTS	= $00100000;
  DDCAPS_ZOVERLAYS	= $00200000;
  DDCAPS_COLORKEY	= $00400000;
  DDCAPS_ALPHA	= $00800000;
  DDCAPS_COLORKEYHWASSIST	= $01000000;
  DDCAPS_NOHARDWARE	= $02000000;
  DDCAPS_BLTCOLORFILL	= $04000000;
  DDCAPS_BANKSWITCHED	= $08000000;
  DDCAPS_BLTDEPTHFILL	= $10000000;
  DDCAPS_CANCLIP	= $20000000;
  DDCAPS_CANCLIPSTRETCHED	= $40000000;
  DDCAPS_CANBLTSYSMEM	= $80000000;
  DDCAPS2_CERTIFIED	= $00000001;
  DDCAPS2_NO2DDURING3DSCENE	= $00000002;
  DDCAPS2_VIDEOPORT	= $00000004;
  DDCAPS2_AUTOFLIPOVERLAY	= $00000008;
  DDCAPS2_CANBOBINTERLEAVED	= $00000010;
  DDCAPS2_CANBOBNONINTERLEAVED	= $00000020;
  DDCAPS2_COLORCONTROLOVERLAY	= $00000040;
  DDCAPS2_COLORCONTROLPRIMARY	= $00000080;
  DDCAPS2_CANDROPZ16BIT	= $00000100;
  DDCAPS2_NONLOCALVIDMEM	= $00000200;
  DDCAPS2_NONLOCALVIDMEMCAPS	= $00000400;
  DDCAPS2_NOPAGELOCKREQUIRED	= $00000800;
  DDCAPS2_WIDESURFACES	= $00001000;
  DDCAPS2_CANFLIPODDEVEN	= $00002000;
  DDCAPS2_CANBOBHARDWARE	= $00004000;
  DDCAPS2_COPYFOURCC	= $00008000;
  DDCAPS2_PRIMARYGAMMA	= $00020000;
  DDCAPS2_CANRENDERWINDOWED	= $00080000;
  DDCAPS2_CANCALIBRATEGAMMA	= $00100000;
  DDCAPS2_FLIPINTERVAL	= $00200000;
  DDCAPS2_FLIPNOVSYNC	= $00400000;
  DDCAPS2_CANMANAGETEXTURE	= $00800000;
  DDCAPS2_TEXMANINNONLOCALVIDMEM	= $01000000;
  DDCAPS2_STEREO	= $02000000;
  DDCAPS2_SYSTONONLOCAL_AS_SYSTOLOCAL = $04000000;
  DDFXALPHACAPS_BLTALPHAEDGEBLEND	= $00000001;
  DDFXALPHACAPS_BLTALPHAPIXELS	= $00000002;
  DDFXALPHACAPS_BLTALPHAPIXELSNEG	= $00000004;
  DDFXALPHACAPS_BLTALPHASURFACES	= $00000008;
  DDFXALPHACAPS_BLTALPHASURFACESNEG	= $00000010;
  DDFXALPHACAPS_OVERLAYALPHAEDGEBLEND	= $00000020;
  DDFXALPHACAPS_OVERLAYALPHAPIXELS	= $00000040;
  DDFXALPHACAPS_OVERLAYALPHAPIXELSNEG	= $00000080;
  DDFXALPHACAPS_OVERLAYALPHASURFACES	= $00000100;
  DDFXALPHACAPS_OVERLAYALPHASURFACESNEG	= $00000200;
  DDFXCAPS_BLTARITHSTRETCHY	= $00000020;
  DDFXCAPS_BLTARITHSTRETCHYN	= $00000010;
  DDFXCAPS_BLTMIRRORLEFTRIGHT	= $00000040;
  DDFXCAPS_BLTMIRRORUPDOWN	= $00000080;
  DDFXCAPS_BLTROTATION	= $00000100;
  DDFXCAPS_BLTROTATION90	= $00000200;
  DDFXCAPS_BLTSHRINKX	= $00000400;
  DDFXCAPS_BLTSHRINKXN	= $00000800;
  DDFXCAPS_BLTSHRINKY	= $00001000;
  DDFXCAPS_BLTSHRINKYN	= $00002000;
  DDFXCAPS_BLTSTRETCHX	= $00004000;
  DDFXCAPS_BLTSTRETCHXN	= $00008000;
  DDFXCAPS_BLTSTRETCHY	= $00010000;
  DDFXCAPS_BLTSTRETCHYN	= $00020000;
  DDFXCAPS_OVERLAYARITHSTRETCHY	= $00040000;
  DDFXCAPS_OVERLAYARITHSTRETCHYN	= $00000008;
  DDFXCAPS_OVERLAYSHRINKX	= $00080000;
  DDFXCAPS_OVERLAYSHRINKXN	= $00100000;
  DDFXCAPS_OVERLAYSHRINKY	= $00200000;
  DDFXCAPS_OVERLAYSHRINKYN	= $00400000;
  DDFXCAPS_OVERLAYSTRETCHX	= $00800000;
  DDFXCAPS_OVERLAYSTRETCHXN	= $01000000;
  DDFXCAPS_OVERLAYSTRETCHY	= $02000000;
  DDFXCAPS_OVERLAYSTRETCHYN	= $04000000;
  DDFXCAPS_OVERLAYMIRRORLEFTRIGHT	= $08000000;
  DDFXCAPS_OVERLAYMIRRORUPDOWN	= $10000000;
  DDFXCAPS_BLTALPHA	= $00000001;
  DDFXCAPS_BLTFILTER	= DDFXCAPS_BLTARITHSTRETCHY;
  DDFXCAPS_OVERLAYALPHA	= $00000004;
  DDFXCAPS_OVERLAYFILTER	= DDFXCAPS_OVERLAYARITHSTRETCHY;
  DDSVCAPS_ENIGMA	= $00000001;
  DDSVCAPS_FLICKER	= $00000002;
  DDSVCAPS_REDBLUE	= $00000004;
  DDSVCAPS_SPLIT	= $00000008;
  DDSVCAPS_STEREOSEQUENTIAL	= $00000010;
  DDPCAPS_4BIT	= $00000001;
  DDPCAPS_8BITENTRIES	= $00000002;
  DDPCAPS_8BIT	= $00000004;
  DDPCAPS_INITIALIZE	= $00000000;
  DDPCAPS_PRIMARYSURFACE	= $00000010;
  DDPCAPS_PRIMARYSURFACELEFT	= $00000020;
  DDPCAPS_ALLOW256	= $00000040;
  DDPCAPS_VSYNC	= $00000080;
  DDPCAPS_1BIT	= $00000100;
  DDPCAPS_2BIT	= $00000200;
  DDPCAPS_ALPHA	= $00000400;
  DDSPD_IUNKNOWNPOINTER	= $00000001;
  DDSPD_VOLATILE	= $00000002;
  DDBD_1	= $00004000;
  DDBD_2	= $00002000;
  DDBD_4	= $00001000;
  DDBD_8	= $00000800;
  DDBD_16	= $00000400;
  DDBD_24	= $00000200;
  DDBD_32	= $00000100;
  DDCKEY_COLORSPACE	= $00000001;
  DDCKEY_DESTBLT	= $00000002;
  DDCKEY_DESTOVERLAY	= $00000004;
  DDCKEY_SRCBLT	= $00000008;
  DDCKEY_SRCOVERLAY	= $00000010;
  DDCKEYCAPS_DESTBLT	= $00000001;
  DDCKEYCAPS_DESTBLTCLRSPACE	= $00000002;
  DDCKEYCAPS_DESTBLTCLRSPACEYUV	= $00000004;
  DDCKEYCAPS_DESTBLTYUV	= $00000008;
  DDCKEYCAPS_DESTOVERLAY	= $00000010;
  DDCKEYCAPS_DESTOVERLAYCLRSPACE	= $00000020;
  DDCKEYCAPS_DESTOVERLAYCLRSPACEYUV	= $00000040;
  DDCKEYCAPS_DESTOVERLAYONEACTIVE	= $00000080;
  DDCKEYCAPS_DESTOVERLAYYUV	= $00000100;
  DDCKEYCAPS_SRCBLT	= $00000200;
  DDCKEYCAPS_SRCBLTCLRSPACE	= $00000400;
  DDCKEYCAPS_SRCBLTCLRSPACEYUV	= $00000800;
  DDCKEYCAPS_SRCBLTYUV	= $00001000;
  DDCKEYCAPS_SRCOVERLAY	= $00002000;
  DDCKEYCAPS_SRCOVERLAYCLRSPACE	= $00004000;
  DDCKEYCAPS_SRCOVERLAYCLRSPACEYUV	= $00008000;
  DDCKEYCAPS_SRCOVERLAYONEACTIVE	= $00010000;
  DDCKEYCAPS_SRCOVERLAYYUV	= $00020000;
  DDCKEYCAPS_NOCOSTOVERLAY	= $00040000;
  DDPF_ALPHAPIXELS	= $00000001;
  DDPF_ALPHA	= $00000002;
  DDPF_FOURCC	= $00000004;
  DDPF_PALETTEINDEXED4	= $00000008;
  DDPF_PALETTEINDEXEDTO8	= $00000010;
  DDPF_PALETTEINDEXED8	= $00000020;
  DDPF_RGB	= $00000040;
  DDPF_COMPRESSED	= $00000080;
  DDPF_RGBTOYUV	= $00000100;
  DDPF_YUV	= $00000200;
  DDPF_ZBUFFER	= $00000400;
  DDPF_PALETTEINDEXED1	= $00000800;
  DDPF_PALETTEINDEXED2	= $00001000;
  DDPF_ZPIXELS	= $00002000;
  DDPF_STENCILBUFFER	= $00004000;
  DDPF_ALPHAPREMULT	= $00008000;
  DDPF_LUMINANCE	= $00020000;
  DDPF_BUMPLUMINANCE	= $00040000;
  DDPF_BUMPDUDV	= $00080000;
  DDENUMSURFACES_ALL	= $00000001;
  DDENUMSURFACES_MATCH	= $00000002;
  DDENUMSURFACES_NOMATCH	= $00000004;
  DDENUMSURFACES_CANBECREATED	= $00000008;
  DDENUMSURFACES_DOESEXIST	= $00000010;
  DDSDM_STANDARDVGAMODE	= $00000001;
  DDEDM_REFRESHRATES	= $00000001;
  DDEDM_STANDARDVGAMODES	= $00000002;
  DDSCL_FULLSCREEN	= $00000001;
  DDSCL_ALLOWREBOOT	= $00000002;
  DDSCL_NOWINDOWCHANGES	= $00000004;
  DDSCL_NORMAL	= $00000008;
  DDSCL_EXCLUSIVE	= $00000010;
  DDSCL_ALLOWMODEX	= $00000040;
  DDSCL_SETFOCUSWINDOW	= $00000080;
  DDSCL_SETDEVICEWINDOW	= $00000100;
  DDSCL_CREATEDEVICEWINDOW	= $00000200;
  DDSCL_MULTITHREADED	= $00000400;
  DDSCL_FPUSETUP	= $00000800;
  DDSCL_FPUPRESERVE	= $00001000;
  DDBLT_ALPHADEST	= $00000001;
  DDBLT_ALPHADESTCONSTOVERRIDE	= $00000002;
  DDBLT_ALPHADESTNEG	= $00000004;
  DDBLT_ALPHADESTSURFACEOVERRIDE	= $00000008;
  DDBLT_ALPHAEDGEBLEND	= $00000010;
  DDBLT_ALPHASRC	= $00000020;
  DDBLT_ALPHASRCCONSTOVERRIDE	= $00000040;
  DDBLT_ALPHASRCNEG	= $00000080;
  DDBLT_ALPHASRCSURFACEOVERRIDE	= $00000100;
  DDBLT_ASYNC	= $00000200;
  DDBLT_COLORFILL	= $00000400;
  DDBLT_DDFX	= $00000800;
  DDBLT_DDROPS	= $00001000;
  DDBLT_KEYDEST	= $00002000;
  DDBLT_KEYDESTOVERRIDE	= $00004000;
  DDBLT_KEYSRC	= $00008000;
  DDBLT_KEYSRCOVERRIDE	= $00010000;
  DDBLT_ROP	= $00020000;
  DDBLT_ROTATIONANGLE	= $00040000;
  DDBLT_ZBUFFER	= $00080000;
  DDBLT_ZBUFFERDESTCONSTOVERRIDE	= $00100000;
  DDBLT_ZBUFFERDESTOVERRIDE	= $00200000;
  DDBLT_ZBUFFERSRCCONSTOVERRIDE	= $00400000;
  DDBLT_ZBUFFERSRCOVERRIDE	= $00800000;
  DDBLT_WAIT	= $01000000;
  DDBLT_DEPTHFILL	= $02000000;
  DDBLT_DONOTWAIT	= $08000000;
  DDBLTFAST_NOCOLORKEY	= $00000000;
  DDBLTFAST_SRCCOLORKEY	= $00000001;
  DDBLTFAST_DESTCOLORKEY	= $00000002;
  DDBLTFAST_WAIT	= $00000010;
  DDBLTFAST_DONOTWAIT	= $00000020;
  DDFLIP_WAIT	= $00000001;
  DDFLIP_EVEN	= $00000002;
  DDFLIP_ODD	= $00000004;
  DDFLIP_NOVSYNC	= $00000008;
  DDFLIP_INTERVAL2	= $02000000;
  DDFLIP_INTERVAL3	= $03000000;
  DDFLIP_INTERVAL4	= $04000000;
  DDFLIP_STEREO	= $00000010;
DDFLIP_DONOTWAIT = $00000020;
  DDOVER_ALPHADEST	= $00000001;
  DDOVER_ALPHADESTCONSTOVERRIDE	= $00000002;
  DDOVER_ALPHADESTNEG	= $00000004;
  DDOVER_ALPHADESTSURFACEOVERRIDE	= $00000008;
  DDOVER_ALPHAEDGEBLEND	= $00000010;
  DDOVER_ALPHASRC	= $00000020;
  DDOVER_ALPHASRCCONSTOVERRIDE	= $00000040;
  DDOVER_ALPHASRCNEG	= $00000080;
  DDOVER_ALPHASRCSURFACEOVERRIDE	= $00000100;
  DDOVER_HIDE	= $00000200;
  DDOVER_KEYDEST	= $00000400;
  DDOVER_KEYDESTOVERRIDE	= $00000800;
  DDOVER_KEYSRC	= $00001000;
  DDOVER_KEYSRCOVERRIDE	= $00002000;
  DDOVER_SHOW	= $00004000;
  DDOVER_ADDDIRTYRECT	= $00008000;
  DDOVER_REFRESHDIRTYRECTS	= $00010000;
  DDOVER_REFRESHALL	= $00020000;
  DDOVER_DDFX	= $00080000;
  DDOVER_AUTOFLIP	= $00100000;
  DDOVER_BOB	= $00200000;
  DDOVER_OVERRIDEBOBWEAVE	= $00400000;
  DDOVER_INTERLEAVED	= $00800000;
  DDOVER_BOBHARDWARE	= $01000000;
  DDOVER_ARGBSCALEFACTORS	= $02000000;
  DDOVER_DEGRADEARGBSCALING	= $04000000;
  DDLOCK_SURFACEMEMORYPTR	= $00000000;
  DDLOCK_WAIT	= $00000001;
  DDLOCK_EVENT	= $00000002;
  DDLOCK_READONLY	= $00000010;
  DDLOCK_WRITEONLY	= $00000020;
  DDLOCK_NOSYSLOCK	= $00000800;
  DDLOCK_NOOVERWRITE	= $00001000;
  DDLOCK_OKTOSWAP	= $00002000;
  DDLOCK_DONOTWAIT  = $00004000;
  DDBLTFX_ARITHSTRETCHY	= $00000001;
  DDBLTFX_MIRRORLEFTRIGHT	= $00000002;
  DDBLTFX_MIRRORUPDOWN	= $00000004;
  DDBLTFX_NOTEARING	= $00000008;
  DDBLTFX_ROTATE180	= $00000010;
  DDBLTFX_ROTATE270	= $00000020;
  DDBLTFX_ROTATE90	= $00000040;
  DDBLTFX_ZBUFFERRANGE	= $00000080;
  DDBLTFX_ZBUFFERBASEDEST	= $00000100;
  DDOVERFX_ARITHSTRETCHY	= $00000001;
  DDOVERFX_MIRRORLEFTRIGHT	= $00000002;
  DDOVERFX_MIRRORUPDOWN	= $00000004;
  DDWAITVB_BLOCKBEGIN	= $00000001;
  DDWAITVB_BLOCKBEGINEVENT	= $00000002;
  DDWAITVB_BLOCKEND	= $00000004;
  DDGFS_CANFLIP	= $00000001;
  DDGFS_ISFLIPDONE	= $00000002;
  DDGBS_CANBLT	= $00000001;
  DDGBS_ISBLTDONE	= $00000002;
  DDENUMOVERLAYZ_BACKTOFRONT	= $00000000;
  DDENUMOVERLAYZ_FRONTTOBACK	= $00000001;
  DDOVERZ_SENDTOFRONT	= $00000000;
  DDOVERZ_SENDTOBACK	= $00000001;
  DDOVERZ_MOVEFORWARD	= $00000002;
  DDOVERZ_MOVEBACKWARD	= $00000003;
  DDOVERZ_INSERTINFRONTOF	= $00000004;
  DDOVERZ_INSERTINBACKOF	= $00000005;
  DDSGR_CALIBRATE	= $00000001;
  DDEM_MODEPASSED	= $00000001;
  DDEM_MODEFAILED	= $00000002;

  DD_OK	= 0;

  DD_FALSE	= S_FALSE;

  DDENUMRET_CANCEL	= 0;
  DDENUMRET_OK	= 1;
  DDERR_ALREADYINITIALIZED	= $88760005;
  DDERR_CANNOTATTACHSURFACE	= $8876000A;
  DDERR_CANNOTDETACHSURFACE	= $88760014;
  DDERR_CURRENTLYNOTAVAIL	= $88760028;
  DDERR_EXCEPTION	= $88760037;
  DDERR_GENERIC	= E_FAIL;
  DDERR_HEIGHTALIGN	= $8876005A;
  DDERR_INCOMPATIBLEPRIMARY	= $8876005F;
  DDERR_INVALIDCAPS	= $88760064;
  DDERR_INVALIDCLIPLIST	= $8876006E;
  DDERR_INVALIDMODE	= $88760078;
  DDERR_INVALIDOBJECT	= $88760082;
  DDERR_INVALIDPARAMS	= E_INVALIDARG;
  DDERR_INVALIDPIXELFORMAT	= $88760091;
  DDERR_INVALIDRECT	= $88760096;
  DDERR_LOCKEDSURFACES	= $887600A0;
  DDERR_NO3D	= $887600AA;
  DDERR_NOALPHAHW	= $887600B4;
  DDERR_NOSTEREOHARDWARE	= $887600B5;
  DDERR_NOSURFACELEFT	= $887600B6;
  DDERR_NOCLIPLIST	= $887600CD;
  DDERR_NOCOLORCONVHW	= $887600D2;
  DDERR_NOCOOPERATIVELEVELSET	= $887600D4;
  DDERR_NOCOLORKEY	= $887600D7;
  DDERR_NOCOLORKEYHW	= $887600DC;
  DDERR_NODIRECTDRAWSUPPORT	= $887600DE;
  DDERR_NOEXCLUSIVEMODE	= $887600E1;
  DDERR_NOFLIPHW	= $887600E6;
  DDERR_NOGDI	= $887600F0;
  DDERR_NOMIRRORHW	= $887600FA;
  DDERR_NOTFOUND	= $887600FF;
  DDERR_NOOVERLAYHW	= $88760104;
  DDERR_OVERLAPPINGRECTS	= $8876010E;
  DDERR_NORASTEROPHW	= $88760118;
  DDERR_NOROTATIONHW	= $88760122;
  DDERR_NOSTRETCHHW	= $88760136;
  DDERR_NOT4BITCOLOR	= $8876013C;
  DDERR_NOT4BITCOLORINDEX	= $8876013D;
  DDERR_NOT8BITCOLOR	= $88760140;
  DDERR_NOTEXTUREHW	= $8876014A;
  DDERR_NOVSYNCHW	= $8876014F;
  DDERR_NOZBUFFERHW	= $88760154;
  DDERR_NOZOVERLAYHW	= $8876015E;
  DDERR_OUTOFCAPS	= $88760168;
  DDERR_OUTOFMEMORY	= E_OUTOFMEMORY;
  DDERR_OUTOFVIDEOMEMORY	= $8876017C;
  DDERR_OVERLAYCANTCLIP	= $8876017E;
  DDERR_OVERLAYCOLORKEYONLYONEACTIVE	= $88760180;
  DDERR_PALETTEBUSY	= $88760183;
  DDERR_COLORKEYNOTSET	= $88760190;
  DDERR_SURFACEALREADYATTACHED	= $8876019A;
  DDERR_SURFACEALREADYDEPENDENT	= $887601A4;
  DDERR_SURFACEBUSY	= $887601AE;
  DDERR_CANTLOCKSURFACE	= $887601B3;
  DDERR_SURFACEISOBSCURED	= $887601B8;
  DDERR_SURFACELOST	= $887601C2;
  DDERR_SURFACENOTATTACHED	= $887601CC;
  DDERR_TOOBIGHEIGHT	= $887601D6;
  DDERR_TOOBIGSIZE	= $887601E0;
  DDERR_TOOBIGWIDTH	= $887601EA;
  DDERR_UNSUPPORTED	= E_NOTIMPL;
  DDERR_UNSUPPORTEDFORMAT	= $887601FE;
  DDERR_UNSUPPORTEDMASK	= $88760208;
  DDERR_INVALIDSTREAM	= $88760209;
  DDERR_VERTICALBLANKINPROGRESS	= $88760219;
  DDERR_WASSTILLDRAWING	= $8876021C;
  DDERR_DDSCAPSCOMPLEXREQUIRED	= $8876021E;
  DDERR_XALIGN	= $88760230;
  DDERR_INVALIDDIRECTDRAWGUID	= $88760231;
  DDERR_DIRECTDRAWALREADYCREATED	= $88760232;
  DDERR_NODIRECTDRAWHW	= $88760233;
  DDERR_PRIMARYSURFACEALREADYEXISTS	= $88760234;
  DDERR_NOEMULATION	= $88760235;
  DDERR_REGIONTOOSMALL	= $88760236;
  DDERR_CLIPPERISUSINGHWND	= $88760237;
  DDERR_NOCLIPPERATTACHED	= $88760238;
  DDERR_NOHWND	= $88760239;
  DDERR_HWNDSUBCLASSED	= $8876023A;
  DDERR_HWNDALREADYSET	= $8876023B;
  DDERR_NOPALETTEATTACHED	= $8876023C;
  DDERR_NOPALETTEHW	= $8876023D;
  DDERR_BLTFASTCANTCLIP	= $8876023E;
  DDERR_NOBLTHW	= $8876023F;
  DDERR_NODDROPSHW	= $88760240;
  DDERR_OVERLAYNOTVISIBLE	= $88760241;
  DDERR_NOOVERLAYDEST	= $88760242;
  DDERR_INVALIDPOSITION	= $88760243;
  DDERR_NOTAOVERLAYSURFACE	= $88760244;
  DDERR_EXCLUSIVEMODEALREADYSET	= $88760245;
  DDERR_NOTFLIPPABLE	= $88760246;
  DDERR_CANTDUPLICATE	= $88760247;
  DDERR_NOTLOCKED	= $88760248;
  DDERR_CANTCREATEDC	= $88760249;
  DDERR_NODC	= $8876024A;
  DDERR_WRONGMODE	= $8876024B;
  DDERR_IMPLICITLYCREATED	= $8876024C;
  DDERR_NOTPALETTIZED	= $8876024D;
  DDERR_UNSUPPORTEDMODE	= $8876024E;
  DDERR_NOMIPMAPHW	= $8876024F;
  DDERR_INVALIDSURFACETYPE	= $88760250;
  DDERR_NOOPTIMIZEHW	= $88760258;
  DDERR_NOTLOADED	= $88760259;
  DDERR_NOFOCUSWINDOW	= $8876025A;
  DDERR_DCALREADYCREATED	= $8876026C;
  DDERR_NONONLOCALVIDMEM	= $88760276;
  DDERR_CANTPAGELOCK	= $88760280;
  DDERR_CANTPAGEUNLOCK	= $88760294;
  DDERR_NOTPAGELOCKED	= $887602A8;
  DDERR_MOREDATA	= $887602B2;
  DDERR_EXPIRED	= $887602B3;
  DDERR_TESTFINISHED	= $887602B4;
  DDERR_NEWMODE	= $887602B5;
  DDERR_VIDEONOTACTIVE	= $887602B7;
  DDERR_NOMONITORINFORMATION = $887602B8;
  DDERR_NODRIVERSUPPORT =  $887602B9;
  DDERR_DEVICEDOESNTOWNSURFACE	= $887602BB;
  DDERR_NOTINITIALIZED	= CO_E_NOTINITIALIZED;

const
  DDENUM_ATTACHEDSECONDARYDEVICES	= $00000001;
  DDENUM_DETACHEDSECONDARYDEVICES	= $00000002;
  DDENUM_NONDISPLAYDEVICES	= $00000004;
  REGSTR_KEY_DDHW_DESCRIPTION	= 'Description';
  REGSTR_KEY_DDHW_DRIVERNAME	= 'DriverName';
  REGSTR_PATH_DDHW	= 'Hardware\DirectDrawDrivers';
  DDCREATE_HARDWAREONLY	= $00000001;
  DDCREATE_EMULATIONONLY	= $00000002;

const
  DDSD_CAPS	= $00000001;
  DDSD_HEIGHT	= $00000002;
  DDSD_WIDTH	= $00000004;
  DDSD_PITCH	= $00000008;
  DDSD_BACKBUFFERCOUNT	= $00000020;
  DDSD_ZBUFFERBITDEPTH	= $00000040;
  DDSD_ALPHABITDEPTH	= $00000080;
  DDSD_LPSURFACE	= $00000800;
  DDSD_PIXELFORMAT	= $00001000;
  DDSD_CKDESTOVERLAY	= $00002000;
  DDSD_CKDESTBLT	= $00004000;
  DDSD_CKSRCOVERLAY	= $00008000;
  DDSD_CKSRCBLT	= $00010000;
  DDSD_MIPMAPCOUNT	= $00020000;
  DDSD_REFRESHRATE	= $00040000;
  DDSD_LINEARSIZE	= $00080000;
  DDSD_TEXTURESTAGE	= $00100000;
  DDSD_ALL	= $001ff9ee;

const
  DDOSD_GUID	= $00000001;
  DDOSD_COMPRESSION_RATIO	= $00000002;
  DDOSD_SCAPS	= $00000004;
  DDOSD_OSCAPS	= $00000008;
  DDOSD_ALL	= $0000000f;
  DDOSDCAPS_OPTCOMPRESSED	= $00000001;
  DDOSDCAPS_OPTREORDERED	= $00000002;
  DDOSDCAPS_MONOLITHICMIPMAP	= $00000004;
  DDOSDCAPS_VALIDSCAPS	= $30004800;
  DDOSDCAPS_VALIDOSCAPS	= $00000007;
  DD_ROP_SPACE	= $00000008;

const
  MAX_DDDEVICEID_STRING	= 512;

const
  DDGDI_GETHOSTIDENTIFIER	= $00000001;

implementation

const
  ddrawDLL = 'ddraw.dll';

  function DirectDrawEnumerate; external ddrawDLL name 'DirectDrawEnumerateA';
  function DirectDrawEnumerateEx; external ddrawDLL name 'DirectDrawEnumerateExA';
  function DirectDrawCreate; external ddrawDLL name 'DirectDrawCreate';
  function DirectDrawCreateEx; external ddrawDLL name 'DirectDrawCreateEx';
  function DirectDrawCreateClipper; external ddrawDLL name 'DirectDrawCreateClipper';

end.
