unit dsound;

interface

uses Windows, Ole2, d3dtypes,mmsystem,SysUtils;

const
  _FACDS	= $878;

  CLSID_DirectSound: TGUID = (
    D1:$47d4d946;D2:$62e8;D3:$11cf;D4:($93,$bc,$44,$45,$53,$54,$0,$0));
  CLSID_DirectSoundCapture: TGUID = (
    D1:$b0210780;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSoundBuffer: TGUID = (
    D1:$279AFA85;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSound: TGUID = (
    D1:$279AFA83;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSound3DListener: TGUID = (
    D1:$279AFA84;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSound3DBuffer: TGUID = (
    D1:$279AFA86;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSoundCapture: TGUID = (
    D1:$b0210781;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSoundCaptureBuffer: TGUID = (
    D1:$b0210782;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSoundNotify: TGUID = (
    D1:$b0210783;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));

  KSPROPERTY_SUPPORT_GET	= $00000001;
  KSPROPERTY_SUPPORT_SET	= $00000002;

  IID_IKsPropertySet: TGUID = (
    D1:$31efac30;D2:$515c;D3:$11d0;D4:($a9,$aa,$00,$aa,$00,$61,$be,$93));

type
  IDirectSound = class;
  IDirectSoundBuffer = class;
  IDirectSound3DListener = class;
  IDirectSound3DBuffer = class;
  IDirectSoundCapture = class;
  IDirectSoundCaptureBuffer = class;
  IDirectSoundNotify = class;

  LPDIRECTSOUND	= IDirectSound;
  LPDIRECTSOUNDBUFFER	= IDirectSoundBuffer;
  LPDIRECTSOUND3DLISTENER	= IDirectSound3DListener;
  LPDIRECTSOUND3DBUFFER	= IDirectSound3DBuffer;
  LPDIRECTSOUNDCAPTURE	= IDirectSoundCapture;
  LPDIRECTSOUNDCAPTUREBUFFER	= IDirectSoundCaptureBuffer;
  LPDIRECTSOUNDNOTIFY	= IDirectSoundNotify;

  LPWAVEFORMATEX= ^TWAVEFORMATEX;


  DSCAPS = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwMinSecondarySampleRate	: DWORD;
	dwMaxSecondarySampleRate	: DWORD;
	dwPrimaryBuffers	: DWORD;
	dwMaxHwMixingAllBuffers	: DWORD;
	dwMaxHwMixingStaticBuffers	: DWORD;
	dwMaxHwMixingStreamingBuffers	: DWORD;
	dwFreeHwMixingAllBuffers	: DWORD;
	dwFreeHwMixingStaticBuffers	: DWORD;
	dwFreeHwMixingStreamingBuffers	: DWORD;
	dwMaxHw3DAllBuffers	: DWORD;
	dwMaxHw3DStaticBuffers	: DWORD;
	dwMaxHw3DStreamingBuffers	: DWORD;
	dwFreeHw3DAllBuffers	: DWORD;
	dwFreeHw3DStaticBuffers	: DWORD;
	dwFreeHw3DStreamingBuffers	: DWORD;
	dwTotalHwMemBytes	: DWORD;
	dwFreeHwMemBytes	: DWORD;
	dwMaxContigFreeHwMemBytes	: DWORD;
	dwUnlockTransferRateHwBuffers	: DWORD;
	dwPlayCpuOverheadSwBuffers	: DWORD;
	dwReserved1	: DWORD;
	dwReserved2	: DWORD;
  end;
  LPDSCAPS	= ^DSCAPS;

  LPCDSCAPS	= ^DSCAPS;

  DSBCAPS = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwBufferBytes	: DWORD;
	dwUnlockTransferRate	: DWORD;
	dwPlayCpuOverhead	: DWORD;
  end;
  LPDSBCAPS	= ^DSBCAPS;

  LPCDSBCAPS	= ^DSBCAPS;

  DSBUFFERDESC = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwBufferBytes	: DWORD;
	dwReserved	: DWORD;
	lpwfxFormat	: LPWAVEFORMATEX;
  end;
  LPDSBUFFERDESC	= ^DSBUFFERDESC;

  LPCDSBUFFERDESC	= ^DSBUFFERDESC;

  DS3DBUFFER = record
	dwSize	: DWORD;
	vPosition	: D3DVECTOR;
	vVelocity	: D3DVECTOR;
	dwInsideConeAngle	: DWORD;
	dwOutsideConeAngle	: DWORD;
	vConeOrientation	: D3DVECTOR;
	lConeOutsideVolume	: LongInt;
	flMinDistance	: D3DVALUE;
	flMaxDistance	: D3DVALUE;
	dwMode	: DWORD;
  end;
  LPDS3DBUFFER	= ^DS3DBUFFER;

  LPCDS3DBUFFER	= ^DS3DBUFFER;

  DS3DLISTENER = record
	dwSize	: DWORD;
	vPosition	: D3DVECTOR;
	vVelocity	: D3DVECTOR;
	vOrientFront	: D3DVECTOR;
	vOrientTop	: D3DVECTOR;
	flDistanceFactor	: D3DVALUE;
	flRolloffFactor	: D3DVALUE;
	flDopplerFactor	: D3DVALUE;
  end;
  LPDS3DLISTENER	= ^DS3DLISTENER;

  LPCDS3DLISTENER	= ^DS3DLISTENER;

  DSCCAPS = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwFormats	: DWORD;
	dwChannels	: DWORD;
  end;
  LPDSCCAPS	= ^DSCCAPS;

  LPCDSCCAPS	= ^DSCCAPS;

  DSCBUFFERDESC = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwBufferBytes	: DWORD;
	dwReserved	: DWORD;
	lpwfxFormat	: LPWAVEFORMATEX;
  end;
  LPDSCBUFFERDESC	= ^DSCBUFFERDESC;

  LPCDSCBUFFERDESC	= ^DSCBUFFERDESC;

  DSCBCAPS = record
	dwSize	: DWORD;
	dwFlags	: DWORD;
	dwBufferBytes	: DWORD;
	dwReserved	: DWORD;
  end;
  LPDSCBCAPS	= ^DSCBCAPS;

  LPCDSCBCAPS	= ^DSCBCAPS;

  DSBPOSITIONNOTIFY = record
	dwOffset	: DWORD;
	hEventNotify	: THANDLE;
  end;
  LPDSBPOSITIONNOTIFY	= ^DSBPOSITIONNOTIFY;

  LPCDSBPOSITIONNOTIFY	= ^DSBPOSITIONNOTIFY;

  LPLPDIRECTSOUND	= ^LPDIRECTSOUND;
  LPLPDIRECTSOUNDBUFFER	= ^LPDIRECTSOUNDBUFFER;
  LPLPDIRECTSOUND3DLISTENER	= ^LPDIRECTSOUND3DLISTENER;
  LPLPDIRECTSOUND3DBUFFER	= ^LPDIRECTSOUND3DBUFFER;
  LPLPDIRECTSOUNDCAPTURE	= ^LPDIRECTSOUNDCAPTURE;
  LPLPDIRECTSOUNDCAPTUREBUFFER	= ^LPDIRECTSOUNDCAPTUREBUFFER;
  LPLPDIRECTSOUNDNOTIFY	= ^LPDIRECTSOUNDNOTIFY;
  LPLPVOID	= ^Pointer;
  LPCWAVEFORMATEX	= ^TWAVEFORMATEX;

  IDirectSound = class ( IUnknown )
    function CreateSoundBuffer(Para0: LPCDSBUFFERDESC; var Para1: LPDIRECTSOUNDBUFFER; 
	 Para2: pointer): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDSCAPS): HRESULT; virtual; stdcall; abstract;
    function DuplicateSoundBuffer(Para0: LPDIRECTSOUNDBUFFER; var Para1: LPDIRECTSOUNDBUFFER): HRESULT; virtual; stdcall; abstract;
    function SetCooperativeLevel(Para0: HWND; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function Compact: HRESULT; virtual; stdcall; abstract;
    function GetSpeakerConfig(Para0: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function SetSpeakerConfig(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSoundBuffer = class ( IUnknown )
    function GetCaps(Para0: LPDSBCAPS): HRESULT; virtual; stdcall; abstract;
    function GetCurrentPosition(Para0: LPDWORD; Para1: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetFormat(Para0: LPWAVEFORMATEX; Para1: DWORD; Para2: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetVolume(Para0: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetPan(Para0: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetFrequency(Para0: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetStatus(Para0: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: LPDIRECTSOUND; Para1: LPCDSBUFFERDESC): HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: DWORD; Para1: DWORD; var Para2: Pointer; Para3: LPDWORD; 
	 var Para4: Pointer; Para5: LPDWORD; Para6: DWORD): HRESULT; virtual; stdcall; abstract;
    function Play(Para0: DWORD; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetCurrentPosition(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetFormat(Para0: LPCWAVEFORMATEX): HRESULT; virtual; stdcall; abstract;
    function SetVolume(Para0: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetPan(Para0: LongInt): HRESULT; virtual; stdcall; abstract;
    function SetFrequency(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function Stop: HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: Pointer; Para1: DWORD; Para2: Pointer; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function Restore: HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSound3DListener = class ( IUnknown )
    function GetAllParameters(Para0: LPDS3DLISTENER): HRESULT; virtual; stdcall; abstract;
    function GetDistanceFactor(Para0: LPD3DVALUE): HRESULT; virtual; stdcall; abstract;
    function GetDopplerFactor(Para0: LPD3DVALUE): HRESULT; virtual; stdcall; abstract;
    function GetOrientation(Para0: LPD3DVECTOR; Para1: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function GetPosition(Para0: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function GetRolloffFactor(Para0: LPD3DVALUE): HRESULT; virtual; stdcall; abstract;
    function GetVelocity(Para0: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function SetAllParameters(Para0: LPCDS3DLISTENER; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDistanceFactor(Para0: D3DVALUE; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetDopplerFactor(Para0: D3DVALUE; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetOrientation(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; Para3: D3DVALUE; 
	 Para4: D3DVALUE; Para5: D3DVALUE; Para6: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetPosition(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetRolloffFactor(Para0: D3DVALUE; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetVelocity(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function CommitDeferredSettings: HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSound3DBuffer = class ( IUnknown )
    function GetAllParameters(Para0: LPDS3DBUFFER): HRESULT; virtual; stdcall; abstract;
    function GetConeAngles(Para0: LPDWORD; Para1: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetConeOrientation(Para0: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function GetConeOutsideVolume(Para0: PLongint): HRESULT; virtual; stdcall; abstract;
    function GetMaxDistance(Para0: LPD3DVALUE): HRESULT; virtual; stdcall; abstract;
    function GetMinDistance(Para0: LPD3DVALUE): HRESULT; virtual; stdcall; abstract;
    function GetMode(Para0: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetPosition(Para0: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function GetVelocity(Para0: LPD3DVECTOR): HRESULT; virtual; stdcall; abstract;
    function SetAllParameters(Para0: LPCDS3DBUFFER; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetConeAngles(Para0: DWORD; Para1: DWORD; Para2: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetConeOrientation(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; 
	 Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetConeOutsideVolume(Para0: LongInt; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetMaxDistance(Para0: D3DVALUE; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetMinDistance(Para0: D3DVALUE; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetMode(Para0: DWORD; Para1: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetPosition(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
    function SetVelocity(Para0: D3DVALUE; Para1: D3DVALUE; Para2: D3DVALUE; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSoundCapture = class ( IUnknown )
    function CreateCaptureBuffer(Para0: LPCDSCBUFFERDESC; var Para1: LPDIRECTSOUNDCAPTUREBUFFER; 
	 Para2: pointer): HRESULT; virtual; stdcall; abstract;
    function GetCaps(Para0: LPDSCCAPS): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: PGUID): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSoundCaptureBuffer = class ( IUnknown )
    function GetCaps(Para0: LPDSCBCAPS): HRESULT; virtual; stdcall; abstract;
    function GetCurrentPosition(Para0: LPDWORD; Para1: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetFormat(Para0: LPWAVEFORMATEX; Para1: DWORD; Para2: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function GetStatus(Para0: LPDWORD): HRESULT; virtual; stdcall; abstract;
    function Initialize(Para0: LPDIRECTSOUNDCAPTURE; Para1: LPCDSCBUFFERDESC): HRESULT; virtual; stdcall; abstract;
    function Lock(Para0: DWORD; Para1: DWORD; var Para2: Pointer; Para3: LPDWORD; 
	 var Para4: Pointer; Para5: LPDWORD; Para6: DWORD): HRESULT; virtual; stdcall; abstract;
    function Start(Para0: DWORD): HRESULT; virtual; stdcall; abstract;
    function Stop: HRESULT; virtual; stdcall; abstract;
    function Unlock(Para0: Pointer; Para1: DWORD; Para2: Pointer; Para3: DWORD): HRESULT; virtual; stdcall; abstract;
  end;

  IDirectSoundNotify = class ( IUnknown )
    function SetNotificationPositions(Para0: DWORD; Para1: LPCDSBPOSITIONNOTIFY): HRESULT; virtual; stdcall; abstract;
  end;

  IKsPropertySet = class;
  LPKSPROPERTYSET	= ^IKsPropertySet;

  IKsPropertySet = class ( IUnknown )
    function Get(Para0: TGUID; Para1: ULONG; Para2: Pointer; Para3: ULONG; Para4: Pointer;
	 Para5: ULONG; Para6: PULONG): HRESULT; virtual; stdcall; abstract;
    function Set_(Para0: TGUID; Para1: ULONG; Para2: Pointer; Para3: ULONG; Para4: Pointer;
	 Para5: ULONG): HRESULT; virtual; stdcall; abstract;
    function QuerySupport(Para0: TGUID; Para1: ULONG; Para2: PULONG): HRESULT; virtual; stdcall; abstract;
  end;

const
  DS_OK	= 0;
  DSERR_ALLOCATED	= $8878000A;
  DSERR_CONTROLUNAVAIL	= $8878001E;
  DSERR_INVALIDPARAM	= E_INVALIDARG;
  DSERR_INVALIDCALL	= $88780032;
  DSERR_GENERIC	= E_FAIL;
  DSERR_PRIOLEVELNEEDED	= $88780046;
  DSERR_OUTOFMEMORY	= E_OUTOFMEMORY;
  DSERR_BADFORMAT	= $88780064;
  DSERR_UNSUPPORTED	= E_NOTIMPL;
  DSERR_NODRIVER	= $88780078;
  DSERR_ALREADYINITIALIZED	= $88780082;
  DSERR_NOAGGREGATION	= CLASS_E_NOAGGREGATION;
  DSERR_BUFFERLOST	= $88780096;
  DSERR_OTHERAPPHASPRIO	= $887800A0;
  DSERR_UNINITIALIZED	= $887800AA;
  DSERR_NOINTERFACE	= E_NOINTERFACE;
  DSCAPS_PRIMARYMONO	= $00000001;
  DSCAPS_PRIMARYSTEREO	= $00000002;
  DSCAPS_PRIMARY8BIT	= $00000004;
  DSCAPS_PRIMARY16BIT	= $00000008;
  DSCAPS_CONTINUOUSRATE	= $00000010;
  DSCAPS_EMULDRIVER	= $00000020;
  DSCAPS_CERTIFIED	= $00000040;
  DSCAPS_SECONDARYMONO	= $00000100;
  DSCAPS_SECONDARYSTEREO	= $00000200;
  DSCAPS_SECONDARY8BIT	= $00000400;
  DSCAPS_SECONDARY16BIT	= $00000800;
  DSBPLAY_LOOPING	= $00000001;
  DSBSTATUS_PLAYING	= $00000001;
  DSBSTATUS_BUFFERLOST	= $00000002;
  DSBSTATUS_LOOPING	= $00000004;
  DSBLOCK_FROMWRITECURSOR	= $00000001;
  DSBLOCK_ENTIREBUFFER	= $00000002;
  DSSCL_NORMAL	= $00000001;
  DSSCL_PRIORITY	= $00000002;
  DSSCL_EXCLUSIVE	= $00000003;
  DSSCL_WRITEPRIMARY	= $00000004;
  DS3DMODE_NORMAL	= $00000000;
  DS3DMODE_HEADRELATIVE	= $00000001;
  DS3DMODE_DISABLE	= $00000002;
  DS3D_IMMEDIATE	= $00000000;
  DS3D_DEFERRED	= $00000001;
  DS3D_MINDISTANCEFACTOR	= 0.0;
  DS3D_MAXDISTANCEFACTOR	= 10.0;
  DS3D_DEFAULTDISTANCEFACTOR	= 1.0;
  DS3D_MINROLLOFFFACTOR	= 0.0;
  DS3D_MAXROLLOFFFACTOR	= 10.0;
  DS3D_DEFAULTROLLOFFFACTOR	= 1.0;
  DS3D_MINDOPPLERFACTOR	= 0.0;
  DS3D_MAXDOPPLERFACTOR	= 10.0;
  DS3D_DEFAULTDOPPLERFACTOR	= 1.0;
  DS3D_DEFAULTMINDISTANCE	= 1.0;
  DS3D_DEFAULTMAXDISTANCE	= 1000000000.0;
  DS3D_MINCONEANGLE	= 0;
  DS3D_MAXCONEANGLE	= 360;
  DS3D_DEFAULTCONEANGLE	= 360;
  DS3D_DEFAULTCONEOUTSIDEVOLUME	= 0;
  DSBCAPS_PRIMARYBUFFER	= $00000001;
  DSBCAPS_STATIC	= $00000002;
  DSBCAPS_LOCHARDWARE	= $00000004;
  DSBCAPS_LOCSOFTWARE	= $00000008;
  DSBCAPS_CTRL3D	= $00000010;
  DSBCAPS_CTRLFREQUENCY	= $00000020;
  DSBCAPS_CTRLPAN	= $00000040;
  DSBCAPS_CTRLVOLUME	= $00000080;
  DSBCAPS_CTRLPOSITIONNOTIFY	= $00000100;
  DSBCAPS_CTRLDEFAULT	= $000000E0;
  DSBCAPS_CTRLALL	= $000001F0;
  DSBCAPS_STICKYFOCUS	= $00004000;
  DSBCAPS_GLOBALFOCUS	= $00008000;
  DSBCAPS_GETCURRENTPOSITION2	= $00010000;
  DSBCAPS_MUTE3DATMAXDISTANCE	= $00020000;

  DSBCAPS_LOCDEFER            = $00040000;

  DSCBCAPS_WAVEMAPPED	= $80000000;
  DSSPEAKER_HEADPHONE	= $00000001;
  DSSPEAKER_MONO	= $00000002;
  DSSPEAKER_QUAD	= $00000003;
  DSSPEAKER_STEREO	= $00000004;
  DSSPEAKER_SURROUND	= $00000005;
  DSSPEAKER_GEOMETRY_MIN	= $00000005;
  DSSPEAKER_GEOMETRY_NARROW	= $0000000A;
  DSSPEAKER_GEOMETRY_WIDE	= $00000014;
  DSSPEAKER_GEOMETRY_MAX	= $000000B4;
  DSCCAPS_EMULDRIVER	= $00000020;
  DSCBLOCK_ENTIREBUFFER	= $00000001;
  DSCBSTATUS_CAPTURING	= $00000001;
  DSCBSTATUS_LOOPING	= $00000002;
  DSCBSTART_LOOPING	= $00000001;
  DSBFREQUENCY_MIN	= 100;
  DSBFREQUENCY_MAX	= 100000;
  DSBFREQUENCY_ORIGINAL	= 0;
  DSBPAN_LEFT	= -10000;
  DSBPAN_CENTER	= 0;
  DSBPAN_RIGHT	= 10000;
  DSBVOLUME_MIN	= -10000;
  DSBVOLUME_MAX	= 0;
  DSBSIZE_MIN	= 4;
  DSBSIZE_MAX	= $0FFFFFFF;
  DSBPN_OFFSETSTOP	= $FFFFFFFF;

type
  LPDSENUMCALLBACK = function ( lpGuid: PGUID ; lpstrDescription: LPSTR ;
      lpstrModule: LPSTR ; lpContext: Pointer ): BOOL ; stdcall ;

  function DirectSoundCreate(Para1: PGUID; var Para2: LPDIRECTSOUND; Para3: Pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundCreate';
  function DirectSoundEnumerateW(Para1: LPDSENUMCALLBACK; Para2: Pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundEnumerateW';
  function DirectSoundEnumerateA(Para1: LPDSENUMCALLBACK; Para2: Pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundEnumerateA';

  function DirectSoundCaptureCreate(Para1: PGUID; var Para2: LPDIRECTSOUNDCAPTURE;
	 Para3: pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundCaptureCreate';
  function DirectSoundCaptureEnumerateW(Para1: LPDSENUMCALLBACK; Para2: Pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundCaptureEnumerateW';
  function DirectSoundCaptureEnumerateA(Para1: LPDSENUMCALLBACK; Para2: Pointer): HRESULT; stdcall;
	 external 'dsound.dll' name 'DirectSoundCaptureEnumerateA';

implementation

end.
